
/**********************************************************************/
/***   Program:  Hardcore Mod Control Panel                         ***/
/***   By: Beancounter                                              ***/
/***   Version: v1.00                                               ***/
/**********************************************************************/
/***   Description:  This include file lets you customize the       ***/
/***   various bonuses the NPCs get from the Hardcore Mod.  The     ***/
/***   bonuses are calculated using the formula:                    ***/
/***   PC Level * BC_Base_Modifier * Tweak Setting                  ***/
/***   Boss characters us the HC_Boss_Modifier                      ***/
/***                                                                ***/
/***   Setting any of the values to 0 will disable that bonus.  If  ***/
/***   the variable begins 'float' then you need to set it to 0.0   ***/
/***   to disable.                                                  ***/
/***                                                                ***/
/***   IMPORTANT NOTE:  You must recompile this MOD for your        ***/
/***   changes to take effect.  See this thread in Holowan Labs for ***/
/***   detailed instructions on compiling scripts                   ***/
/***                                                                ***/
/***   http://www.lucasforums.com/showthread.php?s=&threadid=143681 ***/
/***                                                                ***/
/***   The following files MUST be in the same directory as         ***/
/***   NWNNSSCOMP to compile correctly:                             ***/
/***   HC_Control.nss                                               ***/
/***   Hardcore_Mod.nss                                             ***/
/***   k_inc_debug.nss                                              ***/
/***   k_inc_generic.nss                                            ***/
/***   k_inc_switch.nss                                             ***/
/***   k_inc_utility.nss                                            ***/
/***   k_inc_gensupport.nss                                         ***/
/***   k_inc_walkways.nss                                           ***/
/***   k_inc_drop.nss                                               ***/
/***   nwscript.nss                                                 ***/
/***                                                                ***/
/***   The ONLY file from this MOD that should be in the override   ***/
/***   directory is k_ai_master                                     ***/
/**********************************************************************/



float HC_Base_Modifier     = 30.00;  //  Base Modifier for Non Boss NPC
float HC_Boss_Modifier     = 30.00;  //  Base Modifier for Boss NPC



float HC_HP_Tweak          = 3.00;  //  Modifier for Vitality Points
float HC_Save_Tweak        = 0.00;  //  Modifier for Save Bonus
float HC_THAC0_Tweak       = 3.00;  //  Modifier for THAC0 Bonus
float HC_Def_Tweak         = 0.25;  //  Default is no defense bonus
float HC_Dmg_Tweak         = 3.00;  //  Default is no extra damage
float HC_FP_Tweak          = 3.00;  //  Modifier for Force Points

int HC_Resist_Chance       = 25;    //  Chance that an NPC will get Immunity to Stun/Paralysis/Fear


float HC_Ability_Tweak     = 0.00;  //  Modifier for Ability Bonus


int   HC_Extra_Attack1     = 25;     //  Sets the level NPC's will get an Extra Attack - Setting to 0 turns it off
int   HC_Extra_Attack2     = 35;     //  Sets the level NPC's will get an Extra two Attacks - Setting to 0 turns it off

// Beta Functions
int   HC_Extra_Feat        = 1;     //  This is BETA Only!  Set to 1 at your own risk.  If a creature animation does not
				    //  support a bonus feat they will not attack properly! jd modified,removed combat move feats and added custom feats
int   HC_AI_Tweak          = 1;     //  This is also BETA!  It is safer then HC_Extra Feat, but I am leaving it turned off.  
				    //  Valid Entries are 0 and 1.  0 Turns the AI changes off and 1 Turns it on.
                                    //  The change switchs NPC from using the Default AI
                                    //  To the Boss AI.  The Boss AI is a LOT more aggressive
                                    //  and will freely use Grenades, Feats and Special Abilities.
                                    //  If you turn on HC_Extra_Feat make sure you set this to one.

int Assign_High_Level_Force_Powers = 1; //set to 0 to disable,when enabled(set to 1) all jedi monsters will be given a random high level force power

