
/*****************************************************/
/***   Program:  Hardcore Mod Main Program         ***/
/***   By: Beancounter                             ***/
/***   Version: v1.00                              ***/
/*****************************************************/
/***   Description:  This include file is the      ***/
/***   main block for the Hardcode Mod             ***/
/***
/***   See Hardcore_Control.nss for how to Tweak   ***/
/***   the Buffs a NPC gets.                       ***/
/*****************************************************/

#include "HC_Control-Custom"

int GetIsValueBetween(int iValue,int iLow,int iHigh)
{
  if(iValue >= iLow && iValue <= iHigh)
  {
    return(TRUE);
  }
  else
  {
    return(FALSE);
  }
}

int Sp_IsJedi( object oTarget ) {

    if( ( GetLevelByClass( CLASS_TYPE_JEDICONSULAR, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_JEDIGUARDIAN, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_JEDIMASTER, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_JEDISENTINEL, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_JEDIWATCHMAN, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_JEDIWEAPONMASTER, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_SITHASSASSIN, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_SITHLORD, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_SITHMARAUDER, oTarget ) > 0 ) ) {
        return TRUE;
    }
    return FALSE;
}

// Function Prototypes
int IsCreature();
void Hardcore_Mod();


void Hardcore_Mod()
{

     float HC_Modifier;
     
     int hp_very_high = 12;
     int hp_high = 10;
     int hp_med  = 8;
     int hp_low  = 6;
     
     float THAC0_high = 1.00;
     float THAC0_med  = 0.75;
     float THAC0_low  = 0.50;
          
     int fp_high = 10;
     int fp_med  = 8;
     int fp_low  = 6;
     int fp_very_low = 4;
     int fp_none = 0;
     
     float save_high = 1.0;
     float save_med = 0.375;
     float save_low = 0.25;
     

     float def_high = 1.00;
     float def_med  = 0.75;
     float def_low  = 0.50;

     float dmg_high = 1.00;
     float dmg_med  = 0.75;
     float dmg_low  = 0.50;
     
     int hp_modifier;
     int fp_modifier;
     float THAC0_modifier;
     
     float fort_modifier;
     float reflect_modifier;
     float will_modifier;
     
     float dmg_modifier;
     float def_modifier;
     
     
     int ability_to_increase1;
     int ability_to_increase2;
     int ability_to_increase3;
     
     int ability_increase_amount1;
     int ability_increase_amount2;
     int ability_increase_amount3;
     

       
     int HC_hp_Buff;
     int HC_THAC0_Buff;
     int HC_fp_Buff;
     
     int HC_fort_Buff;
     int HC_reflect_Buff;
     int HC_will_Buff;
     
     int HC_Def_Buff;
     int HC_Dmg_Buff;
     

     
     int nClass = GetClassByPosition(1, OBJECT_SELF);

     int NPC_AI = GetNPCAIStyle(OBJECT_SELF);
     
     //  Determine if the creature is marked as a Boss
     if(GN_GetSpawnInCondition(SW_FLAG_BOSS_AI) || NPC_AI == NPC_AISTYLE_TURTLE)
     {
          HC_Modifier          = HC_Boss_Modifier;
     }
     
     else
     {
         HC_Modifier          = HC_Base_Modifier;
     }


     int PC_Level          = GetHitDice(GetFirstPC());
     int MonsterLevel      = GetHitDice(OBJECT_SELF);
          
         
     int Adj_Needed        = FloatToInt(PC_Level * HC_Modifier);
     int Adj_Monster_Level = MonsterLevel + Adj_Needed;


     
     switch (nClass)
     {
          case CLASS_TYPE_SOLDIER:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;

               def_modifier     = def_high;
               dmg_modifier     = dmg_high;
               
     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }
     
          case CLASS_TYPE_SCOUT:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_SCOUNDREL:
     	  {
     	       hp_modifier      = hp_low;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;

               def_modifier     = def_high;
               dmg_modifier     = dmg_high;
     	       
     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_JEDIGUARDIAN:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_very_low;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_JEDICONSULAR:
     	  {
     	       hp_modifier      = hp_low;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_med;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_JEDISENTINEL:
     	  {
     	       hp_modifier      = hp_med;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_low;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_COMBATDROID:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_EXPERTDROID:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_MINION:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }


          case CLASS_TYPE_TECHSPECIALIST:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }
     
          case CLASS_TYPE_JEDIWEAPONMASTER:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_low;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

          case CLASS_TYPE_JEDIMASTER:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_high;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

          case CLASS_TYPE_JEDIWATCHMAN:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_med;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

          case CLASS_TYPE_SITHMARAUDER:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_low;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

          case CLASS_TYPE_SITHLORD:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_high;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

          case CLASS_TYPE_SITHASSASSIN:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_med;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

     }
     


     

     int constitution_bonus = GetAbilityModifier(ABILITY_CONSTITUTION, OBJECT_SELF);
     int will_bonus = GetAbilityModifier(ABILITY_WISDOM, OBJECT_SELF);
     int charisma_bonus = GetAbilityModifier(ABILITY_CHARISMA, OBJECT_SELF);


    
     HC_hp_Buff      = (hp_modifier + constitution_bonus) * Adj_Needed;
     HC_fp_Buff      = (fp_modifier + will_bonus + charisma_bonus) * Adj_Needed;
     HC_THAC0_Buff   = FloatToInt(Adj_Monster_Level * THAC0_modifier) - FloatToInt(MonsterLevel * THAC0_modifier); 

     HC_fort_Buff    = FloatToInt(Adj_Monster_Level * fort_modifier) - FloatToInt(MonsterLevel * fort_modifier);
     HC_reflect_Buff = FloatToInt(Adj_Monster_Level * reflect_modifier) - FloatToInt(MonsterLevel * reflect_modifier);
     HC_will_Buff    = FloatToInt(Adj_Monster_Level * will_modifier) - FloatToInt(MonsterLevel * will_modifier);
     
     HC_Def_Buff     = FloatToInt(def_modifier * Adj_Needed);
     HC_Dmg_Buff     = FloatToInt(dmg_modifier * Adj_Needed);


     /* Adj Setting for the Tweaks from Hardcore_Control.nss */
     HC_hp_Buff      = FloatToInt(HC_hp_Buff * HC_HP_Tweak);
     HC_fp_Buff      = FloatToInt(HC_fp_Buff * HC_FP_Tweak);
     HC_THAC0_Buff   = FloatToInt(HC_THAC0_Buff * HC_THAC0_Tweak);
     HC_fort_Buff    = FloatToInt(HC_fort_Buff * HC_Save_Tweak);
     HC_reflect_Buff = FloatToInt(HC_reflect_Buff * HC_Save_Tweak);
     HC_will_Buff    = FloatToInt(HC_will_Buff * HC_Save_Tweak);
     HC_Def_Buff     = FloatToInt(HC_Def_Buff * HC_Def_Tweak);
     HC_Dmg_Buff     = FloatToInt(HC_Dmg_Buff * HC_Dmg_Tweak);
     
     ability_increase_amount1 = FloatToInt(ability_increase_amount1 * HC_Ability_Tweak);
     ability_increase_amount2 = FloatToInt(ability_increase_amount2 * HC_Ability_Tweak);
     ability_increase_amount3 = FloatToInt(ability_increase_amount3 * HC_Ability_Tweak);


     /***************************/
     /***   APPLY BUFFS       ***/
     /***************************/
     // Adj Attributes     
     if (ability_to_increase1 != 0 && ability_increase_amount1 > 0) 
     {
          if(ability_increase_amount1 > 75){
              ability_increase_amount1 = 75;
          } 
          AdjustCreatureAttributes(OBJECT_SELF,ability_to_increase1 ,ability_increase_amount1);
     }
     
     if (ability_to_increase2 != 0 && ability_increase_amount2 > 0) 
     {
          if(ability_increase_amount2 > 75){
              ability_increase_amount2 = 75;
          } 
          AdjustCreatureAttributes(OBJECT_SELF,ability_to_increase2 ,ability_increase_amount2);
     }

     if (ability_to_increase3 != 0 && ability_increase_amount3 > 0) 
     {
          if(ability_increase_amount3 > 75){
              ability_increase_amount3 = 75;
          } 
          AdjustCreatureAttributes(OBJECT_SELF,ability_to_increase3 ,ability_increase_amount3);
     }

     
     // Adj Vitality
     if(HC_hp_Buff > 0)
     {
          if((GetMaxHitPoints(OBJECT_SELF) + HC_hp_Buff) > 32700){
		   SetMaxHitPoints(OBJECT_SELF, (32700 - GetMaxHitPoints(OBJECT_SELF)));
          }   
	    else { 
          	   SetMaxHitPoints(OBJECT_SELF, GetMaxHitPoints(OBJECT_SELF) + HC_hp_Buff);
	    }
     }
     
     // Adj Force Points
     if(HC_fp_Buff > 0)
     {
          AddBonusForcePoints(OBJECT_SELF, HC_fp_Buff);
     }
     
     
     
     // Adj Saves
     if(HC_fort_Buff > 0)
     {
          if(HC_fort_Buff > 90){
               HC_fort_Buff = 90;
          } 
          ModifyFortitudeSavingThrowBase(OBJECT_SELF, HC_fort_Buff);
     }
     
     if(HC_reflect_Buff > 0)
     {
          if(HC_reflect_Buff > 90){
               HC_reflect_Buff = 90;
          } 
          ModifyReflexSavingThrowBase(OBJECT_SELF, HC_reflect_Buff);
     }
     
     if(HC_will_Buff > 0)
     {
          if(HC_will_Buff > 90){
               HC_will_Buff = 90;
          } 
          ModifyWillSavingThrowBase(OBJECT_SELF, HC_will_Buff);
     }
     
     
     // Adj THAC0
     if(HC_THAC0_Buff > 0)
     {
          if(HC_THAC0_Buff > 150){
               HC_THAC0_Buff = 150;
          }
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectAttackIncrease(HC_THAC0_Buff), OBJECT_SELF);
     }
     
     // Adj AC
     if(HC_Def_Buff > 0)
     {
          if(HC_Def_Buff > 50){
               HC_Def_Buff = 50;
          }
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectACIncrease(HC_Def_Buff), OBJECT_SELF);
     }
     
     // Adj Dmg
     if(HC_Dmg_Buff > 0)
     {
          if(HC_Dmg_Buff > 10){
               HC_Dmg_Buff = 10;
          }
          if(HC_Dmg_Buff < 1){
               HC_Dmg_Buff = 1;
          }
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectDamageIncrease(HC_Dmg_Buff, DAMAGE_TYPE_UNIVERSAL), OBJECT_SELF);
     }
     
     
     // Add Extra Attacks
     if(HC_Extra_Attack2 > 0 && Adj_Monster_Level >= HC_Extra_Attack2)
     {
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectModifyAttacks(2), OBJECT_SELF);
     }
     
     
     else if(HC_Extra_Attack1 > 0 && Adj_Monster_Level >= HC_Extra_Attack1)
     {
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectModifyAttacks(1), OBJECT_SELF);
     }
     
     
     // Adj AI
     if(HC_AI_Tweak != 0 && (NPC_AI == NPC_AISTYLE_DEFAULT_ATTACK || NPC_AI == NPC_AISTYLE_RANGED_ATTACK 
     			     || NPC_AI == NPC_AISTYLE_MELEE_ATTACK || NPC_AI == NPC_AISTYLE_GRENADE_THROWER))
     {
          GN_SetSpawnInCondition(SW_FLAG_BOSS_AI);

     }
     


     //  Assign Bonus Immunity
     int nRandom = Random(100) + 1;
     
     if (nRandom <= HC_Resist_Chance)
     {
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSpellImmunity(IMMUNITY_TYPE_FEAR), OBJECT_SELF);
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSpellImmunity(IMMUNITY_TYPE_PARALYSIS), OBJECT_SELF);
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSpellImmunity(IMMUNITY_TYPE_STUN), OBJECT_SELF);
     }


     /* ADD EXTRA FEATS - THIS IS BETA ONLY, USE AT YOUR OWN RISK!! */
     /* If an Appearance Type Does not support the Combat Feat the creature will not attack correctly */
     
     int CreatureAppearance = GetAppearanceType(OBJECT_SELF);
     
     if (PC_Level <= 6 && IsCreature() == 0 && HC_Extra_Feat != 0)     
     {
          GrantFeat(FEAT_WEAPON_FOCUS_BLASTER, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_FOCUS_BLASTER_RIFLE, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_FOCUS_HEAVY_WEAPONS, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_FOCUS_LIGHTSABER, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_FOCUS_MELEE_WEAPONS, OBJECT_SELF);
          GrantFeat(FEAT_WEAPON_FOCUS_SIMPLE_WEAPONS, OBJECT_SELF);
          GrantFeat(113, OBJECT_SELF); //DUELING
          GrantFeat(FEAT_AMBIDEXTERITY, OBJECT_SELF);

     }


     else if (PC_Level > 6 && PC_Level < 12 && IsCreature() == 0 && HC_Extra_Feat != 0)     
     {
     
          GrantFeat(FEAT_WEAPON_SPECIALIZATION_BLASTER, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_SPECIALIZATION_BLASTER_RIFLE, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_SPECIALIZATION_HEAVY_WEAPONS, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_SPECIALIZATION_LIGHTSABER, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_SPECIALIZATION_MELEE_WEAPONS, OBJECT_SELF);
          GrantFeat(FEAT_WEAPON_SPECIALIZATION_SIMPLE_WEAPONS, OBJECT_SELF);
          GrantFeat(114, OBJECT_SELF); //ADVANCED DUELING
          GrantFeat(FEAT_DOUBLE_WEAPON_FIGHTING, OBJECT_SELF);

     }

     else if (PC_Level >= 12 && IsCreature() == 0 && HC_Extra_Feat != 0)     
     {
     
          GrantFeat(FEAT_WEAPON_SPECIALIZATION_BLASTER, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_SPECIALIZATION_BLASTER_RIFLE, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_SPECIALIZATION_HEAVY_WEAPONS, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_SPECIALIZATION_LIGHTSABER, OBJECT_SELF);
	    GrantFeat(FEAT_WEAPON_SPECIALIZATION_MELEE_WEAPONS, OBJECT_SELF);
          GrantFeat(FEAT_WEAPON_SPECIALIZATION_SIMPLE_WEAPONS, OBJECT_SELF);
          GrantFeat(115, OBJECT_SELF); //MASTER DUELING
          GrantFeat(FEAT_AMBIDEXTERITY, OBJECT_SELF);
          GrantFeat(FEAT_ADVANCED_DOUBLE_WEAPON_FIGHTING, OBJECT_SELF);

     }
   
     if(GetIsValueBetween(PC_Level,1,3) && HC_Extra_Feat != 0)
     {
          int nValue = 0;
          if( GetSkillRank(SKILL_DEMOLITIONS) > 0 ) {
             nValue = GetSkillRank(SKILL_DEMOLITIONS);
          }
          GrantFeat(JD_DEMO_ONE, OBJECT_SELF);
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSkillDecrease(SKILL_DEMOLITIONS, nValue), OBJECT_SELF); 
     }
     else if(GetIsValueBetween(PC_Level,4,6) && HC_Extra_Feat != 0)
     {
          int nValue = 0;
          if( GetSkillRank(SKILL_DEMOLITIONS) > 0 ) {
             nValue = GetSkillRank(SKILL_DEMOLITIONS);
          }
          GrantFeat(JD_DEMO_TWO, OBJECT_SELF);
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSkillDecrease(SKILL_DEMOLITIONS, nValue), OBJECT_SELF); 
     }
     else if(GetIsValueBetween(PC_Level,7,9) && HC_Extra_Feat != 0)
     {
          int nValue = 0;
          if( GetSkillRank(SKILL_DEMOLITIONS) > 0 ) {
             nValue = GetSkillRank(SKILL_DEMOLITIONS);
          }
          GrantFeat(JD_DEMO_THREE, OBJECT_SELF);
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSkillDecrease(SKILL_DEMOLITIONS, nValue), OBJECT_SELF); 
     }            
     else if(GetIsValueBetween(PC_Level,10,12) && HC_Extra_Feat != 0)
     {
          int nValue = 0;
          if( GetSkillRank(SKILL_DEMOLITIONS) > 0 ) {
             nValue = GetSkillRank(SKILL_DEMOLITIONS);
          }
          GrantFeat(JD_DEMO_FOUR, OBJECT_SELF);
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSkillDecrease(SKILL_DEMOLITIONS, nValue), OBJECT_SELF); 
     } 
     else if(GetIsValueBetween(PC_Level,13,15) && HC_Extra_Feat != 0)
     {
          int nValue = 0;
          if( GetSkillRank(SKILL_DEMOLITIONS) > 0 ) {
             nValue = GetSkillRank(SKILL_DEMOLITIONS);
          }
          GrantFeat(JD_DEMO_FIVE, OBJECT_SELF);
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSkillDecrease(SKILL_DEMOLITIONS, nValue), OBJECT_SELF); 
     }  
     else if((PC_Level >= 16) && HC_Extra_Feat != 0)
     {
          int nValue = 0;
          if( GetSkillRank(SKILL_DEMOLITIONS) > 0 ) {
             nValue = GetSkillRank(SKILL_DEMOLITIONS);
          }
          GrantFeat(JD_DEMO_SIX, OBJECT_SELF);
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSkillDecrease(SKILL_DEMOLITIONS, nValue), OBJECT_SELF); 
     }  
     
     if( Sp_IsJedi(OBJECT_SELF) && (Assign_High_Level_Force_Powers != 0) )
     {
          if(GetIsValueBetween(PC_Level,7,13)) 
          {
	         switch (Random(21) + 1)
               {
		
			  case 1: 
			       GrantSpell( JD_PULL, OBJECT_SELF );
                    break;
				
			  case 2: 
			       GrantSpell( JD_CHAIN, OBJECT_SELF );
                    break;
				
			  case 3: 
			       GrantSpell( JD_HURRICANE, OBJECT_SELF );
                    break;
				
			  case 4: 	
			       GrantSpell( JD_STRIKE, OBJECT_SELF );
                    break;
				
			  case 5: 
			       GrantSpell( JD_WEAKEN, OBJECT_SELF );
                    break;
			
			  case 6: 
			       GrantSpell( JD_SAPWILL, OBJECT_SELF );
                    break;
				
			  case 7: 
			       GrantSpell( JD_HOLD, OBJECT_SELF );
                    break;

			  case 8: 
			       GrantSpell( JD_FREEZE, OBJECT_SELF );
                    break;
				
			  case 9: 	
			       GrantSpell( JD_OMNI, OBJECT_SELF );
                    break;

			  case 10: 
			       GrantSpell( JD_GRIP, OBJECT_SELF );
                    break;
				
			  case 11: 	
			       GrantSpell( JD_PROTECT, OBJECT_SELF );
                    break;

			  case 12: 	
			       GrantSpell( JD_REGEN, OBJECT_SELF );
                    break;

			  case 13: 
			       GrantSpell( JD_INFERNO, OBJECT_SELF );
                    break;

			  case 14: 
			       GrantSpell( JD_DESTRUCT, OBJECT_SELF );
                    break;
			
			  case 15: 
			       GrantSpell( JD_BOMBARD, OBJECT_SELF );
                    break;

			  case 16: 
			       GrantSpell( JD_CONTAGION, OBJECT_SELF );
                    break;

			  case 17: 
			       GrantSpell( JD_STATIC, OBJECT_SELF );
                    break;

			  case 18: 
			       GrantSpell( JD_ENERGY, OBJECT_SELF );
                    break;

			  case 19: 
			       GrantSpell( JD_LEECH, OBJECT_SELF );
                    break;

			  case 20: 
			       GrantSpell( JD_BLIND, OBJECT_SELF );
                    break;

			  case 21: 
			       GrantSpell( JD_BLIND, OBJECT_SELF );
                    break;
                }
          }
          else if(GetIsValueBetween(PC_Level,14,20)) 
          {
	         switch (Random(21) + 1)
               {
		
			  case 1: 
			       GrantSpell( JD_IMPROVED_PULL, OBJECT_SELF );
                    break;
				
			  case 2: 
			       GrantSpell( JD_CHAIN_IMP, OBJECT_SELF );
                    break;
				
			  case 3: 
			       GrantSpell( JD_HURRICANE_IMP, OBJECT_SELF );
                    break;
				
			  case 4: 	
			       GrantSpell( JD_STRIKE_IMP, OBJECT_SELF );
                    break;
				
			  case 5: 
			       GrantSpell( JD_WEAKEN_IMP, OBJECT_SELF );
                    break;
			
			  case 6: 
			       GrantSpell( JD_SAPWILL_IMP, OBJECT_SELF );
                    break;
				
			  case 7: 
			       GrantSpell( JD_HOLD_IMP, OBJECT_SELF );
                    break;

			  case 8: 
			       GrantSpell( JD_FREEZE_IMP, OBJECT_SELF );
                    break;
				
			  case 9: 	
			       GrantSpell( JD_OMNI_IMP, OBJECT_SELF );
                    break;

			  case 10: 
			       GrantSpell( JD_GRIP_IMP, OBJECT_SELF );
                    break;
				
			  case 11: 	
			       GrantSpell( JD_PROTECT_IMP, OBJECT_SELF );
                    break;

			  case 12: 	
			       GrantSpell( JD_REGEN_IMP, OBJECT_SELF );
                    break;

			  case 13: 
			       GrantSpell( JD_INFERNO_IMP, OBJECT_SELF );
                    break;

			  case 14: 
			       GrantSpell( JD_DESTRUCT_IMP, OBJECT_SELF );
                    break;
			
			  case 15: 
			       GrantSpell( JD_BOMBARD_IMP, OBJECT_SELF );
                    break;

			  case 16: 
			       GrantSpell( JD_CONTAGION_IMP, OBJECT_SELF );
                    break;

			  case 17: 
			       GrantSpell( JD_STATIC_IMP, OBJECT_SELF );
                    break;

			  case 18: 
			       GrantSpell( JD_ENERGY_IMP, OBJECT_SELF );
                    break;

			  case 19: 
			       GrantSpell( JD_LEECH_IMP, OBJECT_SELF );
                    break;

			  case 20: 
			       GrantSpell( JD_BLIND_IMP, OBJECT_SELF );
                    break;

			  case 21: 
			       GrantSpell( JD_BLIND_IMP, OBJECT_SELF );
                    break;
                }
          }
          else if(PC_Level >= 21) 
          {
	         switch (Random(21) + 1)
               {
			
			  case 1: 
			       GrantSpell( JD_MASTER_PULL, OBJECT_SELF );
                    break;
				
			  case 2: 
			       GrantSpell( JD_CHAIN_MSTR, OBJECT_SELF );
                    break;
				
			  case 3: 
			       GrantSpell( JD_HURRICANE_MSTR, OBJECT_SELF );
                    break;
				
			  case 4: 	
			       GrantSpell( JD_STRIKE_MSTR, OBJECT_SELF );
                    break;
				
			  case 5: 
			       GrantSpell( JD_WEAKEN_MSTR, OBJECT_SELF );
                    break;
			
			  case 6: 
			       GrantSpell( JD_SAPWILL_MSTR, OBJECT_SELF );
                    break;
				
			  case 7: 
			       GrantSpell( JD_HOLD_MSTR, OBJECT_SELF );
                    break;

			  case 8: 
			       GrantSpell( JD_FREEZE_MSTR, OBJECT_SELF );
                    break;
				
			  case 9: 	
			       GrantSpell( JD_OMNI_MSTR, OBJECT_SELF );
                    break;

			  case 10: 
			       GrantSpell( JD_GRIP_MSTR, OBJECT_SELF );
                    break;
				
			  case 11: 	
			       GrantSpell( JD_PROTECT_MSTR, OBJECT_SELF );
                    break;

			  case 12: 	
			       GrantSpell( JD_REGEN_MSTR, OBJECT_SELF );
                    break;

			  case 13: 
			       GrantSpell( JD_INFERNO_MSTR, OBJECT_SELF );
                    break;

			  case 14: 
			       GrantSpell( JD_DESTRUCT_MSTR, OBJECT_SELF );
                    break;
			
			  case 15: 
			       GrantSpell( JD_BOMBARD_MSTR, OBJECT_SELF );
                    break;

			  case 16: 
			       GrantSpell( JD_CONTAGION_MSTR, OBJECT_SELF );
                    break;

			  case 17: 
			       GrantSpell( JD_STATIC_MSTR, OBJECT_SELF );
                    break;

			  case 18: 
			       GrantSpell( JD_ENERGY_MSTR, OBJECT_SELF );
                    break;

			  case 19: 
			       GrantSpell( JD_LEECH_MSTR, OBJECT_SELF );
                    break;

			  case 20: 
			       GrantSpell( JD_BLIND_MSTR, OBJECT_SELF );
                    break;

			  case 21: 
			       GrantSpell( JD_BLIND_MSTR, OBJECT_SELF );
                    break;
                }
          }
     }          
}
     
     
     
int IsCreature()
{
     int MainHandType = GetBaseItemType(GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON, OBJECT_SELF));
     int OffHandType  = GetBaseItemType(GetItemInSlot(INVENTORY_SLOT_LEFTWEAPON, OBJECT_SELF));

     if(MainHandType == BASE_ITEM_CREATURE_ITEM_SLASH 
        || MainHandType == BASE_ITEM_CREATURE_ITEM_PIERCE
     	|| MainHandType == BASE_ITEM_CREATURE_WEAPON_SL_PRC
        || OffHandType == BASE_ITEM_CREATURE_ITEM_SLASH 
        || OffHandType == BASE_ITEM_CREATURE_ITEM_PIERCE
     	|| OffHandType == BASE_ITEM_CREATURE_WEAPON_SL_PRC)
     	{
     	     return 1;
     	}
     	else 
     	{
     	     return 0;
     	}
}

     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     