// ===============================================================
// k_inc_generic - Generic Creature AI include file
// ---------------------------------------------------------------
// v1.5
// Generic Include for KOTOR
// Post Clean Up as of March 3, 2003
//
// ST: And loads of big and small changes and tweaks after that.
// 
// NOTE: Changed non-changing Global variables to Constants
//       instead to reduce the script size and stack use a bit.
//       Remember to use version of nwnnsscomp that supports
//       constants when recompiling!
//
// Created By: Preston Watamaniuk
// Copyright (c) 2002 Bioware Corp.
// ---------------------------------------------------------------
// Last Modified: 2006-07-17 (v2u3)
// ===============================================================


// ===============================================================
// GLOBAL STRUCT (Used for passing some data between functions)
// ---------------------------------------------------------------

struct tLastRound {
    int 	nLastAction;
    int 	nLastActionID;
    int 	nLastTalentCode;
    object 	oLastTarget;
    int 	nTalentSuccessCode;
    int 	nIsLastTargetDebil;
    int 	nLastCombo;
    int 	nLastComboIndex;
    int 	nCurrentCombo;
    int 	nBossSwitchCurrent;
};

struct tLastRound tPR;

// ===============================================================
// CONSTANTS
// ---------------------------------------------------------------

//LOCAL BOOLEANS RANGE FROM 0 to 109
// 30-64 reserved for designer usage.
const int AMBIENT_PRESENCE_DAY_ONLY 		= 1;  // POSSIBLE CUT
const int AMBIENT_PRESENCE_NIGHT_ONLY 		= 2;      // POSSIBLE CUT
const int AMBIENT_PRESENCE_ALWAYS_PRESENT 	= 3;

const int SW_FLAG_EVENT_ON_PERCEPTION 		= 20;
const int SW_FLAG_EVENT_ON_ATTACKED   		= 21;
const int SW_FLAG_EVENT_ON_DAMAGED    		= 22;
const int SW_FLAG_EVENT_ON_FORCE_AFFECTED 	= 23;
const int SW_FLAG_EVENT_ON_DISTURBED 		= 24;
const int SW_FLAG_EVENT_ON_COMBAT_ROUND_END = 25;
const int SW_FLAG_EVENT_ON_DIALOGUE    		= 26;
const int SW_FLAG_EVENT_ON_DEATH       		= 27;
const int SW_FLAG_EVENT_ON_HEARTBEAT   		= 28;
//int SW_FLAG_AMBIENT_ANIMATIONS 		= 29;     // located in k_inc_walkways

// ST: Snipped a novel that was messing up the readability of the list. Summarized above. :)

//int SW_FLAG_AMBIENT_ANIMATIONS_MOBILE 	= 65;   //located in k_inc_walkways
const int SW_FLAG_FAST_BUFF            		= 66;   //POSSIBLE CUT
const int SW_FLAG_ASC_IS_BUSY          		= 67;   //POSSIBLE CUT
const int SW_FLAG_ASC_AGGRESSIVE_MODE  		= 68;   //POSSIBLE CUT
const int SW_FLAG_AMBIENT_DAY_ONLY     		= 69;   //POSSIBLE CUT
const int SW_FLAG_AMBIENT_NIGHT_ONLY   		= 70;   //POSSIBLE CUT
const int SW_FLAG_EVENT_ON_SPELL_CAST_AT 	= 71;
const int SW_FLAG_EVENT_ON_BLOCKED     		= 72;
const int SW_FLAG_ON_DIALOGUE_COMPUTER 		= 73;
const int SW_FLAG_FORMATION_POSITION_0 		= 74;   //POSSIBLE CUT
const int SW_FLAG_FORMATION_POSITION_1 		= 75;   //POSSIBLE CUT
const int SW_FLAG_FORMATION_POSITION_2 		= 76;   //POSSIBLE CUT
const int SW_FLAG_FORMATION_POSITION_3 		= 77;   //POSSIBLE CUT
const int SW_FLAG_FORMATION_POSITION_4 		= 78;   //POSSIBLE CUT
const int SW_FLAG_FORMATION_POSITION_5 		= 79;   //POSSIBLE CUT
const int SW_FLAG_FORMATION_POSITION_6 		= 80;   //POSSIBLE CUT
const int SW_FLAG_FORMATION_POSITION_7 		= 81;   //POSSIBLE CUT
const int SW_FLAG_FORMATION_POSITION_8 		= 82;   //POSSIBLE CUT
const int SW_FLAG_FORMATION_POSITION_9 		= 83;   //POSSIBLE CUT
//const int SW_FLAG_TARGET_FRIEND      		= 84;   // Located in k_inc_gensupport
const int SW_FLAG_COMMONER_BEHAVIOR    		= 85;
const int SW_FLAG_SPECTATOR_STATE      		= 86;
const int SW_FLAG_AI_OFF               		= 87;
const int SW_CANDEROUS_COMBAT_REGEN    		= 88;
const int SW_FLAG_BOSS_AI              		= 89;
const int SW_FLAG_SHIELD_USED          		= 90;
const int SW_FLAG_EVENT_ON_DIALOGUE_END 	= 91;
const int SW_FLAG_RESISTANCES_APPLIED  		= 92;

//JAB-OEI 5/21/04 - Commented out the Following line because of conflicts with SW_FLAG_EVENT_ON_DIALOGUE_END
//const int SW_FLAG_EVENT_DIALOGUE_END   	= 93;   //User defined event

//This flag is set when the creature percieves a hostile for the first time.
//Used to eliminate the delay a creature puts on his perception event when first seeing a hostile.
const int SW_FLAG_STATE_AGITATED       			= 94;
const int SW_FLAG_MALAK_AI_ON          			= 95;
const int SW_FLAG_DYNAMIC_COMBAT_ZONE  			= 96;
const int SW_FLAG_EVENT_ON_DIALOGUE_INTERRUPT 	= 97;
//int SW_FLAG_WAYPOINT_START_AT_NEAREST 		= 98;	//Located in k_inc_walkways

//TALENT ROUTINES
const int GEN_TALENT_SUPRESS_FORCE 			= 1;
const int GEN_TALENT_REMOVE_POISON 			= 2;
const int GEN_TALENT_HEALING       			= 3;
const int GEN_TALENT_BUFF          			= 4;
const int GEN_TALENT_REVITALIZE    			= 5;	//RWT-OEI 09/03/04

// ST: Added this - base radius party members have to stay within while
//     in JediSupport/Grenadier AI style.
const float ST_DEFENSIVE_RADIUS 			= 50.0;


// ===============================================================
// FUNCTION PROTOTYPES
// ---------------------------------------------------------------

//Sets the NPC listening patterns for the purposes of shouts
void GN_SetListeningPatterns();

//Determines what combat actions the character is going to take.
void GN_DetermineCombatRound(object oIntruder = OBJECT_INVALID, int nCaller=0);

// Function used by the On Dialogue script to determine what to do when a NPC gets shout
void GN_RespondToShout(object oShouter, int nShoutIndex, object oIntruder = OBJECT_INVALID);

//Sets the day night patterns for the creature.  Uses the AMBIENCE_ constants.
void GN_SetDayNightPresence(int nPresenceSetting);

//Sets the attack target depending on whether oTarget or oIntruder is Valid
object GN_DetermineAttackTarget(object oIntruder = OBJECT_INVALID);

//Makes the character flee the center of an explosion
void GN_DodgeGrenade(object oIntruder);

//Resets the formation booleans on a character.
void GN_ResetFormationBooleans();

//Checks which position on a character is free.
void GN_MoveToFormation(object oAnchor, int nFormationType);

//Runs the default AI routine
int GN_RunDefaultAIRoutine(object oIntruder = OBJECT_INVALID);

//Runs the Aid AI routine
int GN_RunAidAIRoutine(object oIntruder = OBJECT_INVALID);

//Runs the Grenade Thrower AI
int GN_RunGrenadeAIRoutine(object oIntruder = OBJECT_INVALID);

//Runs the Jedi Support AI routine
int GN_RunJediSupportAIRoutine(object oIntruder = OBJECT_INVALID);

//RWT-OEI 03/18/04 - This AI only heals, never attacks.
int GN_RunHealerAIRoutine( object oIntruder = OBJECT_INVALID );

//RWT-OEI 03/22/04 - This AI moves between shooting.
//  If called outside of combat, they just move around randomly.
int GN_RunSkirmishAIRoutine( object oIntruder = OBJECT_INVALID );

//RWT-OEI 08/28/04 - This function keeps the party NPCs within
//a certain number of meters from the party leader. Returns FALSE
//if they are already within that range, returns TRUE if it is
//currently moving them into range.
int GN_CheckRangeFromLeader(float fDistanceLimit = 10.0f);

//RWT-OEI 09/08/04 - This function keeps party puppets within
//a certain number of meters from their owner. Returns FALSE
//if they are already within that range, returns TRUE if it is
//currently moving them into range.
int GN_CheckRangeFromOwner(float fDistanceLimit = 5.0f );

//RWT-OEI 08/28/04 - This AI tries to use ranged as much as possible,
//switches to melee if being attacked with melee.
int GN_RunRangedSupportAIRoutine( object oIntruder = OBJECT_INVALID );

//RWT-OEI 08/28/04 - Calling this tries to switch us to a ranged
//weapon config if we can and we are not being attacked by
//melee at the moment or in the last X rounds.
int GN_CheckRangedPreferred();

//RWT-OEI 08/28/04 - This AI stands in one place and uses ranged or
//melee when being attacked by melee.
// ST: This routine is not implemented. Why is the prototype still here?
int GN_RunStationaryAIRoutine( object oIntruder = OBJECT_INVALID );

//RWT-OEI 08/28/04 - This returns TRUE if the object has a Jedi class
int GN_IsJedi(object oObject = OBJECT_SELF);

//RWT-OEI 09/08/04 - Runs the default puppet AI for the Remote.
int GN_RunDefaultPuppetAIRoutine(object oIntruder = OBJECT_INVALID );

//Runs the Boss AI Routine
int GN_RunBossAIRoutine(object oIntruder = OBJECT_INVALID);

//Run Boss Grenade AI Routine
int GN_RunBossGrenadeAI(object oIntruder = OBJECT_INVALID);

//Run Boss AOE Force Power Routine
int GN_RunBossAOEPowerRoutine(object oIntruder=OBJECT_INVALID);

//Runs special AI just for Darth Malak on the Star Forge
// ST: Why is this still here? It's area specific!
int GN_RunMalakAIRoutine();

//Run Boss Targeted Routine
int GN_RunBossTargetedRoutine(object oIntruder=OBJECT_INVALID);

// JAB-OEI 7/3/04 - Runs special AI for boss Drexl on Onderon
int GN_RunTurtleAIRoutine(object oIntruder = OBJECT_INVALID);

// DJS-OEI 9/27/2004 - Runs AI for monsters that use Special Abilities
int GN_RunMonsterPowersAIRoutine(object oIntruder = OBJECT_INVALID);

//Sets up struct tLastRound to allow for a single point of determination.
void GN_SetLastRoundData();

//Makes the person or droid activate a shield
int GN_ActivateForceField();

//Makes the person activate Resist Elements and Resist Force.
int GN_ActivateResistances();

//Resets a Droid to his deactivated animation
void GN_ResetDroidDeactivationState(object oDroid = OBJECT_SELF);

//Checks the target and the droid utility use to make sure they are compatible
talent GN_CheckDroidUtilityUsage(object oTarget, talent tUse);

//Checks the target and the force power to make sure that a lightsaber is not thrown from close range.
talent GN_CheckThrowLightSaberUsage(object oTarget, talent tUse);

//Checks the target and the force power to make sure that a non-droid force power is used against a droid
talent GN_CheckNonDroidForcePower(object oTarget, talent tUse);

//Performs a series of checks in case the combat portion of DetermineCombatRound falls through.
int GN_DoPostDCRChecks();

//A void version of do post DCR checks for use with action do command.
void GN_ActionDoPostDCRChecks();

//Determine Combat Round Targeting Funtions
//This function returns an object if OBJECT_SELF is poisoned, or if any party member is poisoned.
object GN_CheckIfPoisoned();

//This function returns an object if OBJECT_SELF is below 50% health, or if any party member is injured.
object GN_CheckIfInjured();

//RWT-OEI 09/03/04 - This returns TRUE if any party member is KO'd.
int GN_CheckIfKnockedOut();

//This checks the last hostile target and determines the best attack action based on the last round.
int GN_GetAttackTalentCode(object oTarget);

//Pass in a talent type and a target to have object_self use the talent
int GN_TalentMasterRoutine(int nTalentConstant, object oTarget);

//Determines where in the current combo the character is and what to do next based on AI style, and combat info.
talent GN_GetComboMove(int nBoss = FALSE);

//Plays an Ambient Animation depending on the spawn in condition selected.
void GN_PlayAmbientAnimation();

// This causes peasants to flee when people
int GN_CommonAI();

//Should Commoners run away.  This returns a yes or no based on a set of conditions
int GN_CheckShouldFlee();

//RWT-OEI 04/07/04 - Sets the heal percentage for the calling object.
void GN_SetHealPercentage( int nHeal );

//RWT-OEI 04/13/04 - Sets the threshold at which the Healer AI will heal
void GN_SetHealThreshold( int nPercentage );

//RWT-OEI 07/16/04 - Set the amount of damage the exploding, floating
//mine will do.
void GN_SetFloatingMineDamage( int nDamage );

//RWT-OEI 07/16/04 - Set the Range that the mine will start seeking
void GN_SetFloatingMineSeekRange( int nRange );

// ST: Added this function: Use special bot weapons if available.
int ST_RunBotAIRoutine(object oIntruder);


// ===============================================================
// FUNCTION IMPLEMENTATION
// ---------------------------------------------------------------


// ---------------------------------------------------------------
// Main combat AI routine. Determines suitable actions to perform
// this combat round and initiates them.
//
// ST: Caller is currently unused due to removing the context
//     sensitive code from the DCR for now. It contains the AI
//     event number of the Event hook that calls the function.
// ---------------------------------------------------------------
void GN_DetermineCombatRound(object oIntruder = OBJECT_INVALID, int nCaller=0) {
	// ST: (2006-02-05) Added MainChar support for the Atton Spirit feats...
	ST_CheckRevivePlayer(); 
		
	// ST: (2005-08-18) Added this, gives bosses HL Force Powers if those are enabled....
	ST_AssignHLPowers(); 
	
    //RWT-OEI 10/19/04 - If this is a party member, and this party member already has
    //combat actions queued up, don't do anything to override those.
    
    //RWT-OEI 10/30/04 - I had to take this out. It was causing your party members to not
    //engage if they were in Ranged Support but had a melee weapon equipped. They'd often just
    //stand there and do nothing.
    
    // ST: Modified to to to prevent them from clearing the action queue if they
    //     have force powers queued. Should hopefully help a bit against them disregarding
    //     of manually assigned orders as soon as the player switch away from controlling them.
    if ( IsObjectPartyMember(OBJECT_SELF) 
    	&& GetCombatActionsPending(OBJECT_SELF)
    	&& (GetNPCAIStyle(OBJECT_SELF) != NPC_AISTYLE_PARTY_RANGED)
    	&& ((GetCurrentAction(OBJECT_SELF) == ACTION_CASTSPELL) || (GetCurrentAction(OBJECT_SELF) == ACTION_ITEMCASTSPELL))) 
    {
        return;
    }
    

    // ST: Don't proceed with combat AI if somehow debilitated. Will hopefully stop stunned
    //     opponents from using force powers and grenades on occasion.
    // EDIT: Removed this until I know for sure just what the game counts as "debilitated",
    //       as they shouldn't stop fighting if they are poisoned or ability drained...
    /*
    if (GetIsDebilitated(OBJECT_SELF))
    	return;	
    */

    // ST: It would be rather pointless to continue if already dead...
    if (GetIsDead(OBJECT_SELF)) 
    	return;	
    
    // ST: If we're a partymember and oIntruder is also a party member, set it to invalid...	
    if (IsObjectPartyMember(OBJECT_SELF) && IsObjectPartyMember(oIntruder))
    	oIntruder = OBJECT_INVALID;


	// ST: Added --------------------------------------------------
	// Partymembers don't run away on their own to fight when using the Jedi Support/Grenadier AI style.
	// Stay within 10m of the party leader.
    if ((GetNPCAIStyle(OBJECT_SELF) == NPC_AISTYLE_PARTY_SUPPORT) 
    	&& !GetSoloMode()
    	&& !GN_GetSpawnInCondition(SW_FLAG_AI_OFF)
    	&& IsObjectPartyMember(OBJECT_SELF)
    	&& (GetPartyMemberByIndex(0) != OBJECT_SELF)) 
    {
    	object oLeader = GetPartyLeader();
    	int nAction = GetCurrentAction();
    	// ST: FIX(2005-06-19) See if it works out to come back when they have no line of
    	//     sight to leader as well, to prevent them from running off in tight indoors
    	//     areas like G0T0s ship.
    	if (!GetObjectSeen(oLeader) ) {
    		if (	(nAction == ACTION_ATTACKOBJECT)
    			|| 	(nAction == ACTION_CASTSPELL)
    			|| 	(nAction == ACTION_QUEUEEMPTY)
    			|| 	(nAction == ACTION_INVALID)
    			|| 	(nAction == ACTION_ITEMCASTSPELL)
    			|| 	(nAction == 39))
	    	{
	    		ClearAllActions();
	    		ActionForceMoveToObject(oLeader, TRUE, 2.0, 15.0);
	    		return;   		
	    	}
	    	else if (nAction == ACTION_MOVETOPOINT) {
	    		// ST: They might already be moving to leader from above orders, let
	    		//     them do so without being interrupted by other AI commands.
	    		// TODO: Should probably add some kind of abort counter here in case
	    		//       they get blocked while moving. DeltaTime, where are you? :/
	    		return;	
	    	}
	    }
    }
	// ------------------------------------------------------------

    GN_SetLastRoundData();
    int nPartyAI = GetPartyAIStyle(); //Determines how the party should react to intruders
    int nNPC_AI = GetNPCAIStyle(OBJECT_SELF); //Determines how the individual should react in combat

    //MODIFIED by Preston Watamaniuk on March 27 - Put GetUserActionsPending back in to 
    // cancel Determine Combat when user actions are present.
    if (!GN_GetSpawnInCondition(SW_FLAG_COMMONER_BEHAVIOR)
    	&& !GN_GetSpawnInCondition(SW_FLAG_SPECTATOR_STATE)
    	&& !GN_GetSpawnInCondition(SW_FLAG_AI_OFF)
    	&& !GetUserActionsPending())
    {
		// ST: (2005-09-17) Added, make force users learn and use a saber/form form as appropriate
		ST_DoSaberFormUsage();   	
    	    		
		if ((GetPartyMemberByIndex(0) != OBJECT_SELF) && !GetPlayerRestrictMode()) {

    		// ST: Removed below check since it serves no purpose. It essentially just checks if
    		//     the creature is a party member or if the creature isn't a partymember, since you
    		//     wouldn't get here if GetPlayerRestrictMode() is true anyway due to above check.
			// if ((IsObjectPartyMember(OBJECT_SELF) && !GetPlayerRestrictMode()) || !IsObjectPartyMember(OBJECT_SELF)) {                
            
            // ST: Brainless Grunt AI - just do standard melee attacks.                 
            if (nNPC_AI == NPC_AISTYLE_MELEE_ATTACK) {
                if (GetIsObjectValid(oIntruder)) {
                    ClearAllActions();
                    ActionAttack(oIntruder);
                    ST_SetLastAttackTarget(oIntruder);
                    return;
                }
                else {
                    object oDefault = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY);
                    if (GetIsObjectValid(oDefault)) {
                        ClearAllActions();
                        ActionAttack(oDefault);
                        ST_SetLastAttackTarget(oDefault);
                        return;
                    }
                }
                return;
            }
            
            //Always try and run a force field at the beginning of combat.
            if(GN_ActivateForceField())
                return;

            //Always try to use Force Resistance at the beginning of combat.
            if(GN_ActivateResistances()) 
            	return;

            //P.W. (June 9) - Malakai put into the generics
            // ST: Why is this still here? Or why is it even in the generic AI? It expects
            //     a set number of combatants and placeables in a predefined area. Not generic at all.
            if(GN_GetSpawnInCondition(SW_FLAG_MALAK_AI_ON) == TRUE) {
                if(GN_RunMalakAIRoutine())
                	return;
            }

            //If the boss flag is set then the creature will run the boss AI first.
            if (GN_GetSpawnInCondition(SW_FLAG_BOSS_AI)) {
                if (GN_RunBossAIRoutine(oIntruder))
                	return;
            }

            //RWT-OEI 03/18/04 - This AI just runs around healing others
            // If this AI is active, they get no other options, so just return after it executes.            
            if ( nNPC_AI == NPC_AISTYLE_HEALER ) {
                GN_RunHealerAIRoutine(oIntruder);
                return;
            }

            //RWT-OEI 03/22/04 - This AI moves randomly between shooting
            //If this AI returns 1, then no other AIs should be
            //executed. If it returns 0, then other attacks are fine.            
            if (nNPC_AI == NPC_AISTYLE_SKIRMISH) {
                if (GN_RunSkirmishAIRoutine(oIntruder))
                    return;
            }

            //RWT-OEI 03/23/04 - If we get here, we may be in skirmish
            //  mode, but not moving. Therefore just attack like normal.
            if ((nNPC_AI == NPC_AISTYLE_DEFAULT_ATTACK) || (nNPC_AI == NPC_AISTYLE_SKIRMISH)) {
                 if (GN_RunDefaultAIRoutine(oIntruder))
                    return;
            }
            else if (nNPC_AI == NPC_AISTYLE_GRENADE_THROWER) {
                 if (GN_RunGrenadeAIRoutine(oIntruder))
                 	return;
            }
            else if (nNPC_AI == NPC_AISTYLE_JEDI_SUPPORT) {
                 if (GN_CheckRangeFromLeader(10.0f))
                    return;

                 if (GN_RunJediSupportAIRoutine(oIntruder))
                 	return;
            }
            //JAB-OEI 7/3/04 
            else if(nNPC_AI == NPC_AISTYLE_TURTLE) { // ST: DREXL STYLE!
                if (GN_RunTurtleAIRoutine(oIntruder))
                	return;
            }
            else if(nNPC_AI == NPC_AISTYLE_PARTY_AGGRO) { // ST: Aggressive Style
                //RWT-OEI 08/28/04 Aggressive just acts like it did in KotOR1.
                if (GN_RunDefaultAIRoutine(oIntruder))
                    return;
            }
            else if(nNPC_AI == NPC_AISTYLE_PARTY_DEFENSE) { // ST: Defensive Style (cut)
                //RWT-OEI 08/28/04 - Defensive acts just like default in KotOR1, except never more than
                //10 meters away from the party leader at any time.
                if (GN_CheckRangeFromLeader(5.0f)) 
                    return;

                GN_RunDefaultAIRoutine(oIntruder);
                return;
            }
            else if(nNPC_AI == NPC_AISTYLE_PARTY_RANGED) { // ST: Ranged Style
                //RWT-OEI 08/28/04 - Ranged Support will stand back and use ranged weapons. If
                //they are attacked by someone with melee they will switch to their alternate
                //weapon config if that config has melee weapons in it. Must stay within
                //10 meters of party leader at any time.
                if (GN_CheckRangeFromLeader(10.0f))
                    return;

                GN_RunRangedSupportAIRoutine(oIntruder);
                return;
            }
            else if (nNPC_AI == NPC_AISTYLE_PARTY_STATIONARY) { // ST: This is pretty unreliable, they sometimes move anyway...
                //RWT-OEI 08/28/04 - Just stand in one place and shoot. Don't move under any circumstances whenever
                //in combat mode. This mode should probably override movement outside of combat as well. That would
                //be handled elsewhere.
                
                GN_RunRangedSupportAIRoutine(oIntruder);
                return;
            }
            else if (nNPC_AI == NPC_AISTYLE_PARTY_SUPPORT) { // ST: GRENADE!!! and Jedi/Droid Support AI, all in one...
                // RWT-OEI 08/28/04 - If is Jedi, then will run default Jedi routine from KotOR1. If not,
                // will run Grenadier routine from KotOR1.
                // ST: Added special Droid AI routine to allow party droids to use mounted weapons.
                if (GN_IsJedi(OBJECT_SELF))
                    GN_RunJediSupportAIRoutine(oIntruder);    
                else if (GetRacialType(OBJECT_SELF) == RACIAL_TYPE_DROID)
                	ST_RunBotAIRoutine(oIntruder);
                else
                	GN_RunGrenadeAIRoutine(oIntruder);

                return;
            }
            else if ( nNPC_AI == NPC_AISTYLE_PARTY_REMOTE ) { // ST: AI for Bao-Dur's annoying sidekick...
                //RWT-OEI 09/08/04 - First priority is to stay in range
                //of owner. If we need to move as a result, don't do anything else.
                if (GN_CheckRangeFromOwner(2.0f))
                    return;

                //Otherwise, call the default puppet AI
                GN_RunDefaultPuppetAIRoutine(oIntruder);
                return;
            }
            else if( nNPC_AI == NPC_AISTYLE_MONSTER_POWERS ) { // ST: Bad Breath, Loud screams etc...
                // DJS-OEI 9/27/2004
                if( GN_RunMonsterPowersAIRoutine(oIntruder))
                    return;
            }

            //Run a default AI no matter what. RWT-OEI 08/20/04
            if (GN_RunDefaultAIRoutine(oIntruder)) 
                return;
        }
    }
    
    GN_DoPostDCRChecks();
}

//::///////////////////////////////////////////////
//:: Do Post Determine Combat Round Checks
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Performs a series of checks in case the combat
    portion of DetermineCombatRound falls through.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: April 25, 2003
//:://////////////////////////////////////////////
int GN_DoPostDCRChecks() {
    if(GN_GetSpawnInCondition(SW_FLAG_COMMONER_BEHAVIOR) && !GN_GetSpawnInCondition(SW_FLAG_SPECTATOR_STATE)) {
        //MODIFIED by Preston Watamaniuk on May 29, 2003
        //Changed the commoner subroutine to make sure it walks ways at the end of battles.
        if (GN_CommonAI())
            return TRUE;
    }
    else if(GN_GetSpawnInCondition(SW_FLAG_SPECTATOR_STATE)) {
        ClearAllActions();
        return TRUE;
    }
    
    //If all combat actions fail, then return to Walkways
    //P.W.(May 22, 2003) - Added check to make sure a waypoint path is set out for the creature. If then do not clear all actions.
    //AWD-OEI 10/27/2004 we need to actually check if walk waypoints is ON
    //MODIFIED by Preston Watamaniuk on May15, 2003
    //Put this delay command in so that bark bubble do not disapear so quickly off conversations.    
    if(!IsObjectPartyMember(OBJECT_SELF) && GN_GetSpawnInCondition(SW_FLAG_WAYPOINT_DEACTIVATE) == TRUE) {
        ClearAllActions();
        DelayCommand(1.0, GN_WalkWayPoints());
        return TRUE;
    }
    else if((GetPartyMemberByIndex(0) != OBJECT_SELF)
    	&& !GetIsObjectValid(GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF,1, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN)) 
    	&& IsObjectPartyMember(OBJECT_SELF))
    {
	  if( JD_CheckSeriesCureForce() && GN_IsJedi(OBJECT_SELF) && (GetCurrentForcePoints() <= ((GetMaxForcePoints() * 20) / 100)) ) {
		talent tTemp = TalentSpell(JD_GetSeriesCureForce());
		ActionUseTalentOnObject(tTemp, OBJECT_SELF);
	  } 
        object oLeader = GetPartyMemberByIndex(0);
        object oLeaderTarget = GetAttackTarget(oLeader);
        if (!GetSoloMode()) {
            //RWT-OEI 09/18/04 - Now your party members will stick it out with
            //helping you bash stuff, if they're not otherwise already occupied.
            //Forget it. Party members won't help with bashing anymore.
            //The targets are too small so it looks lame            
            if ((GetObjectType( oLeaderTarget ) == OBJECT_TYPE_DOOR) 
            	&& !GetIsOpen( oLeaderTarget ) 
            	&& !GetSoloMode())
            {
                ClearAllActions();
                ActionFollowLeader();
            }
            else if ((GetObjectType(oLeaderTarget) == OBJECT_TYPE_PLACEABLE) 
            	&& (GetCurrentHitPoints(oLeaderTarget) > 0) 
            	&& !GetSoloMode())
            {
                //RWT-OEI 10/05/04 - No matter what I do this is going to look lame, taking out party bashing help
                ClearAllActions();
                ActionFollowLeader();
            }
            else {
                CancelCombat(OBJECT_SELF);
                ClearAllActions();
                ActionFollowLeader();
            }
        }
        return TRUE;
    }
    return FALSE;
}

//::///////////////////////////////////////////////
//:: GN_ActionDoPostDCRChecks
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    A form of the DCR checks that can be run as
    an actions.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: May 29, 2003
//:://////////////////////////////////////////////
void GN_ActionDoPostDCRChecks()
{
    int nx = GN_DoPostDCRChecks();
}


//:://////////////////////////////////////////////
//:: Run Default AI
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Runs the default AI for an NPC. Returns FALSE
    if they cannot do anything.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Oct 9, 2002
//:://////////////////////////////////////////////
int GN_RunDefaultAIRoutine(object oIntruder) {
    object 	oTarget;
    object 	oClose;
    int 	nTalentCode;
    talent 	tUse;
    int 	nMoving;

    oTarget = GN_CheckIfPoisoned();
    if(GetIsObjectValid(oTarget)) {
        if(GN_TalentMasterRoutine(GEN_TALENT_REMOVE_POISON, oTarget))
        	return TRUE;
    }
    
    // ST: Randomize heal frequency a bit... only do it 66% of the time.
    //     TODO: Modify frequency by how injured they are...
    if (d3() > 1) {
	    oTarget = GN_CheckIfInjured();
	    if(GetIsObjectValid(oTarget)) {
	        if (GN_TalentMasterRoutine(GEN_TALENT_HEALING, oTarget))
	        	return TRUE;
	    }
	}
    
    // ST: Added... 25% chance of using buffs if Jedi and on Aggressive AI.
    //     Added Default Attack AI style as well to allow non-party NPCs to do it.
    // ST: CHANGED(2005-09-21) Let non-force users buff too if they have any stims.
    if((   (GetNPCAIStyle(OBJECT_SELF) == NPC_AISTYLE_PARTY_AGGRO) 
    	|| (GetNPCAIStyle(OBJECT_SELF) == NPC_AISTYLE_DEFAULT_ATTACK)
    	|| (GetNPCAIStyle(OBJECT_SELF) == NPC_AISTYLE_RANGED_ATTACK)
    	|| (GetNPCAIStyle(OBJECT_SELF) == NPC_AISTYLE_GRENADE_THROWER))
    //	&& GN_IsJedi(OBJECT_SELF) 
    	)
    {   
	    if(GN_TalentMasterRoutine(GEN_TALENT_BUFF, OBJECT_SELF))
	        return TRUE;
    } 
    
    // ST: Added... If having Ewok Rage and not already enraged, use it...
    if (d4() > 1) {
		if (ST_TalentUseRage())
			return TRUE;
	}
		
	// ----------------------------------------------------------------
	
    tUse = GN_GetComboMove();

    int nFriend = GetLocalBoolean(OBJECT_SELF, SW_FLAG_TARGET_FRIEND);
    if(nFriend == TRUE) {
        if(GetNPCAIStyle(OBJECT_SELF) == NPC_AISTYLE_JEDI_SUPPORT)
            oTarget = GetPartyMemberByIndex(0);
        else
            oTarget = OBJECT_SELF;
    }
    else {
    	// ST: Using alternate targeting routine...
    	oTarget = ST_SelectAttackTarget(oIntruder);
    	oClose = oTarget;
        // oTarget = tPR.oLastTarget;
        
        // ST: This AI style can't be selected for party members... cut?
        if ( GetNPCAIStyle(OBJECT_SELF) == NPC_AISTYLE_PARTY_DEFENSE ) {
            //RWT-OEI 10/04/04 - In Defensive AI mode, we chose our targets
            //differently than other modes
            //First we need to know if we have range or melee equipped.
            object oLeader = GetPartyLeader();
            int nWeaponType = 0;
            object oWeap = GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON );
            if ( GetIsObjectValid(oWeap) )
            {
                nWeaponType = GN_GetWeaponTypeFromBaseItem(GetBaseItemType(oWeap));
            }

            //If we have RANGED (2), then we only target whoever the player is
            //attacking currently
            if (nWeaponType == 2) {   
            	if (GetIsInCombat(oLeader, TRUE)) {
                    oClose = GetAttackTarget(oLeader);
                }
                else {
                    //If the leader isn't fighting, then either do we
                    oClose = OBJECT_INVALID;
                }
            }
            else
            {
                //If we have melee equipped, we only attack creatures that are within 5.0 meters of the player character
                oClose = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, oLeader,1, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);

                //So just get the nearest creature and check that they're within 5 meters of the
                //current leader. Clear oClose as a non-target then
                if (GetIsObjectValid(oClose) && GetDistanceToObject(oClose) > 5.0f) {
                    oClose = OBJECT_INVALID;
                    oIntruder = OBJECT_INVALID;
                }
            }
        }
        else {
            //RWT-OEI 11/01/04 - Trying to make the bosses more aggressive
            // ST: Commented out conditional check...
            //if ( GetNPCAIStyle(OBJECT_SELF) != SW_FLAG_BOSS_AI )
            // {
            oClose = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF,1, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
            //}
            // ST: Commented this out, using alternative targeting routine instead...
            /*            
            else
            {
                oClose = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF,1);
                // ST: DON'T! Stay on task, unless the target is no longer valid...
                if (!GetIsObjectValid(oTarget) || !GetIsEnemy(oTarget) || GetIsDead(oTarget)) 
                	oTarget = oClose;
            }
            */
        }

        //MODIFIED by Preston Watamaniuk on June 3, 2003
        //I put this check in to make sure the party members only attack what you want until that things dies or leaves.
        if(IsObjectPartyMember(OBJECT_SELF) 
        	&& GetIsObjectValid(oTarget) 
        	&& !GetIsDead(oTarget) 
        	&& GetObjectSeen(oTarget))
        {
            oTarget = oTarget; //Just put this here to show that the target is being used.
        }
        //MODIFIED by Preston Watamaniuk on May 15, 2003
        //Made it so the intruder object is always used if they can be seen and are valid.
        // ST: Stay on task... Don't switch targets every DCR! a 10 near death enemies can
        //     hurt you just as much as 10 uninjured ones. Only use oClose if last target
        //     was not valid, or only 50% use oIntruder if valid...        
        // ST: Removed this part, using custom target selection above instead...
        //     ST_SelectAttackTarget() already uses oIntruder if relevant, and oClose
        //     won't contain anything that the function hasn't already evaluated anyway.
        /* // ST: <COMMENTED OUT>
        else if((!GetIsObjectValid(oTarget) || (Random(4) > 1)) && GetIsObjectValid(oIntruder) && GetObjectSeen(oIntruder) )
        {
            // GN_MyPrintString("GENERIC DEBUG *************** Intruder becomes Target");
            oTarget = oIntruder;
        }
        else if(GetIsObjectValid(oClose) && GetObjectSeen(oClose))
        {
            if((!GetIsObjectValid(oTarget) ||
               !GetIsEnemy(oTarget) ||
               GetIsDead(oTarget) ||
               GetCurrentHitPoints(oTarget) < GetCurrentHitPoints(oClose)))
               {
                  // GN_MyPrintString("GENERIC DEBUG *************** Closest becomes Target");
                  oTarget = oClose;
               }
        } 
        */ // ST: </COMMENTED OUT>
        // ST: Moved checks down here since the above cases were removed.
        else if ((GetRacialType(OBJECT_SELF) == RACIAL_TYPE_DROID) 
        	&& (!GetIsObjectValid(oTarget) || !GetObjectSeen(oTarget))
        	&& !IsObjectPartyMember(OBJECT_SELF)) 
        {
            //RWT-OEI 04/07/04 - I added this support to make it so that
            //  ranged-only users will try to chase down the characters.
            //  But the problem is that the HasLineOfSight function is
            //  returning vectors that don't actually give line of
            //  sight -sometimes-. It works about 60%, but the percentage
            //  goes down the further the player is from the attacker.
            //  I would like to fix this up in the future if I have time
            //  to get back to it.

            //First we need to determine a valid target to go after.
            //oClose is not valid. Probably out of sight. Now find
            //an oClose without the line of sight check.
            if (!GetIsObjectValid(oClose)) 
                oClose = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF, 1);

            //See if that nearest target is stealthed, if so, don't keep looking for them
            if ( GetIsObjectValid(oClose) && IsStealthed(oClose))
                    oClose = OBJECT_INVALID; 

            //Do we have a valid target now?
            if ( GetIsObjectValid( oClose ) ) {
                float  fDistance  = GetDistanceToObject2D( oClose );
                string sDistance  = FloatToString( fDistance );
                vector vTargetPos = GetPosition( oClose );
                int    nLocal     = GetLocalNumber( OBJECT_SELF, 9 );
                string sLocal     = IntToString( nLocal );
                
                if ((GetLocalNumber( OBJECT_SELF, 9) > 2)) {
                    int      nActionID = GetCurrentAction( OBJECT_SELF ) ;
                    location newLoc    = Location( vTargetPos, GetFacing(OBJECT_SELF));
                    
                    ActionMoveToLocation(newLoc, TRUE);
                    oClose  = OBJECT_INVALID;
                    oTarget = OBJECT_INVALID;
                } 
                else {
                    vector vNewPos = GetRandomDestination( OBJECT_SELF, 10 );
                    int nCount = 0;
                    //float fDistanceToTarget = GetDistanceToObject2D(oClose);

                    while ( nCount < 20 ) {
                        if ( HasLineOfSight( vNewPos, vTargetPos ) ) {
                            //New position has line of sight.
                            // ST: Well... they would if HasLineOfSight() wasn't terribly broken...
                            break;
                        }
                        //If we didn't have line of sight at that last point, try another one
                        vNewPos = GetRandomDestination( OBJECT_SELF, 20 );
                        ++nCount;
                    }

                    //If nCount is < 20, we found a good place to move to. So move.
                    if ( nCount < 20 ) {
                        string sCount = IntToString( nCount );
                        int nActionID = GetCurrentAction(OBJECT_SELF);
                        if ( nActionID != ACTION_MOVETOPOINT ) {
                            location newLoc = Location( vNewPos, GetFacing(OBJECT_SELF));
                            ActionMoveToLocation( newLoc, TRUE );
                            SetLocalNumber(OBJECT_SELF, 9, GetLocalNumber(OBJECT_SELF, 9) + 1);
                        }
                    }
                    //Clear objects since we have nothing to attack
                    oClose = OBJECT_INVALID;
                    oTarget = OBJECT_INVALID;
                }
            }

        }

    }

    // RWT-OEI 10/31/04 - If our target is more than 30 meters away, drop out of combat all together
    float fDistance = GetDistanceToObject(oTarget);
    if ( (fDistance > 30.0f) 
    	&& (GetNPCAIStyle(OBJECT_SELF) != SW_FLAG_BOSS_AI)
    	&& !IsObjectPartyMember(OBJECT_SELF))
    {
        oTarget = OBJECT_INVALID;
        CancelCombat(OBJECT_SELF);
    }

    // If we have a valid target, reset the number of times we've looked for a better firing position.
    if (GetIsObjectValid(oTarget))
        SetLocalNumber( OBJECT_SELF, 9, 0 );

    //MODIFIED by Preston Watamaniuk on April 22, 2003
    //Put this check in to allow Droids to use their special abilities in a more logical manner. Passes in the talent and the target
    //and double checks that the usage is logical.
    if(GetRacialType(OBJECT_SELF) == RACIAL_TYPE_DROID)
        tUse = GN_CheckDroidUtilityUsage(oTarget, tUse);
        
    tUse = GN_CheckThrowLightSaberUsage(oTarget, tUse);
    tUse = GN_CheckNonDroidForcePower(oTarget, tUse);

    if(GetIsObjectValid(oTarget)) {     
        // ST: Removed, only do this below when relevant...
        // ClearAllActions();
        
         // ST: Don't do anything else for now to avoid interrupting the weapon change...
        if (GN_EquipAppropriateWeapon()) {
        	return TRUE;
        }

	    // ST: Added ----------------------------------------------
	    // Do special Party-specific targeting adjustments...
	    if ((GetNPCAIStyle(OBJECT_SELF) == NPC_AISTYLE_PARTY_SUPPORT) 
	    	&& !GetSoloMode()
	    	&& IsObjectPartyMember(OBJECT_SELF)) 
	    {	    	
	    	float fModDist = ST_DEFENSIVE_RADIUS - 0.5;
	    	
	    	if (GetIsTalentValid(tUse) && (GetTypeFromTalent(tUse) == TALENT_TYPE_FORCE))
	    		fModDist += 10.0;
	    	else 
	    		fModDist += ST_GetAttackRange();
	    	
	    	object oLeader = GetPartyLeader();
			oTarget = ST_GetTargetInRange(fModDist, oTarget, oIntruder);
	    	
    		if (!GetIsObjectValid(oTarget)) {
	    		oClose  		= OBJECT_INVALID;
	    		oIntruder 		= OBJECT_INVALID; 
	    		oTarget 		= OBJECT_INVALID;
	    		tPR.oLastTarget = OBJECT_INVALID;
	    		ST_SetLastAttackTarget(OBJECT_INVALID);
	    		
	    		ClearAllActions();
	    		ActionForceMoveToObject(oLeader, TRUE, 2.0, 15.0);
	    		return FALSE; 
    		}	
    		
    		// ST: SPECIAL CASE! 50% chance to use Bao-Dur's shield breaker against a
			//	   Shielded opponent that's close enough to allow melee contact.
			if (GetHasFeat(220) 
				&& ST_IsValidAttackTarget(oTarget, oLeader, 9.5)
				&& !GetIsObjectValid(GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON))
				&& ST_GetIsShielded(oTarget))
			{
				talent tBreaker = TalentFeat(220);				
				if (GetIsObjectValid(oTarget) && GetIsTalentValid(tBreaker) && GetCreatureHasTalent(tBreaker)) {
					ClearAllActions();
					ActionMoveToObject(oTarget, TRUE, 0.5);
					int bRes = ST_ActionUseTalent(tBreaker, oTarget, TRUE, FALSE);
					if (bRes)
						ActionWait(0.5);
					return bRes;
				}
    		} 	
	    }
	    // --------------------------------------------------------
		// ST: Added Disabler power filter...
        if (GetIsObjectValid(oTarget) 
        	&& GetIsTalentValid(tUse) 
        	&& GetIsEnemy(oTarget)
        	&& ST_ShouldUseDisablingPower(tUse, oTarget))
        { 	
        	// ST: Added fallback to Default attack if the talent could not be
        	//     used for whatever reason. Better do something than nothing...
            if (!ST_ActionUseTalent(tUse, oTarget)) {
	        	ClearAllActions();
	            ActionAttack(oTarget);
	            ST_SetLastAttackTarget(oTarget);
            }
            return TRUE;	
        }
        else if (GetIsObjectValid(oTarget) && GetIsEnemy(oTarget)) {
        	ClearAllActions();
            ActionAttack(oTarget);
            ST_SetLastAttackTarget(oTarget);
            return TRUE;
        }
    }

    return FALSE;
}


//::///////////////////////////////////////////////
//:: Jedi Aid AI
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    AI that concentrates on keeping the party healed,
    poison free.  If the party is doing ok then the Jedi
    will attempt to use Force Powers. If they are unable
    to use force powers they will run default AI.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Jan 20, 2003
//:://////////////////////////////////////////////

int GN_RunAidAIRoutine(object oIntruder = OBJECT_INVALID)
{   
    // ST: Added randomizer to reduce spam somewhat...
    if (d3() > 1) {
    object oPoisoned = GN_CheckIfPoisoned();
	    if(GetIsObjectValid(oPoisoned))
	    {
	        if(GN_TalentMasterRoutine(GEN_TALENT_REMOVE_POISON, oPoisoned)) {return TRUE;}
	    }    	
    	
	    object oInjured = GN_CheckIfInjured();
	    if(GetIsObjectValid(oInjured))
	    {
	        if(GN_TalentMasterRoutine(GEN_TALENT_HEALING, oInjured)) {return TRUE;}
	    }
	}

    return GN_RunDefaultAIRoutine(oIntruder);
}

//::///////////////////////////////////////////////
//:: Grenade AI
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Trys to use a grenades on targets not surrounded
    by enemies
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Jan 17, 2003
//:://////////////////////////////////////////////

int GN_RunGrenadeAIRoutine(object oIntruder = OBJECT_INVALID)
{
	talent tUse;
      object oTarget = ST_FindPartyGrenadeTarget(); 
      if (GetIsObjectValid(oTarget) && GetIsEnemy(oTarget)) {
		if (GetIsObjectValid(oIntruder)) {
			tUse = ST_GetRandomProjectileTalent();
			if (GetIsTalentValid(tUse)) {
				return ST_ActionUseTalent(tUse, oIntruder, FALSE);
			}
		}
                return GN_RunDefaultAIRoutine(oIntruder); 	
     }
    return GN_RunDefaultAIRoutine(oIntruder);
}

//::///////////////////////////////////////////////
//:: Jedi Support
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    This will make the Jedi use Force Powers before
    everything else.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Jan 17, 2003
//:://////////////////////////////////////////////
int GN_RunJediSupportAIRoutine(object oIntruder = OBJECT_INVALID) {
    //RWT-OEI 10/19/04 - Don't do ANYTHING if we're in a cutscene...
    // ST: Fugly hack that isn't at all generic, but make an exception here for the Arena AI
    //     to prevent combat from coming to a screeching halt when using the arena cameras.
    if (GetIsConversationActive() && (GetStringLowerCase(GetModuleName()) != "st_arena"))
        return TRUE;
    
    object oPoisoned = GN_CheckIfPoisoned();
    talent tUse;
    object oTarget;

    //P.W (May 27, 2003) - Made a change so that Droids can use Jedi Support. Its just default AI with an AI check however.
    // ST: Let them try to use the custom DRIOD(sic) AI first, then fall back to Default AI!
    if(GetRacialType(OBJECT_SELF) == RACIAL_TYPE_DROID) {
    	if (IsObjectPartyMember(OBJECT_SELF))
        	return ST_RunBotAIRoutine(oIntruder);
        else
        	return GN_RunDefaultAIRoutine(oIntruder);
    }

    //RWT-OEI 10/11/04 - If the player character is just attacking doors
    //or placeables, then don't bother buffing them...
    object oLeader = GetPartyMemberByIndex(0);
    object oLeaderTarget = GetAttackTarget(oLeader);
    if (!GetSoloMode()) {
        if ((GetObjectType( oLeaderTarget ) == OBJECT_TYPE_DOOR) || (GetObjectType( oLeaderTarget ) == OBJECT_TYPE_PLACEABLE))
            return FALSE;
    }

    if (GN_CheckSeriesRevitalize() != -1) {
        int nDown = GN_CheckIfKnockedOut();
        if (nDown) {
            if ( GN_TalentMasterRoutine(GEN_TALENT_REVITALIZE, GetFirstPC()) )
                return TRUE;
        }
    }

    if(GetIsObjectValid(oPoisoned)) {
        if (GN_TalentMasterRoutine(GEN_TALENT_REMOVE_POISON, oPoisoned))
        	return TRUE;
    }

    // ST: Added slight randomizer to healing. Only do it 66% of the time.
    if (d3() > 1) {
	    object oInjured = GN_CheckIfInjured();
	    if (GetIsObjectValid(oInjured)) {
	        if (GN_TalentMasterRoutine(GEN_TALENT_HEALING, oInjured))
	        	return TRUE;
	    }
	}

	// ST: Add slight randomizer to buffing... 75% chance to do it.
	if (d4() > 1) {
	    if (GN_TalentMasterRoutine(GEN_TALENT_BUFF, OBJECT_SELF))
	        return TRUE;
	}

	// ST: Use alternate targeting routine...
	oIntruder = ST_SelectAttackTarget(oIntruder);
    oTarget   = GN_FindAOETarget(oIntruder);

    if (GetIsObjectValid(oTarget)) {
        if(GetRacialType(oTarget) == RACIAL_TYPE_DROID) {
            tUse = GN_GetBossCombatMove(SW_BOSS_ATTACK_TYPE_FORCE_POWER, TRUE);
            if (!ST_ShouldUseDisablingPower(tUse, oTarget)) // ST: Retry once...
            	tUse = GN_GetBossCombatMove(SW_BOSS_ATTACK_TYPE_FORCE_POWER, TRUE);
        }
        else {
            tUse = GN_GetBossCombatMove(SW_BOSS_ATTACK_TYPE_FORCE_POWER);
            if (!ST_ShouldUseDisablingPower(tUse, oTarget)) // ST: Retry once...
            	tUse = GN_GetBossCombatMove(SW_BOSS_ATTACK_TYPE_FORCE_POWER);            
        }
    }
    else {
		// ST: Added oIntruder to prioritize target selected above...
        oTarget = GN_DetermineAttackTarget(oIntruder);

        if(GetIsObjectValid(oTarget)) {
            if (GetRacialType(oTarget) == RACIAL_TYPE_DROID) {
                tUse = GN_GetBossCombatMove(SW_BOSS_ATTACK_TYPE_NPC, TRUE);
                if (!ST_ShouldUseDisablingPower(tUse, oTarget)) // ST: Retry once...
                	tUse = GN_GetBossCombatMove(SW_BOSS_ATTACK_TYPE_NPC, TRUE);
            }
            else {
                tUse = GN_GetBossCombatMove(SW_BOSS_ATTACK_TYPE_NPC);
                if (!ST_ShouldUseDisablingPower(tUse, oTarget)) // ST: Retry once...
                	tUse = GN_GetBossCombatMove(SW_BOSS_ATTACK_TYPE_NPC);
            }
        }
    }
    
    tUse = GN_CheckThrowLightSaberUsage(oTarget, tUse);
    tUse = GN_CheckNonDroidForcePower(oTarget, tUse);
    
    if (GetIsObjectValid(oTarget) && GetIsTalentValid(tUse)) {
    	// ST: Added ------------------------------------------------
	    if ((GetNPCAIStyle(OBJECT_SELF) == NPC_AISTYLE_PARTY_SUPPORT) 
	    	&& !GetSoloMode()
	    	&& IsObjectPartyMember(OBJECT_SELF)
	    	&& !GetIsDead(OBJECT_SELF)) 
	    {
	    	object oLeader = GetPartyLeader();
	    	float fModDist = ST_DEFENSIVE_RADIUS - 0.5;
	    	
	    	if ((GetTypeFromTalent(tUse) == TALENT_TYPE_FORCE) 
	    		&& (GetIdFromTalent(tUse) != FORCE_POWER_FORCE_JUMP_ADVANCED)
	    		&& (GetIdFromTalent(tUse) != FORCE_POWER_FORCE_JUMP))
	    	{
	    		fModDist += 10.0;
	    	}
	    	else {
	    		fModDist += ST_GetAttackRange();
	    	}	    	
	    	
			oTarget = ST_GetTargetInRange(fModDist, oTarget, oIntruder);
	    		
    		if (!GetIsObjectValid(oTarget))
				return GN_RunDefaultAIRoutine();  	
	    }    	   	
    	// ----------------------------------------------------------
    	
        // ST: Do some usage sanity checks for the picked talent to see if it should be used...
        if (!ST_ShouldUseDisablingPower(tUse, oTarget))
        	return GN_RunDefaultAIRoutine(oIntruder);

        return ST_ActionUseTalent(tUse, oTarget);
    }

    // ST: Added oIntruder param to no redo target selection needlessly if
    //     a valid opponent was found.
    return GN_RunDefaultAIRoutine(oIntruder);
}

//::///////////////////////////////////////////////
//:: Boss AI: Grenade
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Run Boss Grenade AI Routine
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: April 2, 2003
//:://////////////////////////////////////////////
// ST: Added oIntruder parameter
int GN_RunBossGrenadeAI(object oIntruder = OBJECT_INVALID)
{
	talent tUse;
      object oTarget = ST_FindPartyGrenadeTarget(); 
      if (GetIsObjectValid(oTarget) && GetIsEnemy(oTarget)) {
		if (GetIsObjectValid(oIntruder)) {
                  int nDroid = (GetRacialType(oIntruder) == RACIAL_TYPE_DROID);
                  tUse = GN_GetBossCombatMove(SW_BOSS_ATTACK_TYPE_GRENADE, nDroid);
			if (GetIsTalentValid(tUse)) {
				return ST_ActionUseTalent(tUse, oIntruder, FALSE);
			}
		}
                return GN_RunDefaultAIRoutine(oIntruder); 	
     }
    return FALSE;
}

//::///////////////////////////////////////////////
//:: Boss AI: AOE Power
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Run Boss AOE Force Power Routine
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: April 2, 2003
//:://////////////////////////////////////////////
int GN_RunBossAOEPowerRoutine(object oIntruder=OBJECT_INVALID) {
    talent tUse;
    object oCheck = GN_FindAOETarget(oIntruder);
    
    if(GetIsObjectValid(oCheck)) {
         tUse = GN_GetBossCombatMove(SW_BOSS_ATTACK_TYPE_FORCE_POWER, (GetRacialType(oCheck) == RACIAL_TYPE_DROID));
         
         if (GetIsTalentValid(tUse) && ST_ShouldUseDisablingPower(tUse, oCheck)) {
            return ST_ActionUseTalent(tUse, oCheck);
         }
    }

    return FALSE;
}

//::///////////////////////////////////////////////
//:: Boss AI: Targeting
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    This will make boss monsters use targeted
    super powers.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: April 2, 2003
//:://////////////////////////////////////////////
// ST: Added oIntruder parameter. use targeted against the
//     current target first and foremost, and if that fails
//     then pick another.
int GN_RunBossTargetedRoutine(object oIntruder=OBJECT_INVALID) {
    talent 	tUse;
    object 	oTarget;
    object 	oFind;
    int 	nDroid;
    int 	nRand = d6();
    int 	nCnt = 1;
    
    if (nRand < 4)
    	nRand = 1;
    if (nRand == 4)
    	nRand = 2;
    if (nRand == 5)
    	nRand = 3;
    if (nRand == 6)
    	nRand = 4;

	// ST: Added, if oIntruder is specified use it instead of looking for new target.
	
	if (GetIsObjectValid(oIntruder) && GetIsEnemy(oIntruder) && GetObjectSeen(oIntruder)) {
		oFind = oIntruder;	
		oTarget = oIntruder;
	}
	else {
	    oFind = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF, nCnt, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);

	    while(GetIsObjectValid(oFind) && nCnt <= nRand) {
	        if(GetIsObjectValid(oFind))
	            oTarget = oFind;

	        nCnt++;
	        oFind = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF, nCnt, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
	    }
	}

    if(GetIsObjectValid(oTarget)) {
        nDroid = (GetRacialType(oTarget) == RACIAL_TYPE_DROID);
        tUse = GN_GetBossCombatMove(SW_BOSS_ATTACK_TYPE_NPC, nDroid);
        tUse = GN_CheckThrowLightSaberUsage(oTarget, tUse);
        tUse = GN_CheckNonDroidForcePower(oTarget, tUse);

        //MODIFIED by Preston Watamaniuk on April 2, 2003
        //Added this check to make the Droid setting was used for non-specific attacks.
        if(GetIsTalentValid(tUse) 
        	&& GetIsObjectValid(oTarget)
        	&& ST_ShouldUseDisablingPower(tUse, oTarget))
        {
            return ST_ActionUseTalent(tUse, oTarget);
        }
    }

    return FALSE;
}


//::///////////////////////////////////////////////
//:: Boss AI
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    This will make boss monsters buff themselves
    and use more force powers or utility devices
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Jan 31, 2003
//:://////////////////////////////////////////////
int GN_RunBossAIRoutine(object oIntruder = OBJECT_INVALID) {

	// ST: Added Heal randomizer... Don't spam healing if attacked!
	if ((d2() == 1) || !GetIsObjectValid(GetLastAttacker())) {
	    object oTarget = GN_CheckIfInjured();
	    if (GetIsObjectValid(oTarget)) {
	        if (GN_TalentMasterRoutine(GEN_TALENT_HEALING, oTarget)) 
	        	return TRUE;
	    }
	}
	
    // ST: Added... 25% chance of using buffs if I'm a Force User.
    // ST: CHANGED(2005-09-21) Let non-force users buff too if they have any stims.
    if (/* GN_IsJedi(OBJECT_SELF) && */ (d4() > 3))  {   
	    if (GN_TalentMasterRoutine(GEN_TALENT_BUFF, OBJECT_SELF))
	        return TRUE;
    } 
    
    // ST: Added... If having Ewok Rage and not already enraged, use it...
    if (d4() > 1) {
		if (ST_TalentUseRage())
			return TRUE;
	}

	
    if (GN_EquipAppropriateWeapon()) {
       // ST: Don't do anything more for now to avoid interrupting the weapon change.
       return TRUE;
    }

	// ST: New target selection routine. Hopefully this will enable somewhat
	//     less stupid targeting behavior if the supplied oIntruder is invalid.
	//     If oIntruder is valid it will be returned again, since DCR was
	//     instructed to attack a specific creature.
	oIntruder = ST_SelectAttackTarget(oIntruder);
	
	/*
	// ST: If no valid Intruder is given, flip it to the last attacked target.
	if (!GetIsObjectValid(oIntruder) 
		&& GetIsObjectValid(tPR.oLastTarget)
		&& !GetIsDead(tPR.oLastTarget)
		&& GetIsEnemy(tPR.oLastTarget)
		&& GetObjectSeen(tPR.oLastTarget))
	{
		oIntruder = tPR.oLastTarget;
	}
	*/

	// ST: Too predictable... Randomize the order it tries things a little...
	//     Also added Intruder parameter to AOE and Targeted subroutines to allow
	//     them the opportunity to primarily stay focused on a specified opponent.
	switch (Random(4)+1) {
		case 1:
		    if (GN_RunBossGrenadeAI(oIntruder)) 	  return TRUE;
		    if (GN_RunBossAOEPowerRoutine(oIntruder)) return TRUE;	
		    if (GN_RunBossTargetedRoutine(oIntruder)) return TRUE;
		    break;  
		case 2:
		    if (GN_RunBossAOEPowerRoutine(oIntruder)) return TRUE;	
		    if (GN_RunBossGrenadeAI(oIntruder)) 	  return TRUE;
		    if (GN_RunBossTargetedRoutine(oIntruder)) return TRUE;	
		    break;	
		case 3:
		    if (GN_RunBossTargetedRoutine(oIntruder)) return TRUE;	
		    if (GN_RunBossGrenadeAI(oIntruder)) 	  return TRUE;
		    if (GN_RunBossAOEPowerRoutine(oIntruder)) return TRUE;	
		    break;	
		case 4:	  
		    if (GN_RunBossTargetedRoutine(oIntruder)) return TRUE;	
		    if (GN_RunBossAOEPowerRoutine(oIntruder)) return TRUE;	
		    if (GN_RunBossGrenadeAI(oIntruder)) 	  return TRUE;
		    break;	
	}
	
	// ST: Fallthrough to default AI if no valid boss actions were found.
    return GN_RunDefaultAIRoutine();
}


//::///////////////////////////////////////////////
//:: Malak AI
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    This AI is just for Darth Malak on the Star
    Forge. It assumes there is only the PC and
    no one else.

    Malak's Force Powers
        Master Speed
        Force Push
        Throw Lightsaber (15)
        Affliction
        Force Resistance
        Imp. Energy Resist
        Lightning (15)
        Force Breach

    This routine is an add-on for boss ai.  It
    tests certain conditions that could be
    occurring in the Malak fight and reacts to them
    in a more agressive manner.

    1. K_END_JEDI_LEFT - Will track the total number
       of entombed Jedi left in the fight.
    2. K_END_MALAK_JEDI_USED - Will track the number
    of Jedi's Malak has personally used in the fight.

*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: April 29, 2003
//:://////////////////////////////////////////////
int GN_RunMalakAIRoutine()
{
    // GN_MyPrintString("GENERIC DEBUG *************** Malak AI Start");
    //int nJediLeft = GetGlobalNumber("K_END_JEDI_LEFT");
    //int nMalakUsed = GetGlobalNumber("K_END_MALAK_JEDI_USED");
    object oPC = GetFirstPC();
    int bJedi, bDist, bAttack;
    float fDist = GetDistanceBetween(OBJECT_SELF, oPC);

    //Check to see if Malak need to become more aggressive
    //Test the number of Jedi to see if the player has used any
    //if(((8 - nJediLeft) < nMalakUsed))
    //{
    //    bJedi = TRUE;
    //}
    //Check to see if the player is running away
    // GN_MyPrintString("GENERIC DEBUG *************** Malak Distance to PC = " + FloatToString(GetDistanceBetween(OBJECT_SELF, oPC),4,4));
    if(fDist > 10.0)
    {
        bDist = TRUE;
    }
    if(bDist == TRUE)
    {
        /*
            AI REACTION 2 - Player is keeping his distance.
            1. Force Breach if the player is using speed
            OR
            2. Use Action Attack to Force Jump
        */
        // GN_MyPrintString("GENERIC DEBUG *************** Clear 1480");
        ClearAllActions();
        if(GetHasSpellEffect(FORCE_POWER_SPEED_BURST, oPC) ||
           GetHasSpellEffect(FORCE_POWER_KNIGHT_SPEED, oPC) ||
           GetHasSpellEffect(FORCE_POWER_SPEED_MASTERY, oPC))
        {
            talent tBreach = TalentSpell(FORCE_POWER_FORCE_BREACH);
            if(GetIsTalentValid(tBreach))
            {
                // GN_MyPrintString("GENERIC DEBUG *************** Using Breach");
                ST_ActionUseTalent(tBreach, oPC, TRUE, FALSE);
            }
            bAttack = TRUE;
        }
        else
        {
            if(fDist > 10.0)
            {
                int nRoll = d3();
                int nPower = -1;
                if(nRoll == 1)
                {
                    nPower = FORCE_POWER_LIGHTNING;
                }
                else if(nRoll == 2)
                {
                    nPower = FORCE_POWER_LIGHT_SABER_THROW;
                }
                else if(nRoll > 2)
                {
                    bAttack = TRUE;
                }
                if(nPower != -1)
                {
                    talent tPower = TalentSpell(nPower);
                    if(GetIsTalentValid(tPower))
                    {
                        // GN_MyPrintString("GENERIC DEBUG *************** Malak Using Force Power");
                        return ST_ActionUseTalent(tPower, oPC);
                    }
                }
            }
            bAttack = TRUE;
        }
    }
    if(bAttack == TRUE)
    {
        // GN_MyPrintString("GENERIC DEBUG *************** Malak Attacking");
        ActionAttack(oPC);
        return TRUE;
    }
    // GN_MyPrintString("GENERIC DEBUG *************** Malak AI Drop Out");
    return FALSE;
}

//RWT-OEI 04/07/04
// GN_SetHealPercentage
// Determines what percentage the HealerAI does per heal.
// Specific to the calling object
void GN_SetHealPercentage( int nHeal )
{

    SetLocalNumber(OBJECT_SELF, SW_NUMBER_HEALERAI_PERCENTAGE, nHeal );

}

//RWT-OEI 04/13/04
// GN_SetHealThreshold
// Sets the threshold at which the HealerAI will try to heal
// Specific to the calling object
void GN_SetHealThreshold( int nPercentage )
{
    SetLocalNumber( OBJECT_SELF, SW_NUMBER_HEALERAI_THRESHOLD, nPercentage );
}

//::///////////////////////////////////////////////
//:: Healer AI Routine: Do Heal
//:: Copyright (c) 2004 Obsidian Entertainment
//:://////////////////////////////////////////////
/*
    This subfunction is only intended to be called
    from within the GN_RunHealerAIRoutine.
    It is what handles the actual healing after
    all the logic, patient selection, and movement
    has been taken care of.

*/
//:://////////////////////////////////////////////
//:: Created By: R.Taylor
//:: Created On: 03/22/04
//:://////////////////////////////////////////////
void HealerAIDoHeal( object oPatient )
{
    //AurPostString( "Now in healeraidoheal", 10, 10, 10.0f );

    //Make sure we're facing the right way
    SetFacingPoint(GetPosition(oPatient));

    int nMaxHP = GetMaxHitPoints( oPatient );
    int nCurHP = GetCurrentHitPoints( oPatient );

    //Determine the percentage to heal.
    int nHealPercentage = GetLocalNumber(OBJECT_SELF, SW_NUMBER_HEALERAI_PERCENTAGE);
    if ( !nHealPercentage ) //It wasn't set, so default to 25%
        nHealPercentage = 25;

    int nHealAmount = ( nMaxHP * nHealPercentage ) / 100;

    //int nHealAmount = nMaxHP / 4;

    //Make sure we can't heal them over 100%
    if ( (nMaxHP - nCurHP ) < nHealAmount )
        nHealAmount = nMaxHP - nCurHP;

    //Create and apply the heal effect
    effect eHeal = EffectHeal( nHealAmount );
    ApplyEffectToObject( DURATION_TYPE_INSTANT, eHeal, oPatient );

    //effect eBeam = EffectVisualEffect( VFX_BEAM_STUN_RAY );
    //ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eBeam, OBJECT_SELF, 1.0 );

    effect eBeam = EffectBeam( VFX_BEAM_STUN_RAY, OBJECT_SELF, BODY_NODE_HAND );
    ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eBeam, oPatient, 1.0f );

    effect eHealField;
    if ( GetRacialType( oPatient ) == RACIAL_TYPE_DROID ) {
        eHealField = EffectVisualEffect( 1048 );
    } else {
        eHealField = EffectVisualEffect( VFX_IMP_HEAL );
    }
    ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eHealField, oPatient, 3.0f );
}

//::///////////////////////////////////////////////
//:: Healer AI Routine
//:: Copyright (c) 2004 Obsidian Entertainment
//:://////////////////////////////////////////////
/*
    Creatures using this AI do NOT FIGHT no matter
    what. Instead, they run around looking for
    anyone that is 'friendly' to their faction and
    healing them as long as combat is going on.
    Outside of combat, they'll keep healing until
    no allies are nearby that need healing.
    They do not heal themselves.
    Currently, they restore 25% of their patient's
        HP.

*/
//:://////////////////////////////////////////////
//:: Created By: R.Taylor
//:: Created On: 03/18/04
//:://////////////////////////////////////////////
int GN_RunHealerAIRoutine( object oIntruder )
{
    //First we need to see if we're already actively
    //trying to find someone to heal.
    object oOldTarget = GetHealTarget( OBJECT_SELF );

    if ( GetIsObjectValid( oOldTarget ) && !(GetIsDead( oOldTarget) ) ) {
        //The old target is still valid, let's see if
        //we're close enough to heal them.
        //AurPostString( "We have a heal target", 10, 10, 10.0f );
        float distance = GetDistanceToObject( oOldTarget );
        if ( distance < 3.5 ) { //We're now close enough to heal
            HealerAIDoHeal( oOldTarget );
            //Clear our old target so we don't heal them again
            SetHealTarget( OBJECT_SELF, OBJECT_INVALID );
            if ( GetIsInCombat() )
                DelayCommand( 3.0, GN_DetermineCombatRound( oIntruder ) );
        } else {
            //See if we're still moving
            //AurPostString( "Check if we are still moving", 10, 10, 10.0f );
            int nActionID = GetCurrentAction(OBJECT_SELF);
            if ( nActionID != ACTION_MOVETOPOINT ) {
                //Requeue a move action to get us moving again
                //AurPostString( "Requeue Moving to New Target", 10, 10, 10.0f );
                // DebugMessageParty("HealerAIRoutine - MOVING TO HEAL TARGET!!!");
                ActionMoveToObject( oOldTarget, TRUE, 3.0f );
                if ( GetIsInCombat() )
                    DelayCommand( 3.0, GN_DetermineCombatRound( oIntruder ) );
            }
        }
        return 0;
    } else {
        //AurPostString( "Target is dead or invalid, so clear.", 10, 10, 10.0f);
        SetHealTarget( OBJECT_SELF, OBJECT_INVALID );
    }

    //If we get this far, then we do not have a current heal target to
    //focus on.
    //Search through every creature within a 20m radius
    //If they are friendly to this creature, and
    //have HP less than 50%, move over to them and heal
    //them.
    //AurPostString( "We don't have a target yet", 10, 10, 10.0f );
    object oCurTarget = GetFirstObjectInShape(SHAPE_SPHERE, 20.0f,
        GetLocation(OBJECT_SELF), FALSE, OBJECT_TYPE_CREATURE );

    while ( GetIsObjectValid(oCurTarget) )
    {
        int bHealCurTarget = TRUE;
        //Make sure we're not healing self
        if ( oCurTarget == OBJECT_SELF ) {
            //AurPostString( "Don't heal self.", 10, 10, 10.0f );
            bHealCurTarget = FALSE;
        }

        //Can't heal the dead ones.
        if ( bHealCurTarget && GetIsDead( oCurTarget ) ) {
            //AurPostString( "Cur Target is already dead.", 10, 10, 10.0f );
            bHealCurTarget = FALSE;
        }

        //Heal those we're friendly to
        if ( bHealCurTarget && !(GetIsFriend( oCurTarget ))  ) {
            //AurPostString( "Not friend or neutral to target.", 10, 10, 10.0f );
            bHealCurTarget = FALSE;
        }

        //RWT-OEI 10/05/04
        //If we're NOT Friendly1, only heal droids.
        if ( GetStandardFaction(OBJECT_SELF) != STANDARD_FACTION_FRIENDLY_1 &&
             GetStandardFaction(OBJECT_SELF) != STANDARD_FACTION_FRIENDLY_2 )
        {
            if ( GetRacialType(oCurTarget) != RACIAL_TYPE_DROID )
            {
                bHealCurTarget = FALSE;
            }
        }

        //RWT-OEI 10/05/04
        //If we're neutral, don't heal anyone
        if ( GetStandardFaction(OBJECT_SELF) == STANDARD_FACTION_NEUTRAL )
        {
            bHealCurTarget = FALSE;
        }

        //We have a target that we might heal now if bHealCurTarget = true
        if ( bHealCurTarget ) {
            //AurPostString( "Target eligible for possible healing.", 10, 10, 5.0f);
            //Determine if cur target has less than 50% HP
            int nCurHP = GetCurrentHitPoints( oCurTarget );
            int nMaxHP = GetMaxHitPoints( oCurTarget );
            int nPercentage = ( nCurHP * 100 ) / nMaxHP;

            int nThreshold = GetLocalNumber(OBJECT_SELF, SW_NUMBER_HEALERAI_THRESHOLD );
            if ( nThreshold < 1 )
                nThreshold = 50;//RWT-OEI 04/13/04 - Default to 50%

            if ( nPercentage < nThreshold ) {
                //AurPostString( "Need to heal this target.", 10, 10, 5.0f );
                //Need to heal this target
                ClearAllActions();

                //Get within 3.5 meters for visual reasons
                float distance = GetDistanceToObject2D( oCurTarget );

                if ( distance > 3.5 ) {
                    //We need to move closer to the object before healing
                    //AurPostString( "Need move closer new target.", 10, 10, 5.0f);

                    //Make sure to store the ID of our current heal target
                    //so we know not to seek out a new target
                    SetHealTarget( OBJECT_SELF, oCurTarget );
                    // DebugMessageParty("HealerAIRoutine - MOVING TO HEAL TARGET 2!!!");
                    ActionMoveToObject( oCurTarget, TRUE, 3.0f );
                    if (GetIsInCombat() )
                        DelayCommand( 3.0, GN_DetermineCombatRound( oIntruder ) );
                    return 0;
                } else {
                    //Close enough to heal new target
                    HealerAIDoHeal( oCurTarget );
                    SetHealTarget( OBJECT_SELF, OBJECT_INVALID );
                    if ( GetIsInCombat() )
                        DelayCommand( 3.0, GN_DetermineCombatRound( oIntruder ));
                    return 0;
                }
            } //if percentage < 50
        } //if bHealCurTarget

        oCurTarget = GetNextObjectInShape(SHAPE_SPHERE, 20.0f,
                       GetLocation(OBJECT_SELF), FALSE,
                       OBJECT_TYPE_CREATURE );
    }// while GetObjectIsValid()
    return 0;
}

//::///////////////////////////////////////////////
//:: Skirmish AI Routine
//:: Copyright (c) 2004 Obsidian Entertainment
//:://////////////////////////////////////////////
/*
    This function handles the Skirmish AI.
    Basically, between shooting, the creature will
    move around randomly. This is designed to give
    the illusion of skirmishing and movement during
    combat, when in effect, all it really does is make
    the creature waste a lot combat rounds by moving
    instead of attacking. As a result, creatures using
    this AI will be easier than the same creature
    using the default AI.
    If it returns 0, that means to continue on
    with alternative AI routines. If it returns 1,
    that means it has handled the creature's action
    for now and no other AI routines should be run.
*/
//:://////////////////////////////////////////////
//:: Created By: R.Taylor
//:: Created On: 03/22/04
//:://////////////////////////////////////////////
int GN_RunSkirmishAIRoutine( object oIntruder )
{
    //Creatures on the Skirmish AI will NOT be allowed
    //to use Waypoints, so we'll just borrow the local
    //Number fields that deal with Waypoints: 0, 1, 2
    //0 = # of times this has been called but done \
    //    nothing.

    //If we're already moving, do nothing.
    if ( GetCurrentAction() == ACTION_MOVETOPOINT ) {
        return 1;
    }

    int nTimes = GetLocalNumber( OBJECT_SELF, 0 );
    int nOdds = (nTimes * 100) / 5;
    int nRand = Random( 100 );

    if ( nRand < nOdds ) {//Okay, move and reset Local:0
        vector vNewPos = GetRandomDestination( OBJECT_SELF, 6 );
        float fFacing  = GetFacing( OBJECT_SELF );
        SetLocalNumber( OBJECT_SELF, 0, 0 );
        location lNewLoc = Location( vNewPos, fFacing );
        ActionMoveToLocation( lNewLoc, TRUE );
        return 1;//We handled the action here
    } else {
        // We're not going to move this time, increment Local:0
        nTimes += 1;
        SetLocalNumber( OBJECT_SELF, 0, nTimes );
        return 0;//We didn't control the action at this time
    }

}

//::///////////////////////////////////////////////
//:: Turtle AI Routine
//:: Copyright (c) 2004 Obsidian Entertainment
//:://////////////////////////////////////////////
/*
    This function handles the Turtle AI.
    We needed a special AI for the Drexl Boss
    on Onderon. Basically what happens is the Drexl
    goes into a defensive turtle mode, where he does
    not attack the PC and the party. He absorbs a
    certain amount of damage, then deals it
    off to the player, and or surrounding NPCs

    The damage is stored in local number 15
    We need to keep a tab on how much damage
    is given in this number
*/
//:://////////////////////////////////////////////
//:: Created By: Adam Brennecke
//:: Created On: 07/03/04
//:://////////////////////////////////////////////
int GN_RunTurtleAIRoutine( object oIntruder )
{
    // check how much damage has been done
    int iDmg = GetLocalNumber(OBJECT_SELF,15);

    // check if we are about to die, if so, then don't do the special attack
    if(GetCurrentHitPoints() < 5)
        return TRUE;

    if(iDmg > 30)
    {
        // AurPostString("Turtle Special Attack",5,7,5.0);
        iDmg = iDmg / 3;

        // we need to remove the effects on the object so it can roar
        effect e = GetFirstEffect(OBJECT_SELF);
        while(GetIsEffectValid(e))
        {
            if(GetEffectType(e) == EFFECT_TYPE_SLEEP)
            {
                DelayCommand(0.1,RemoveEffect(OBJECT_SELF,e));
            }
            else if(GetEffectType(e) == EFFECT_TYPE_PARALYZE)
            {
                DelayCommand(0.1,RemoveEffect(OBJECT_SELF,e));
            }
            else if(GetEffectType(e) == EFFECT_TYPE_VISUAL)
            {
                DelayCommand(0.1,RemoveEffect(OBJECT_SELF,e));
            }

           e = GetNextEffect(OBJECT_SELF);
        }
        // make it look like we are attacking
        ClearAllActions();
        DelayCommand(0.3,ActionPlayAnimation(ANIMATION_FIREFORGET_TAUNT,1.0,1.0));

        // apply damage to the three PCs if they are close enough
        int i;
        for(i = 0; i < 3; i++)
        {
            object oTarg = GetPartyMemberByIndex(i);

            if(GetDistanceBetween(OBJECT_SELF,oTarg) < 10.0)
            {
                // saving throws?
                DelayCommand(1.0,ApplyEffectToObject(DURATION_TYPE_INSTANT,EffectDamage(iDmg),oTarg));

                // play special effect
                //effect eVis = EffectBeam(VFX_BEAM_FLAME_SPRAY,OBJECT_SELF,BODY_NODE_HEAD);
                //DelayCommand(0.5,ApplyEffectToObject(DURATION_TYPE_TEMPORARY,eVis,oTarg,2.0));
            }
        }
        // reset damage counter
        DelayCommand(1.0,ApplyEffectToObject(DURATION_TYPE_TEMPORARY,EffectVisualEffect(VFX_IMP_SCREEN_SHAKE),GetFirstPC(),2.0));
        SetLocalNumber(OBJECT_SELF,15,0);
    }
    else
    {
        // AurPostString("Turtle Paralyzed Code.",5,6,4.0);
        ClearAllActions();
        //ActionPlayAnimation(ANIMATION_LOOPING_SLEEP,1.0,-1.0);

        // We should look like we are about to die, and on the defensive
        // check to see if we already have the effects applied, if so, don't do it twice
        // this was causing me to have alot of headaches
        int nApplyEffects = 1;
        effect e = GetFirstEffect(OBJECT_SELF);
        while(GetIsEffectValid(e))
        {
            if(GetEffectType(e) == EFFECT_TYPE_SLEEP)
                nApplyEffects = 0;

           e = GetNextEffect(OBJECT_SELF);
        }

        if(nApplyEffects)
        {
            //DelayCommand(3.0,ActionDoCommand(ApplyEffectToObject(DURATION_TYPE_TEMPORARY,EffectVisualEffect(VFX_IMP_FLAME),OBJECT_SELF,100.0)));
            DelayCommand(3.0,ActionDoCommand(ApplyEffectToObject(DURATION_TYPE_TEMPORARY,EffectSleep(),OBJECT_SELF,100.0)));
            DelayCommand(3.0,ActionDoCommand(ApplyEffectToObject(DURATION_TYPE_TEMPORARY,EffectParalyze(),OBJECT_SELF,100.0)));
        }
    }

    return TRUE;
}

// DJS-OEI 9/27/2004
// AI for creatures that need to occassionally use Special Abilities.
int GN_RunMonsterPowersAIRoutine(object oIntruder) {

    // AurPostString( "Monster Powers AI Routine", 5, 4, 3.0 );
    // This just looks for Monster Powers (which all seem to have 0x1304 as
    // their category.
    talent tPower = GetCreatureTalentRandom( 0x1304, OBJECT_SELF, TALENT_TYPE_SPELL );
    // Fire a power 20% of the time.
    // ST: Make it lower, they use them way too often already since
    //     they only tend to have one for each type of creature. Spam!
    if((Random(100)+1) < 10) {
        // Perform it.
        if(GetIsTalentValid(tPower) && GetCreatureHasTalent(tPower)) {

			// ST: Added filter check....
            if(GetIsObjectValid(oIntruder) && GetIsEnemy(oIntruder) && ST_ShouldUseDisablingPower(tPower, oIntruder)) {
                // ST: Added ClearAllActions, seems to be done mostly everywhere else a talent is used...
                return ST_ActionUseTalent(tPower, oIntruder);
            }
            else {
                // Get the nearest enemy and use the ability on it.
                object oDefault = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY);
                // ST: Added filter check...
                if(GetIsObjectValid(oDefault) && ST_ShouldUseDisablingPower(tPower, oDefault))
                {
                    // GN_MyPrintString("GENERIC DEBUG *************** Using Talent on Determined Target");
                    // ST: Added ClearAllActions, seems to be done everywhere else a talent is used...
                    return ST_ActionUseTalent(tPower, oDefault);
                }
            }
        }
    }
    return FALSE;
}

//::///////////////////////////////////////////////
//:: Shield Activation
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Organic Shields are 99 to 107
    Droid shields are 110 to 115

    Scans through all of the shield talents to
    see if the target has a shield to use. If the
    shield is used then the person will never use
    another one. Party members will never use this
    function.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Jan 31, 2003
//:://////////////////////////////////////////////
int GN_ActivateForceField()
{
    // GN_MyPrintString("GENERIC DEBUG *************** Starting Forcefield Search");
    // GN_MyPrintString("GENERIC DEBUG *************** Shield Boolean (" + GN_ITS(SW_FLAG_SHIELD_USED) + ") = " + GN_ITS(GN_GetSpawnInCondition(SW_FLAG_SHIELD_USED)));
    if(GN_GetSpawnInCondition(SW_FLAG_SHIELD_USED) == FALSE && !IsObjectPartyMember(OBJECT_SELF))
    {
        int nCnt, nStop;
        int bValid = FALSE;
        talent tShield;
        if(GetRacialType(OBJECT_SELF) == RACIAL_TYPE_DROID)
        {
            nCnt = 110;
            nStop = 115;
        }
        else
        {
            nCnt = 99;
            nStop = 107;
        }

        while(bValid == FALSE && nCnt <= nStop)
        {
            tShield = TalentSpell(nCnt);
            if(GetCreatureHasTalent(tShield))
            {
                bValid = TRUE;
            }
            else
            {
                nCnt++;
            }
        }

        //RWT-OEI 04/22/04 - Since shield powers aren't necessarially
        //incremental in order anymore, we need to catch some special
        //cases here:
        if ( !bValid ) {//One hasn't been found yet, try special cases
            tShield = TalentSpell( 132 ); //This is the Heat Shield
            if ( GetCreatureHasTalent( tShield ) ) {
                bValid = TRUE;
            }
            // JAB-OEI 7/2/04 added another special case
            if(!bValid)
            {
                tShield = TalentSpell( 257 ); // drexl shield
                if ( GetCreatureHasTalent( tShield ) ) {
                    bValid = TRUE;
                }
            }
        }

        if(bValid)
        {
            // GN_MyPrintString("GENERIC DEBUG *************** Clear 1700");
            int bRes = ST_ActionUseTalent(tShield, OBJECT_SELF, FALSE);
            GN_SetSpawnInCondition(SW_FLAG_SHIELD_USED);
            return bRes;
        }
        else
        {
            // GN_MyPrintString("GENERIC DEBUG *************** Forcefield Search Fallthrough");
            GN_SetSpawnInCondition(SW_FLAG_SHIELD_USED);
            return FALSE;
        }
    }
    // GN_MyPrintString("GENERIC DEBUG *************** Forcefield Search Fallthrough");
    return FALSE;
}

//::///////////////////////////////////////////////
//:: Resistance Activation
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    20 Resist Force
    41 Force Immunity
    Checks to see if the character has resist force
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Jan 31, 2003
//:://////////////////////////////////////////////
//Makes the person activate Resist Elements and Resist Force.
int GN_ActivateResistances()
{
    int bValid = FALSE;
    if(GN_GetSpawnInCondition(SW_FLAG_RESISTANCES_APPLIED) == FALSE && !IsObjectPartyMember(OBJECT_SELF))
    {
        if(GetHitDice(GetFirstPC()) >= 15 || GN_GetSpawnInCondition(SW_FLAG_BOSS_AI))
        {
            talent tResist = TalentSpell(FORCE_POWER_RESIST_FORCE);
            talent tImmune = TalentSpell(FORCE_POWER_FORCE_IMMUNITY);
            talent tUse;
            if(GetCreatureHasTalent(tImmune))
            {
                tUse = tImmune;
                bValid = TRUE;
            }
            else if(GetCreatureHasTalent(tResist))
            {
                tUse = tResist;
                bValid = TRUE;
            }

            if(bValid == TRUE)
            {
                bValid = ST_ActionUseTalent(tUse, OBJECT_SELF, FALSE);
            }
            GN_SetSpawnInCondition(SW_FLAG_RESISTANCES_APPLIED);
        }
    }

    return bValid;
}



//:://///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//:://///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//:: Respond to Shout                                           ========  =       =   =======   =       =  =========   ========
//:: Copyright (c) 2001 Bioware Corp.                          =          =       =  =       =  =       =      =      =
//:://////////////////////////////////////////////             =          =       =  =       =  =       =      =      =
/*//                                                           =          =       =  =       =  =       =      =      =
    Catches the shouts and determines the best                 =========  =========  =       =  =       =      =      =========
    course of action for them                                          =  =       =  =       =  =       =      =              =
                                                                       =  =       =  =       =  =       =      =              =
    SetListenPattern(OBJECT_SELF, "GEN_I_WAS_ATTACKED", 1);            =  =       =  =       =  =       =      =              =
    SetListenPattern(OBJECT_SELF, "GEN_I_SEE_AN_ENEMY", 15);   ========   =       =   =======     ======       =      ========
*///
//:://///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: July 16, 2002
//:://///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//:://///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void GN_RespondToShout(object oShouter, int nShoutIndex, object oIntruder = OBJECT_INVALID) {
	
    //RWT-OEI 10/08/04 - If we're neutral, we just don't want to respond to these
    //shouts. Ever. Seriously.
    if ( GetStandardFaction(OBJECT_SELF) == STANDARD_FACTION_NEUTRAL )
        return;

    //MODIFIED by Preston Watamaniuk May 9
    //Put this check into disable shouts being heard by people from different combat zones.
    if (GetLocalNumber(oShouter, SW_NUMBER_COMBAT_ZONE) == GetLocalNumber(OBJECT_SELF, SW_NUMBER_LAST_COMBO) 
    	|| GetLocalNumber(oShouter, SW_NUMBER_COMBAT_ZONE) == 0 
    	|| GetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBAT_ZONE) == 0 
    	|| IsObjectPartyMember(OBJECT_SELF))
    {
        if (!GN_GetSpawnInCondition(SW_FLAG_COMMONER_BEHAVIOR)
           && !GN_GetSpawnInCondition(SW_FLAG_SPECTATOR_STATE)
           && !GN_GetSpawnInCondition(SW_FLAG_AI_OFF)
           && !GetUserActionsPending())
        {
            if ((nShoutIndex == 1) 
            	&& GetIsFriend(oShouter) 
            	&& (oShouter != OBJECT_SELF)) 
            {
                if ((IsObjectPartyMember(OBJECT_SELF) 
                	&& IsObjectPartyMember(oShouter) 
                	&& (GetSoloMode() == FALSE)) || !IsObjectPartyMember(OBJECT_SELF))
                {
                    if (!GetIsObjectValid(GetAttemptedAttackTarget()) 
                    	&& !GetIsObjectValid(GetAttemptedSpellTarget()) 
                    	&& !GetIsObjectValid(GetAttackTarget())
                    	&& !GetIsObjectValid(ST_GetLastAttackTarget()))  // ST: (2005-08-28) Added this
                    {
                        if ((GetPartyMemberByIndex(0) != OBJECT_SELF) 
                        	&& (GetPartyAIStyle() != PARTY_AISTYLE_PASSIVE) 
                        	&& !GetPlayerRestrictMode())
                        {
                            if ((IsObjectPartyMember(OBJECT_SELF) 
                            	&& !GetPlayerRestrictMode()) 
                            	|| !IsObjectPartyMember(OBJECT_SELF))
                            {
                                if (GetObjectSeen(oIntruder)) {
                                    // ClearAllActions(); // ST: Removed, let DCR do this...
                                    GN_DetermineCombatRound(oIntruder);
                                }
                                else if (GetIsObjectValid(oIntruder)) {
                                    ClearAllActions();
                                    float fDistance = 5.0;

                                    //P.W. (June 8) - Put this check in to try and reduce the instances of NPCs running right up
                                    //to their enemies with blasters.
                                    if ((GetDistanceBetween(OBJECT_SELF, oIntruder) < 20.0) && !GetObjectSeen(oIntruder)) 
                                        ActionMoveToObject(oIntruder, TRUE, 2.0);
                                    else if (GN_GetWeaponType(OBJECT_SELF) == 1)
                                    	ActionMoveToObject(oIntruder, TRUE, 4.0);
                                    else
                                    	ActionMoveToObject(oIntruder, TRUE, 15.0);
                                }
                                //MODIFIED by Preston Watamaniuk on May 16th
                                //Added this check to make Party Members attack after the PC engages in combat.
                                else if (IsObjectPartyMember(OBJECT_SELF)) {
                                    oIntruder = GetAttackTarget(oShouter);
                                    if (GetIsObjectValid(oIntruder)) {
                                        GN_DetermineCombatRound(oIntruder);
                                    }
                                    else {
                                        oIntruder = GetSpellTarget(oShouter);
                                        if(GetIsObjectValid(oIntruder))
                                            GN_DetermineCombatRound(oIntruder);
                                    }
                                }
                            }
                            //I AM IN COMBAT
                            // ST: Huh? This conditional is NEVER true since nShoutIndex has to be
                            //     1 in order to reach this spot. Bug?
                            else if ((nShoutIndex == 15) 
                            	&& GetIsFriend(oShouter) 
                            	&& (oShouter != OBJECT_SELF))
                            {
                                if (GetCurrentAction(OBJECT_SELF) == ACTION_INVALID) {
                                    if(GetObjectSeen(oIntruder)) {
                                        // ClearAllActions(); // ST: Removed, let DCR do this...
                                        GN_DetermineCombatRound(oIntruder);
                                    }
                                    else if(GetIsObjectValid(oIntruder)) {
                                        ClearAllActions();
                                        ActionMoveToObject(oIntruder, TRUE, 5.0);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        else if(GN_GetSpawnInCondition(SW_FLAG_SPECTATOR_STATE)) {
            ClearAllActions();
            return;
        }
    }
}

//::///////////////////////////////////////////////
//:: SetListeningPatterns
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Sets the correct listen checks on the NPC by
    determining what talents they possess or what
    class they use.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Oct 24, 2001
//:://////////////////////////////////////////////

void GN_SetListeningPatterns()
{
    SetListening(OBJECT_SELF, TRUE);
    SetListenPattern(OBJECT_SELF, "GEN_I_WAS_ATTACKED", 1);
    SetListenPattern(OBJECT_SELF, "GEN_I_AM_DEAD", 3);
    SetListenPattern(OBJECT_SELF, "GEN_CALL_TO_ARMS", 6);
    if(GetHasSpell(FORCE_POWER_SUPRESS_FORCE) || GetHasSpell(FORCE_POWER_FORCE_BREACH))
    {
        SetListenPattern(OBJECT_SELF, "GEN_SUPRESS_FORCE", 9);
    }
    SetListenPattern(OBJECT_SELF, "GEN_GRENADE_TOSSED", 12);
    SetListenPattern(OBJECT_SELF, "GEN_I_SEE_AN_ENEMY", 14);
    SetListenPattern(OBJECT_SELF, "GEN_COMBAT_ACTIVE", 15);

    GN_SetUpWayPoints();

    //MODIFIED by Preston Watamaniuk on May 8, 2003
    //Added functionality for dynamic or encounter creatures
    //to latch onto a Zone Controller.
    if(GN_GetSpawnInCondition(SW_FLAG_DYNAMIC_COMBAT_ZONE) || GetIsEncounterCreature())
    {
        string sController;
        int nCount = 1;
        object oController, oTest;
        float fNear;
        float fClosest = 100.0;

        for(nCount; nCount < 40; nCount++)
        {
            if(nCount < 10)
            {
                sController = "ZoneController" + "0" + IntToString(nCount);
            }
            else
            {
                sController = "ZoneController" + IntToString(nCount);
            }
            oTest = GetObjectByTag(sController);
            if(GetIsObjectValid(oTest))
            {
                fNear = GetDistanceBetween(OBJECT_SELF, oTest);
                //// GN_MyPrintString("ZONING DEBUG ***************** Controller Distance = " + GN_ReturnDebugName(oController) + " " + FloatToString(fNear, 4, 2));
                if(fNear < fClosest)
                {
                    fClosest = fNear;
                    oController = oTest;
                }
            }
        }
        if(GetIsObjectValid(oController) && fClosest < 30.0)
        {
            //// GN_MyPrintString("ZONING DEBUG ***************** Setup Controller = " + GN_ReturnDebugName(oController));
            int nZone = StringToInt(GetStringRight(GetTag(oController), 2));
            SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBAT_ZONE, nZone);
        }
    }
}

//::///////////////////////////////////////////////
//:: Check for Poison
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Checks if someone in the party is poisoned.
    If the person is a non-party NPC then they
    check if they are poisoned.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Oct 9, 2002
//:://////////////////////////////////////////////

object GN_CheckIfPoisoned()
{
    // GN_MyPrintString("GENERIC DEBUG *************** Starting Poison Check");
    effect ePoison;
    if(IsObjectPartyMember(OBJECT_SELF))
    {
        int nCnt = 0;
        for(nCnt; nCnt > 2; nCnt++)
        {
            ePoison = GetFirstEffect(GetPartyMemberByIndex(nCnt));
            while(GetIsEffectValid(ePoison))
            {
                if(GetEffectType(ePoison) == EFFECT_TYPE_POISON)
                {
                    return GetPartyMemberByIndex(nCnt);
                }
                ePoison = GetNextEffect(GetPartyMemberByIndex(nCnt));
            }
        }
    }
    else
    {
        ePoison = GetFirstEffect(OBJECT_SELF);
        while(GetIsEffectValid(ePoison))
        {
            if(GetEffectType(ePoison) == EFFECT_TYPE_POISON)
            {
                return OBJECT_SELF;
            }
            ePoison = GetNextEffect(OBJECT_SELF);
        }
    }
    // GN_MyPrintString("GENERIC DEBUG ***************  Returning Invalid Poison Object");
    return OBJECT_INVALID;
}

//::///////////////////////////////////////////////
//:: Check for Injuries
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Returns member index +1 or false depending on
    whether the object belongs in the PCs party.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Oct 9, 2002
//:://////////////////////////////////////////////

object GN_CheckIfInjured()
{
    // GN_MyPrintString("GENERIC DEBUG ***************  Starting Injury Check Function");
//RWT-OEI 03/03/04 - Took out this check that used the TYPE_DROID racial query. It didn't make
//  a bit of sense. Having it in there made it so that NPC droids are checking Party Characters
//  to determine if they are injured, instead of just looking at their own condition.
//  Removing this check made it so that droids will use Repair Kits on themselves now.
//    if(IsObjectPartyMember(OBJECT_SELF) || GetRacialType(OBJECT_SELF) == RACIAL_TYPE_DROID)

    if(IsObjectPartyMember(OBJECT_SELF))
    {

        object oP0=GetPartyMemberByIndex(0);
        object oP1=GetPartyMemberByIndex(1);
        object oP2=GetPartyMemberByIndex(2);

        float fDown00 = 10.0;
        float fDown01 = 10.0;
        float fDown02 = 10.0;

        if(GetIsObjectValid(oP0) && GetRacialType(oP0) != RACIAL_TYPE_DROID)
        {
            fDown00 = IntToFloat(GetCurrentHitPoints(oP0)) / IntToFloat(GetMaxHitPoints(oP0));
        }
        if(GetIsObjectValid(oP1)&& GetRacialType(oP0) != RACIAL_TYPE_DROID)
        {
            fDown01 = IntToFloat(GetCurrentHitPoints(oP1)) / IntToFloat(GetMaxHitPoints(oP1));
        }
        if(GetIsObjectValid(oP2) && GetRacialType(oP0) != RACIAL_TYPE_DROID)
        {
            fDown02 = IntToFloat(GetCurrentHitPoints(oP2)) / IntToFloat(GetMaxHitPoints(oP2));
        }

        if(GetIsObjectValid(oP0) && !GetIsDead(oP0) && (fDown00 < 0.7 && fDown00 > 0.0))
        {
            // GN_MyPrintString("GENERIC DEBUG ***************  Return oP0");
            return oP0;
        }
        else if(GetIsObjectValid(oP1) && !GetIsDead(oP1) && (fDown00 < 0.7 && fDown00 > 0.0))
        {
            // GN_MyPrintString("GENERIC DEBUG ***************  Return oP1");
            return oP1;
        }
        else if(GetIsObjectValid(oP2) && !GetIsDead(oP2) && (fDown00 < 0.7 && fDown00 > 0.0))
        {
            // GN_MyPrintString("GENERIC DEBUG ***************  Return oP2");
            return oP2;
        }
    }
    else
    {
        float fNPC = IntToFloat(GetCurrentHitPoints(OBJECT_SELF)) / IntToFloat(GetMaxHitPoints(OBJECT_SELF));
        if(fNPC < 0.7)
        {
            return OBJECT_SELF;
        }
    }
    return OBJECT_INVALID;
}

//RWT-OEI 09/03/04
//Returns TRUE if any of the party members are knocked out.
//Only works if OBJECT_SELF is in the party.
int GN_CheckIfKnockedOut()
{

    object oCurPlayer;
    int i = 0;
    for (i = 0; i < 3; ++i )
    {
        oCurPlayer = GetPartyMemberByIndex(i);
        if ( GetIsObjectValid(oCurPlayer) )
        {
            if ( GetCurrentHitPoints(oCurPlayer) < 1 )
            {
                return TRUE;//Someone is knocked out
            }
        }
    }
    return FALSE;//No one is knocked out
}

//:://///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//:: Generic Talent Routines
//:: Copyright (c) 2001 Bioware Corp.
//::////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//::////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: June 12, 2002
//::////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int GN_TalentMasterRoutine(int nTalentConstant, object oTarget) {
    if(GetIsObjectValid(oTarget)) {
        talent tSpe11_01, tSpe11_02, tSpe11_03, tSpe11_04, tSpe11_05, tSpe11_06, tSpe11_07, tUse;
        int nTalent;
        int bValid = FALSE;
        int bHostile = FALSE;
        
        if(nTalentConstant == GEN_TALENT_SUPRESS_FORCE) {
            nTalent = 0xf021; //Any Area, No Harmful, Dispel, Ranged
        }
        else if(nTalentConstant == GEN_TALENT_REMOVE_POISON) {
            bValid = FALSE;
            tSpe11_01 = TalentSpell(FORCE_POWER_HEAL);
            // ST: Cure don't deal with poisons! Move Master Heal up here instead.
            tSpe11_02 = TalentSpell(FORCE_POWER_MASTER_HEAL); 
            tSpe11_03 = TalentSpell(67); //Remove Poison Item

            // DJS-OEI 12/11/2003
            //tSpe11_04 = TalentSpell(FORCE_POWER_MASTER_HEAL);
            if(GetCreatureHasTalent(tSpe11_01) || GetCreatureHasTalent(tSpe11_02)/* || GetCreatureHasTalent(tSpe11_04)*/ )
            {
                bValid = TRUE;
                if(GetCreatureHasTalent(tSpe11_01))
                {
                    tUse = tSpe11_01;
                }
                else if(GetCreatureHasTalent(tSpe11_02))
                {
                    tUse = tSpe11_02;
                }
                /*
                else if(GetCreatureHasTalent(tSpe11_04))
                {
                    tUse = tSpe11_04;
                }
                */
            }
            else if(GetCreatureHasTalent(tSpe11_03) && oTarget == OBJECT_SELF)
            {
                bValid = TRUE;
                tUse = tSpe11_03;
            }
            //nTalent = 0xff4f;
        }
        else if(nTalentConstant == GEN_TALENT_HEALING) {
            bValid = FALSE;
            if(GetRacialType(OBJECT_SELF) != RACIAL_TYPE_DROID) {
                tSpe11_05 = GetCreatureTalentBest(0x1408, 20);
            }
            else {
                tSpe11_05 = TalentSpell(128);
                if(!GetCreatureHasTalent(tSpe11_05)) {
                    tSpe11_05 = TalentSpell(127);
                    if (!GetCreatureHasTalent(tSpe11_05))
                        tSpe11_05 = TalentSpell(84);
                }
            }

            tSpe11_06 = TalentSpell(FORCE_POWER_DRAIN_LIFE);
            tSpe11_07 = TalentSpell(FORCE_POWER_DEATH_FIELD);
            tUse;
            bValid = FALSE;

            if (GN_CheckSeriesHeal()) 
            {
                bValid = TRUE;
                tUse = TalentSpell(GN_GetSeriesHeal());
            }
            else if (GetCreatureHasTalent(tSpe11_05)
                  || GetCreatureHasTalent(tSpe11_06)
                  || GetCreatureHasTalent(tSpe11_07))
            {
                if(oTarget == OBJECT_SELF) {
                    if(GetCreatureHasTalent(tSpe11_07) && !IsObjectPartyMember(OBJECT_SELF)) {
                        // I have Death Field
                        bValid = TRUE;
                        bHostile = TRUE;
                        tUse = tSpe11_07;
                    }
                    else if(GetCreatureHasTalent(tSpe11_06) && !IsObjectPartyMember(OBJECT_SELF)) {
                        // I have Drain Life
                        bValid = TRUE;
                        bHostile = TRUE;
                        tUse = tSpe11_06;
                    }
                    else {
                        // I have a Med Pack
                        bValid = TRUE;
                        tUse = tSpe11_05;
                    }
                }
            }
        }
        else if (nTalentConstant == GEN_TALENT_REVITALIZE) {
            int nID = GN_GetSeriesRevitalize();
            tUse = TalentSpell(nID);
            bValid = TRUE;
            bHostile = FALSE;
        }
        else if(nTalentConstant == GEN_TALENT_BUFF) {
            bValid = FALSE;
            
            // ST: ADDED(2005-09-21):
            //     Use stims in inventory to buff up with if I'm not a Force User.
            if (!GN_IsJedi(OBJECT_SELF) && ST_TalentBuffUseStims()) 
            	return TRUE;            
            
    		int nChainLightning, nPull, nHurricane, nStrike, nWeaken, nHold, nInferno, nLeech, nSapwill, nGrip, nContagion, nBlind, nStatic, nFreeze, nDestruct, nBombard;

    		int nLastForcePower = GetLastForcePowerUsed(OBJECT_SELF);
		// JD HLFP
		int nOmni, nProtect, nRegen, nEnergy, nInspire, nSpeed, nArmor, nMind, nResist, nForceImmunity, nBarrier, nBattleMeditation, nCnt = 0;
		talent tTemp;
    		if(JD_CheckSeriesOmni() && nLastForcePower != JD_GetSeriesOmni() )
    		{
        		nOmni = 1;
        		nCnt++;
    		}
    		if(JD_CheckSeriesProtect() && nLastForcePower != JD_GetSeriesProtect() )
    		{
        		nProtect = 1;
        		nCnt++;
    		}
    		if(JD_CheckSeriesRegen() && nLastForcePower != JD_GetSeriesRegen() )
    		{
       		nRegen = 1;
        		nCnt++;
    		}
    		if(JD_CheckSeriesEnergy() && nLastForcePower != JD_GetSeriesEnergy() )
    		{
        		nEnergy = 1;
        		nCnt++;
    		}
    		if(JD_CheckSeriesInspire() && nLastForcePower != JD_GetSeriesInspire() )
    		{
        		nInspire = 1;
        		nCnt++;
    		}
    		if(GN_CheckSeriesSpeed() && nLastForcePower != GN_GetSeriesSpeed() )
    		{
        		nSpeed = 1;
        		nCnt++;
    		}
    		if(GN_CheckSeriesArmor() && nLastForcePower != GN_GetSeriesForceArmor() )
    		{
        		nArmor = 1;
        		nCnt++;
    		}
    		if(GN_CheckSeriesMind() && nLastForcePower != GN_GetSeriesMind() )
    		{
        		nMind = 1;
        		nCnt++;
   		}
    		if(GN_CheckSeriesResist() && nLastForcePower != GN_GetSeriesResist() )
    		{
        		nResist = 1;
        		nCnt++;
   		}
    		if(GN_CheckSeriesForceImmunity() && nLastForcePower != GN_GetSeriesForceImmunity() )
    		{
        		nForceImmunity = 1;
        		nCnt++;
    		}
    		if(GN_CheckSeriesBarrier() && nLastForcePower != GN_GetSeriesBarrier() )
    		{
        		nBarrier = 1;
        		nCnt++;
    		}
    		if(GN_CheckSeriesBattleMeditation() && nLastForcePower != GN_GetSeriesBattleMeditation() )
    		{
        		nBattleMeditation = 1;
        		nCnt++;
    		}
    		int nRoll;
    		if(nCnt > 0)
    		{
        		nRoll = Random(nCnt) + 1;
    		}
    		else
    		{
        		nRoll = 0;
    		}
    		if(nOmni == 1 && nRoll == 1)
    		{
        		tTemp = TalentSpell( JD_GetSeriesOmni() );
        		nRoll--;
    		}
    		if(nOmni == 1 && nRoll > 1)
    		{
        		nRoll--;
    		}
    		if(nProtect == 1 && nRoll == 1)
    		{
        		tTemp = TalentSpell( JD_GetSeriesProtect() );
       		nRoll--;
    		}
    		if(nProtect == 1 && nRoll > 1)
    		{
        		nRoll--;
    		}
    		if(nRegen == 1 && nRoll == 1)
    		{
       		tTemp = TalentSpell( JD_GetSeriesRegen() );
        		nRoll--;
    		}
    		if(nRegen == 1 && nRoll > 1)
    		{
        		nRoll--;
    		}
    		if(nEnergy == 1 && nRoll == 1)
    		{
        		tTemp = TalentSpell( JD_GetSeriesEnergy() );
        		nRoll--;
    		}
    		if(nEnergy == 1 && nRoll > 1)
    		{
        		nRoll--;
    		}
    		if(nInspire == 1 && nRoll == 1)
    		{
        		tTemp = TalentSpell( JD_GetSeriesInspire() );
        		nRoll--;
    		}
    		if(nInspire == 1 && nRoll > 1)
    		{
       		 nRoll--;
    		}
    		if(nSpeed == 1 && nRoll == 1)
    		{
        		tTemp = TalentSpell( GN_GetSeriesSpeed() );
        		nRoll--;
    		}
    		if(nSpeed == 1 && nRoll > 1)
    		{
        		nRoll--;
    		}
    		if(nArmor == 1 && nRoll == 1)
    		{
       		tTemp = TalentSpell( GN_GetSeriesForceArmor() );
        		nRoll--;
    		}
    		if(nArmor == 1 && nRoll > 1)
    		{
        		nRoll--;
    		}
    		if(nMind == 1 && nRoll == 1)
    		{
        		tTemp = TalentSpell( GN_GetSeriesMind() );
        		nRoll--;
    		}
    		if(nMind == 1 && nRoll > 1)
    		{
        		nRoll--;
    		}
    		if(nResist == 1 && nRoll == 1)
    		{
        		tTemp = TalentSpell( GN_GetSeriesResist() );
        		nRoll--;
    		}
    		if(nResist == 1 && nRoll > 1)
    		{
        		nRoll--;
    		}
    		if(nForceImmunity == 1 && nRoll == 1)
    		{
        		tTemp = TalentSpell( GN_GetSeriesForceImmunity() );
        		nRoll--;
    		}
    		if(nForceImmunity == 1 && nRoll > 1)
    		{
        		nRoll--;
   		}
    		if(nBarrier == 1 && nRoll == 1)
    		{
        		tTemp = TalentSpell( GN_GetSeriesBarrier() );
        		nRoll--;
    		}
    		if(nBarrier == 1 && nRoll > 1)
    		{
        		nRoll--;
    		}
    		if(nBattleMeditation == 1 && nRoll == 1)
    		{
        		tTemp = TalentSpell( GN_GetSeriesBattleMeditation() );
        		nRoll--;
    		}
    		if(nBattleMeditation == 1 && nRoll > 1)
    		{
        		nRoll--;
    		}
            //Once we get to this point, if tTemp is VALID, then we
            //have picked out a potential buff to cast. Now see if its
            //effects are already active on the creature or not.
            //In order to do that we need to loop through the active effects
            //and see if they came from this specific talent.
            
            // ST: BUG! Scenario: PartyNPC1 has Improved Energy Resistance, but PartyNPC2
            //     has Master Energy Resistance. PartyNPC2 casts Master Energy Res, which affects
            //     PartyNPC1 as well. Now PartyNPC1 gets here with tTemp set to Improved Energy Resist,
            //     which PartyNPC1 casts. However, since the script of Improved Energy Resist detects
            //     a greater power in the same family already on PartyNPC1, it does nothing. Talent runs
            //     again, and since PNPC1 does not have Imp. Energy Res active the script tries to use it
            //     again, which fails, and again, and again and......
            //     SOLUTION: Check for higher power in samy family for AoE buffs such as Energy Resist,
            //     Valor, Battle Meditation (and for completeness Inspire Followers, though its unnessecary
            //     since only the protagonist can cast it in an unmodded game.

            if ( GetIsTalentValid( tTemp ))
            {
                int nSpellID = GetIdFromTalent(tTemp);
                effect eCurEffect = GetFirstEffect(OBJECT_SELF);
                int nCounter = 0;
                while ( GetIsEffectValid(eCurEffect) )
                {
                    nCounter++;
                    // ST: Check for presence of this or better powers instead, since they won't
                    //     override a better one at any rate. If so, skip using this talent.
                    if (ST_GetIsPowerOrBetterEffect(eCurEffect, nSpellID)) {
                        tTemp = TalentSpell(-1);//Set tTemp invalid
                        break;
                    }
                    eCurEffect = GetNextEffect(OBJECT_SELF);
                }
            }

            //If we get down to here, and tTemp is STILL valid, then it is
            //the spell we should cast
            if (GetIsTalentValid( tTemp)) {
                int nCost = GetSpellBaseForcePointCost(GetIdFromTalent(tTemp));
                if ( nCost <= GetCurrentForcePoints()) {
                    bValid = TRUE;
                    tUse = tTemp;
                }
            }

        }

        if((bValid == TRUE) && (bHostile == FALSE) && ST_ShouldUseDisablingPower(tUse, OBJECT_SELF)) {
            int nSpell = GetIdFromTalent(tUse);
            return ST_ActionUseTalent(tUse, OBJECT_SELF, FALSE);
        }
        else if(bValid == TRUE && bHostile == TRUE) {
            oTarget = GN_GetActivePartyMember(TRUE);
            if(GetIsObjectValid(oTarget) && ST_ShouldUseDisablingPower(tUse, oTarget)) {
                return ST_ActionUseTalent(tUse, oTarget);
            }
        }
        // ST: This is never used? WTF... Commenting it out.
        // talent tUse2 = GetCreatureTalentBest(nTalent, 20);
        
        // ST: Added filter check... though this part is probably bugged...
        if(GetIsTalentValid(tUse) 
        	&& ST_ShouldUseDisablingPower(tUse, OBJECT_SELF)
        	&& !GetHasSpellEffect(GetIdFromTalent(tUse)))
        {
            if(GetIsObjectValid(oTarget)) {
                return ST_ActionUseTalent(tUse, OBJECT_SELF, FALSE);
            }
        }
    }

    return FALSE;
}

//::///////////////////////////////////////////////
//:: Last Round Setup
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Sets the following struct up so that Last Rounds
    information is easier to access.

    int nLastAction;
    int nLastActionID;
    int nLastTalentCode;
    object oLastTarget;
    int nTalentSuccessCode;
    int nIsLastTargetDebil;
    int nLastCombo;
    int nLastComboIndex;
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Nov 26, 2002
//:://////////////////////////////////////////////

void GN_SetLastRoundData()
{
     talent tTalent;

     tPR.oLastTarget = ST_GetLastAttackTarget(); // GetLastHostileTarget();
     tPR.nIsLastTargetDebil = GetIsDebilitated(tPR.oLastTarget);
     tPR.nLastAction = GetLastAttackAction();
     if(tPR.nLastAction == ACTION_CASTSPELL)
     {
        tPR.nLastActionID = GetLastForcePowerUsed();
        tPR.nTalentSuccessCode = GetWasForcePowerSuccessful();
        tTalent = TalentSpell(tPR.nLastActionID);
        tPR.nLastTalentCode = GetCategoryFromTalent(tTalent);
     }
     else if(tPR.nLastAction == ACTION_ATTACKOBJECT)
     {
        tPR.nLastActionID = GetLastCombatFeatUsed();
        tPR.nTalentSuccessCode = GetLastAttackResult();
        tTalent = TalentFeat(tPR.nLastActionID);
        tPR.nLastTalentCode = GetCategoryFromTalent(tTalent);
     }
     //tPR.nLastCombo = GetLocalNumber(OBJECT_SELF, SW_NUMBER_LAST_COMBO);
     tPR.nLastComboIndex = GetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_INDEX);
     tPR.nCurrentCombo = GetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_ROUTINE);
}

//::///////////////////////////////////////////////
//:: Combo Sub Routine
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    This function determines what move to do
    based on the last part of the combo performed.
    int nLastAction;
    int nLastActionID;
    int nLastTalentCode;
    object oLastTarget;
    int nTalentSuccessCode;
    int nIsLastTargetDebil;
    int nLastCombo;
    int nLastComboIndex;
    int nCurrentCombo;
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Nov 27, 2002
//:://////////////////////////////////////////////
talent GN_GetComboMove(int nBoss = FALSE)
{
    int nRand;
    int nCombo;
    talent tUse;
    int nNPC_AI = GetNPCAIStyle(OBJECT_SELF); //Determines how the individual should react in combat
    // GN_MyPrintString("GENERIC DEBUG *************** Starting GetComboMove");

    // FAK - OEI 3/4/04
    // enemy droids with utitlies and no blasters, always use them
    object oItem =   GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON);

    if ( (GetLevelByClass(CLASS_TYPE_COMBATDROID) > 0 ||
                    GetLevelByClass(CLASS_TYPE_EXPERTDROID) > 0)
          && !GN_CheckNPCIsInParty(OBJECT_SELF)
          && !GetIsObjectValid(oItem)
        )
    {
        object oItem1 = GetItemInSlot(INVENTORY_SLOT_LEFTARM);
        object oItem2 = GetItemInSlot(INVENTORY_SLOT_RIGHTARM);
        int    bValid = 1;

        int iCooldown = GetLocalNumber(OBJECT_SELF, SW_NUMBER_COOLDOWN);
        int iCooldownThresh = GetLocalNumber(OBJECT_SELF, SW_NUMBER_COOLDOWN_FIRE);
        if (iCooldownThresh <= 0 || iCooldownThresh >= 10)
        {
            iCooldownThresh = 6;
        }
        if (GetIsObjectValid(oItem1))
        {
            nCombo = SW_COMBO_DROID_UTILITIES;
        }
        else if (GetIsObjectValid(oItem2))
        {
            nCombo = SW_COMBO_DROID_UTILITIES_2;
        }
        else
        {
            bValid = 0;
        }
        iCooldown = iCooldown + 1;
        SetLocalNumber(OBJECT_SELF, SW_NUMBER_COOLDOWN, iCooldown);
        if (bValid && iCooldown >= iCooldownThresh)
        {
            SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_INDEX, 3);
            SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_ROUTINE, nCombo);
            SetLocalNumber(OBJECT_SELF, SW_NUMBER_COOLDOWN, 0);

            return GN_GetNextTalentInCombo(nCombo);
        }
        else
        {
            SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_INDEX, 0);
            SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_ROUTINE, SW_COMBO_INVALID);
        }
    }

    //Is the last combo done?
    if(tPR.nLastComboIndex == 4 || tPR.nLastComboIndex == 0)
    {
        //If so then set the local numbers controlling the combo to 0;
        SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_INDEX, 0);
        SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_ROUTINE, 0);
        nRand = Random(6)+1;
        if(nRand > 0)//This nRand check is place here in case we need to limit combo use later
        {
            //If a Jedi use the jedi routines.
            if(GetLevelByClass(CLASS_TYPE_JEDICONSULAR) > 0 ||
               GetLevelByClass(CLASS_TYPE_JEDIGUARDIAN) > 0 ||
               GetLevelByClass(CLASS_TYPE_JEDISENTINEL) > 0 ||
               GetLevelByClass(CLASS_TYPE_JEDIWEAPONMASTER) > 0 ||  // DJS-OEI 8/19/2004
               GetLevelByClass(CLASS_TYPE_JEDIMASTER) > 0 ||
               GetLevelByClass(CLASS_TYPE_JEDIWATCHMAN) > 0 ||
               GetLevelByClass(CLASS_TYPE_SITHMARAUDER) > 0 ||
               GetLevelByClass(CLASS_TYPE_SITHLORD) > 0 ||
               GetLevelByClass(CLASS_TYPE_SITHASSASSIN) > 0 )
            {
                nCombo = GN_GetStandardJediCombo(nBoss);

                // GN_MyPrintString("GENERIC DEBUG *************** Starting Jedi Combo " + GN_FetchComboString(nCombo));

                SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_INDEX, 1);
                SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_ROUTINE, nCombo);

                return GN_GetNextTalentInCombo(nCombo);
            }
            //If a Droid use these routines
            else if(GetLevelByClass(CLASS_TYPE_COMBATDROID) > 0 ||
                    GetLevelByClass(CLASS_TYPE_EXPERTDROID) > 0)
            {
                nCombo = GN_GetStandardDroidCombo(nBoss);
                // GN_MyPrintString("GENERIC DEBUG *************** Starting Droid Combo " + GN_FetchComboString(nCombo));
                SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_INDEX, 1);
                SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_ROUTINE, nCombo);

                return GN_GetNextTalentInCombo(nCombo);
            }
            //All others.
            else
            {
                nCombo = GN_GetStandardNPCCombo(nBoss);
                // GN_MyPrintString("GENERIC DEBUG *************** Starting NPC Combo " + GN_FetchComboString(nCombo));
                SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_INDEX, 1);
                SetLocalNumber(OBJECT_SELF, SW_NUMBER_COMBO_ROUTINE, nCombo);

                return GN_GetNextTalentInCombo(nCombo);
            }
        }
        else//returning an invalid Talent here will mean action attack.
        {
            return tUse;
        }
    }
    else//if(tPR.nTalentSuccessCode > 0)
    {
        //If the PC is already in a combo then continue that combo
        // GN_MyPrintString("GENERIC DEBUG *************** Continuing Combo " + GN_FetchComboString(tPR.nCurrentCombo));
        return GN_GetNextTalentInCombo(tPR.nCurrentCombo);
    }
    return tUse;
}

//::///////////////////////////////////////////////
//:: Check Droid Utility Usage
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Checks the target and the droid utility use
    to make sure they are compatible
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: April 22, 2003
//:://////////////////////////////////////////////
talent GN_CheckDroidUtilityUsage(object oTarget, talent tUse)
{
    int bSwitch;
    // GN_MyPrintString("GENERIC DEBUG *************** Starting Droid Talent Double Check");
    if(GetTypeFromTalent(tUse) == TALENT_TYPE_FORCE)
    {
        // GN_MyPrintString("GENERIC DEBUG *************** Droid Talent is a Spell");
        int nTalentId = GetIdFromTalent(tUse);
        
        if(nTalentId == 116 || nTalentId == 117) //STUN RAY
        {
            if(GetRacialType(oTarget) == RACIAL_TYPE_HUMAN)
            {
                return tUse;
            }
            else
            {
                bSwitch = TRUE;
            }
        }
        
        // ST: Added check for Toxin emitters... droids can't be poisoned.
        if ((GetRacialType(oTarget) != RACIAL_TYPE_HUMAN) && ((nTalentId == 279) || (nTalentId == 280))) {
        	bSwitch = TRUE;	
        }
        
        if(nTalentId == 118 || nTalentId == 119) //SHIELD DISRUPTOR
        {
            if(GetHasSpellEffect(99, oTarget) || GetHasSpellEffect(100, oTarget) || GetHasSpellEffect(101, oTarget) ||
               GetHasSpellEffect(102, oTarget) || GetHasSpellEffect(103, oTarget) || GetHasSpellEffect(104, oTarget) ||
               GetHasSpellEffect(105, oTarget) || GetHasSpellEffect(106, oTarget) || GetHasSpellEffect(107, oTarget) ||
               GetHasSpellEffect(110, oTarget) || GetHasSpellEffect(111, oTarget) || GetHasSpellEffect(112, oTarget) ||
               GetHasSpellEffect(113, oTarget) || GetHasSpellEffect(114, oTarget) || GetHasSpellEffect(115, oTarget))
            {
                return tUse;
            }
            else
            {
            	// ST: It still does damage so use it sometimes, just not that often.
            	if (d4() > 3)
            		return tUse;
            		
                bSwitch = TRUE;
            }
        }
    }
    if(bSwitch == TRUE)
    {
        // DJS-OEI 4/26/2004
        // All of the Ranged combat Feats are 0x1111, not
        // 0x1181. This was causing droids, for instance,
        // to never use their Ranged Feats.
        //talent tFeat = GetCreatureTalentBest(0x1181, 20);
        // ST: Use Random instead of best, since it could get a bit repetitive...
        talent tFeat = GetCreatureTalentRandom(0x1111);
        
        // ST: ...and make sure the best of what was picked is used here instead.
        tFeat = ST_GetCorrectCombatFeat(tFeat);
        
        if(GetIsTalentValid(tUse) && GetCreatureHasTalent(tUse))
        {
            return tFeat;
        }
        else
        {
            talent Invalid;
            return Invalid;
        }
    }
    return tUse;
}

//::///////////////////////////////////////////////
//:: Throw Lightsaber Check
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Checks the target and the force power to make
    sure that a lightsaber is not thrown from close
    range.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: April 24, 2003
//:://////////////////////////////////////////////
talent GN_CheckThrowLightSaberUsage(object oTarget, talent tUse)
{
    int bSwitch = FALSE;
    if(GetTypeFromTalent(tUse) == TALENT_TYPE_FORCE)
    {
        if(GetIdFromTalent(tUse) == FORCE_POWER_LIGHT_SABER_THROW || GetIdFromTalent(tUse) == FORCE_POWER_LIGHT_SABER_THROW_ADVANCED)
        {
            // GN_MyPrintString("GENERIC DEBUG *************** Lightsaber Throw Check = " + FloatToString(GetDistanceBetween(OBJECT_SELF, oTarget),4,2));
            if(GetDistanceBetween(OBJECT_SELF, oTarget) < 10.0)
            {
                bSwitch = TRUE;
            }
        }
    }
    
    // ST: Added slight randomizer to saber throw since they seem to like doing it a lot...
    if (d4() < 2) {
    	bSwitch = TRUE;
    }
    
    if(bSwitch == TRUE)
    {
        talent tFeat = GetCreatureTalentBest(0x1104, 20);
        // ST: Use best of active combat feats...
        tFeat = ST_GetCorrectForceOrFeat(tFeat);
        if(GetIsTalentValid(tUse) && GetCreatureHasTalent(tUse))
        {
            return tFeat;
        }
        else
        {
            talent Invalid;
            return Invalid;
        }
    }
    return tUse;
}

//::///////////////////////////////////////////////
//:: Check Droid Force Power Usage
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Checks the force power and makes sure it can
    be used on a droid.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On:May 12, 2003
//:://////////////////////////////////////////////
talent GN_CheckNonDroidForcePower(object oTarget, talent tUse)
{
    int bSwitch = FALSE;
    if(GetTypeFromTalent(tUse) == TALENT_TYPE_FORCE)
    {
        if(GetIdFromTalent(tUse) == FORCE_POWER_HOLD ||
           GetIdFromTalent(tUse) == FORCE_POWER_HORROR ||
           GetIdFromTalent(tUse) == FORCE_POWER_INSANITY ||
           GetIdFromTalent(tUse) == FORCE_POWER_KILL ||
           GetIdFromTalent(tUse) == FORCE_POWER_PLAGUE ||
           GetIdFromTalent(tUse) == FORCE_POWER_SLEEP ||
           GetIdFromTalent(tUse) == FORCE_POWER_SLOW ||
           GetIdFromTalent(tUse) == FORCE_POWER_STUN ||
           GetIdFromTalent(tUse) == FORCE_POWER_WOUND ||
           GetIdFromTalent(tUse) == FORCE_POWER_AFFLICTION ||
           GetIdFromTalent(tUse) == FORCE_POWER_CHOKE ||
           GetIdFromTalent(tUse) == FORCE_POWER_DEATH_FIELD ||
           GetIdFromTalent(tUse) == FORCE_POWER_DRAIN_LIFE ||
           GetIdFromTalent(tUse) == FORCE_POWER_FEAR ||
           GetIdFromTalent(tUse) == FORCE_POWER_FORCE_SCREAM || // DJS-OEI 8/19/2004
           GetIdFromTalent(tUse) == FORCE_POWER_IMPROVED_FORCE_SCREAM || // DJS-OEI 8/19/2004
           GetIdFromTalent(tUse) == FORCE_POWER_MASTER_FORCE_SCREAM // DJS-OEI 8/19/2004
           )
        {
            if(GetRacialType(oTarget) == RACIAL_TYPE_DROID)
            {
                bSwitch = TRUE;
            }
        }
    }
    if(bSwitch == TRUE)
    {
        talent tFeat = GetCreatureTalentBest(0x1104, 20);
        tFeat = ST_GetCorrectCombatFeat(tFeat);
        if(GetIsTalentValid(tUse) && GetCreatureHasTalent(tUse))
        {
            return tFeat;
        }
        else
        {
            talent Invalid;
            return Invalid;
        }
    }
    return tUse;
}

//::///////////////////////////////////////////////
//:: Play Ambient Animations
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Play the correct animations based on the
    spawn in condition selected.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Dec 4, 2002
//:://////////////////////////////////////////////

void GN_PlayAmbientAnimation()
{
    if(!GetIsInConversation(OBJECT_SELF))
    {
        location lLocal;
        vector vFrnd;
        int nRoll = d2();
        object oFriend = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_FRIEND, OBJECT_SELF, nRoll, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
        if(!GetIsObjectValid(oFriend))
        {
            oFriend = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_NEUTRAL, OBJECT_SELF, nRoll, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
        }
        object oEnemy = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY);
        int nHDMe = GetHitDice(OBJECT_SELF);
        int nHDOther = GetHitDice(oFriend);

        if(!GN_CheckShouldFlee() || !GN_GetSpawnInCondition(SW_FLAG_COMMONER_BEHAVIOR))
        {
            if(GN_GetSpawnInCondition(SW_FLAG_AMBIENT_ANIMATIONS))
            {
                vFrnd = GetPosition(oFriend);
                nRoll = d6();
                if(GetIsObjectValid(oFriend) && GetDistanceBetween(oFriend, OBJECT_SELF) < 5.0 && !IsObjectPartyMember(oFriend))
                {
                    SetFacingPoint(vFrnd);
                    // GN_MyPrintString("GENERIC DEBUG *************** Clear 2600");
                    ClearAllActions();
                    if(nRoll == 1 || nRoll == 2)
                    {
                        ActionPlayAnimation(ANIMATION_LOOPING_TALK_NORMAL, 1.0, 3.0);
                    }
                    else if(nRoll == 3)
                    {
                        ActionPlayAnimation(ANIMATION_LOOPING_TALK_LAUGHING, 1.0, 3.0);
                    }
                    else if(nRoll == 4)
                    {
                        ActionPlayAnimation(ANIMATION_LOOPING_TALK_FORCEFUL, 1.0, 3.0);
                    }
                    else if(nRoll == 5)
                    {
                        ActionPlayAnimation(ANIMATION_FIREFORGET_HEAD_TURN_LEFT);
                    }
                    else if(nRoll == 6)
                    {
                        ActionPlayAnimation(ANIMATION_FIREFORGET_HEAD_TURN_RIGHT);
                    }
                }
                else
                {
                    nRoll = d8();
                    if(nRoll == 1)
                    {
                        ActionPlayAnimation(ANIMATION_FIREFORGET_PAUSE_BORED, 1.0);
                    }
                    else if(nRoll == 2)
                    {
                        ActionPlayAnimation(ANIMATION_FIREFORGET_PAUSE_SCRATCH_HEAD, 1.0);
                    }
                    else if(nRoll == 3)
                    {
                        ActionPlayAnimation(ANIMATION_LOOPING_PAUSE2, 1.0, 3.0);
                    }
                    else if(nRoll == 4 || nRoll == 5)
                    {
                        if(GetGender(OBJECT_SELF) == GENDER_MALE)
                        {
                            GN_SetSpawnInCondition(SW_FLAG_AMBIENT_ANIMATIONS, FALSE);
                            ActionPlayAnimation(ANIMATION_LOOPING_PAUSE3, 1.0, 20.4);
                            ActionDoCommand(GN_SetSpawnInCondition(SW_FLAG_AMBIENT_ANIMATIONS, TRUE));
                        }
                        else if(GetGender(OBJECT_SELF) == GENDER_FEMALE)
                        {
                            GN_SetSpawnInCondition(SW_FLAG_AMBIENT_ANIMATIONS, FALSE);
                            ActionPlayAnimation(ANIMATION_LOOPING_PAUSE3, 1.0, 13.3);
                            ActionDoCommand(GN_SetSpawnInCondition(SW_FLAG_AMBIENT_ANIMATIONS, TRUE));
                        }
                    }
                    else if(nRoll == 6)
                    {
                        ActionPlayAnimation(ANIMATION_FIREFORGET_HEAD_TURN_LEFT);
                    }
                    else if(nRoll == 7)
                    {
                        ActionPlayAnimation(ANIMATION_FIREFORGET_HEAD_TURN_RIGHT);
                    }
                    else if(nRoll == 8)
                    {
                        GN_SetSpawnInCondition(SW_FLAG_AMBIENT_ANIMATIONS, FALSE);
                        ActionPlayAnimation(ANIMATION_LOOPING_PAUSE2, 1.0, 5.0);
                        ActionDoCommand(GN_SetSpawnInCondition(SW_FLAG_AMBIENT_ANIMATIONS, TRUE));
                    }
                }
            }
            else if(GN_GetSpawnInCondition(SW_FLAG_AMBIENT_ANIMATIONS_MOBILE))
            {
                nRoll = d8();
                // GN_MyPrintString("GENERIC DEBUG *************** Clear 2700");
                ClearAllActions();
                if(nRoll == 1)
                {
                    ActionPlayAnimation(ANIMATION_LOOPING_PAUSE2, 1.0, 2.0);
                }
                else if(nRoll == 2)
                {
                    ActionPlayAnimation(ANIMATION_FIREFORGET_TAUNT, 1.0);
                }
                else if(nRoll == 3)
                {
                    //ActionPlayAnimation(ANIMATION_FIREFORGET_HEAD_TURN_LEFT, 0.75);
                    //ActionPlayAnimation(ANIMATION_FIREFORGET_HEAD_TURN_RIGHT, 0.75);
                }
                else if(nRoll == 4)
                {
                    ActionPlayAnimation(ANIMATION_FIREFORGET_VICTORY1, 1.0);
                }
                else if(nRoll >= 5)
                {
                    ActionRandomWalk();
                }
            }
        }
        else if(GN_CheckShouldFlee() && GN_GetSpawnInCondition(SW_FLAG_COMMONER_BEHAVIOR))
        {
            GN_CommonAI();
        }
    }
}
//::///////////////////////////////////////////////
//:: Commoner AI
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    If ever engaged in combat they will flee.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: July 18, 2002
//:://////////////////////////////////////////////
int GN_CommonAI()
{
    // GN_MyPrintString("GENERIC DEBUG *************** Start Commoner AI");
    object oEnemy = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY);
    object oFlee;
    int bValid = TRUE;
    int nIdx = 1;

    object oNeutral = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_NEUTRAL);
    while(GetIsObjectValid(oNeutral) && bValid == TRUE)
    {
        if(GetStandardFaction(oNeutral) == STANDARD_FACTION_HOSTILE_1 ||
            GetStandardFaction(oNeutral) == STANDARD_FACTION_HOSTILE_2 ||
            GetStandardFaction(oNeutral) == STANDARD_FACTION_INSANE)
        {
            if(GetDistanceBetween(OBJECT_SELF, oNeutral) <= 20.0)
            {
                oFlee = oNeutral;
                bValid = FALSE;
            }
            nIdx++;
            oNeutral = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_NEUTRAL, OBJECT_SELF, nIdx);
        }
        else
        {
            nIdx++;
            oNeutral = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_NEUTRAL, OBJECT_SELF, nIdx);
        }
    }

    if(GetIsObjectValid(oEnemy))
    {
        // GN_MyPrintString("GENERIC DEBUG *************** Clear 2710");
        ClearAllActions();
        ActionMoveAwayFromObject(oEnemy, TRUE, 20.0);
        DelayCommand(0.2, ActionDoCommand(GN_ActionDoPostDCRChecks()));
        return TRUE;
    }
    else if(GetIsObjectValid(oFlee))
    {
        // GN_MyPrintString("GENERIC DEBUG *************** Object Flee = " + GN_ReturnDebugName(oFlee));
        // GN_MyPrintString("GENERIC DEBUG *************** Clear 2720");
        ClearAllActions();
        ActionMoveAwayFromObject(oFlee, TRUE, 20.0);
        DelayCommand(0.2, ActionDoCommand(GN_ActionDoPostDCRChecks()));
        return TRUE;
    }
    return FALSE;
}
//::///////////////////////////////////////////////
//:: Should Commoner Flee
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Checks a number of conditions for a commoner
    to flee.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Dec 20, 2002
//:://////////////////////////////////////////////

int GN_CheckShouldFlee()
{
    int nIdx = 1;
    object oNeutral = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_NEUTRAL, OBJECT_SELF, 1, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
    object oHostile = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF, 1, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
    while(GetIsObjectValid(oNeutral) || GetIsObjectValid(oHostile))
    {
        if(GetIsObjectValid(oHostile))
        {
            return TRUE;
        }
        if(GetIsObjectValid(oNeutral))
        {
            if(GetStandardFaction(oNeutral) == STANDARD_FACTION_HOSTILE_1 ||
                GetStandardFaction(oNeutral) == STANDARD_FACTION_HOSTILE_2 ||
                GetStandardFaction(oNeutral) == STANDARD_FACTION_INSANE)
            {
                return TRUE;
            }
        }
        nIdx++;
        oNeutral = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_NEUTRAL, OBJECT_SELF, nIdx, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
    }
    return FALSE;
}

//::///////////////////////////////////////////////
//:: Reset Deactivated Droid
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Resets a Droid to his deactivated animation
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Feb 25, 2003
//:://////////////////////////////////////////////

void GN_ResetDroidDeactivationState(object oDroid = OBJECT_SELF)
{
    /*
    GN_SetSpawnInCondition(SW_FLAG_EVENT_ON_HEARTBEAT, FALSE);
    ClearAllActions();
    ActionPlayAnimation(ANIMATION_LOOPING_DEACTIVATE, 1.0, 900.0);
    ActionDoCommand(GN_SetSpawnInCondition(SW_FLAG_EVENT_ON_HEARTBEAT, TRUE));
    */
    ClearAllActions();
    ActionPlayAnimation(ANIMATION_LOOPING_DEACTIVATE, 1.0, -1.0);
    GN_SetSpawnInCondition(SW_FLAG_EVENT_ON_HEARTBEAT, FALSE);
}

//::///////////////////////////////////////////////
//:: Determine Attack Target
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Checks the nearest seen target and oIntruder
    for a valid attack target.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Oct 7, 2002
//:://////////////////////////////////////////////
object GN_DetermineAttackTarget(object oIntruder = OBJECT_INVALID) {

    int 	nPartyAI 	= GetPartyAIStyle();
    int 	nNPC_AI 	= GetNPCAIStyle(OBJECT_SELF);
    object 	oLastTarget = ST_GetLastAttackTarget(); // ST: Replaced GetLastHostileTarget();
    object 	oTarget;

    if(GetIsObjectValid(oIntruder) 
     // && !GetIsDebilitated(oIntruder)  // ST: Removed...
     	&& GetIsEnemy(oIntruder)
    	&& !GetIsDead(oIntruder))
    { 
        return oIntruder;
    }
    else if (GetIsObjectValid(oLastTarget) 
    	&& !GetIsDead(oLastTarget)
     // && !GetIsDebilitated(oLastTarget)
     	&& GetIsEnemy(oLastTarget)) // ST: Removed & added...
    {
        return oLastTarget;
    }
    else {
        if (nPartyAI == PARTY_AISTYLE_AGGRESSIVE) {
            int nCnt = 1;
            object oATarget = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF, nCnt, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
            oTarget = oATarget;
            while(/*!GetIsDebilitated(oTarget) && */GetIsObjectValid(oTarget)) { // ST: Removed...
                nCnt++;
                oTarget = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF, nCnt, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
            }
            if (!GetIsObjectValid(oTarget) && GetIsObjectValid(oATarget)) {
                oTarget = oATarget;
            }
        }
        else if (nPartyAI == PARTY_AISTYLE_DEFENSIVE) {
            int nCnt = 0;
            object oHostile;
            while (!GetIsObjectValid(oHostile) && (nCnt < 3)) {
                oHostile = GetLastHostileActor(GetPartyMemberByIndex(nCnt));
                nCnt++;
            }
            if(GetIsObjectValid(oHostile)) {
                oTarget = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF, 1, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
            }
            else {
                oHostile = GetLastHostileTarget(GetPartyMemberByIndex(0));
                if(GetIsObjectValid(oHostile)) 
                    oTarget = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF, 1, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
            }
        }
        else if(nPartyAI != PARTY_AISTYLE_PASSIVE) {
            oTarget = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF, 1, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
        }
        else {
            oTarget = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_ENEMY, OBJECT_SELF, 1, CREATURE_TYPE_PERCEPTION, PERCEPTION_SEEN);
        }
    }
    if(GetIsObjectValid(oTarget) && GetIsEnemy(oTarget)) { // ST: Added enemy check
        return oTarget;
    }

    return OBJECT_INVALID;
}

//::///////////////////////////////////////////////
//:: Return Talent Code
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    This function determines the state of the selected
    attack target and what should be done to them.
    If the target is last rounds target then they
    will try not to use failed attack types.

    NOTE: The functionality for area attacks and
    specialized talent use will be coded here.
    For the time being, I will just try to get
    the appropriate cascade of talents being used.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Oct 14, 2002
//:://////////////////////////////////////////////

int GN_GetAttackTalentCode(object oTarget) {

    int nPreviousTalentCode;

    if (!GetIsDead(oTarget) 
    	&& GetIsObjectValid(oTarget) 
    	&& !GetIsDebilitated(oTarget) 
    	&& /*GetLastHostileTarget()*/ ST_GetLastAttackTarget() == oTarget) // ST: Replaced...
    {
        nPreviousTalentCode = GN_GetPreviousTalentCode();
        if (GN_CompareTalents(nPreviousTalentCode, 0xf2ff)) {
            if (GN_GetHasViableTalent(0xff1f))
                return 0xff1f;

            if (GN_GetHasViableTalent(0x0100))
                return 0xf1ff;
        }
        else if (GN_CompareTalents(nPreviousTalentCode, 0xff1f)) {
            if (GN_GetHasViableTalent(0xf1f0))
                return 0xf1ff;
        }
    }
    else if (!GetIsDead(oTarget) 
    	&& GetIsObjectValid(oTarget) 
    	&& !GetIsDebilitated(oTarget) 
    	&& /*GetLastHostileTarget()*/ ST_GetLastAttackTarget() != oTarget) // ST: Replaced...
    {
        if(GN_GetHasViableTalent(0xf3ff))
            return 0xf3ff;

        if(GN_GetHasViableTalent(0xf2ff))
            return 0xf2ff;

        if(GN_GetHasViableTalent(0xff1f))
            return 0xff1f;

        if(GN_GetHasViableTalent(0xf1ff))
            return 0xf1ff;
    }
    else if (!GetIsDead(oTarget) 
    	&& GetIsObjectValid(oTarget) 
    	&& GetIsDebilitated(oTarget))
    {
        if(GN_GetHasViableTalent(0xf1ff))
            return 0xf1ff;
    }

    return 0xffff;
}

//this function was cut from the generics but is needed
//here to keep scripts from breaking.
void GN_SetDayNightPresence(int nPresenceSetting)
{

}

//RWT-OEI 07/16/04 - Set the amount of damage the exploding, floating
//mine will do.
void GN_SetFloatingMineDamage( int nDamage )
{
    SetLocalNumber( OBJECT_SELF, SW_NUMBER_HEALERAI_THRESHOLD, nDamage );
}

//RWT-OEI 07/16/04 - Set the Range that the mine will start seeking
void GN_SetFloatingMineSeekRange( int nRange )
{
    SetLocalNumber( OBJECT_SELF, SW_NUMBER_HEALERAI_PERCENTAGE, nRange );
}

//RWT-OEI 08/28/04 - GN_CheckRangeFromLeader()
//Keeps the party members within a certain number of meters
//from the party leader when they are in combat.
int GN_CheckRangeFromLeader(float fDistanceLimit)
{
    //This only works on party NPCs.
    if (!IsObjectPartyMember(OBJECT_SELF))
    {
        return 0;
    }

    object oLeader = GetPartyLeader();

    //Make sure we're not the party leader, though
    //this should never happen anyway
    if (OBJECT_SELF == oLeader)
    {
        return 0;
    }

    //Make sure we're not dead.
    if ( GetCurrentHitPoints(OBJECT_SELF) < 1 )
    {
        return 0;
    }

    //Compare distance
    float fCurDistance = GetDistanceToObject2D(oLeader);

    if ( fCurDistance <= fDistanceLimit )
    {
        //AurPostString( "Close enough.", 10,31,5.0f );
        return 0;//We're close enough.
    }

    //If we get here, we're too far from the party leader.
    //See if we are actively moving. If so, leave alone.
    //If not, make us move to leader.

    int nActionID = GetCurrentAction(OBJECT_SELF);

    if ( nActionID == ACTION_MOVETOPOINT )
    {
        //AurPostString( "Actively trying to move to leader.", 10, 34, 2.0f );
        //Leave alone
        return 1;
    }

    //If we get here, we're too far away and are not
    //actively moving, so need a new moveto action
    //AurPostString( "Moving to leader.", 10, 32, 2.0f );
    ClearAllActions();
    ActionMoveToObject(oLeader, TRUE, fDistanceLimit / 2.0f);

    return 1;
}

//RWT_OEI 09/08/04 - GN_CheckRangeFromOwner()
//Keeps party puppets within a certain number of meters from their
//owner when they are in combat.
int GN_CheckRangeFromOwner(float fDistanceLimit)
{

    //Only works on party puppets
    if ( !GetIsPuppet(OBJECT_SELF) )
    {
        return 0;
    }

    object oOwner = GetPUPOwner(OBJECT_SELF);

    if ( !GetIsObjectValid(oOwner) )
    {
        // AurPostString( "PUPAI - Unable to find owner. Major error",20, 30, 5.0f );
        return 0;
    }

    //Puppets can never die, so we don't need to bother checking if we're dead.
    //So now move on to comparing distances.
    float fCurDistance = GetDistanceToObject2D(oOwner);

    if ( fCurDistance <= fDistanceLimit )
    {
        //Close enough.
        return FALSE;
    }

    //If we get here, we're too far from the owner.
    //See if we are actively moving. If so, leave alone.
    //If not, make us follow the owner.

    int nActionID = GetCurrentAction(OBJECT_SELF);

    if ( nActionID == ACTION_MOVETOPOINT ||
         nActionID == ACTION_FOLLOWOWNER )
    {
        return TRUE;
    }

    //If we get here, we're too far away and are not
    //actively moving, so need a new followowner action.
    ClearAllActions();
    ActionFollowOwner(2.0f);

    return TRUE;
}

//RWT-OEI 08/28/04 - GN_RangedSupport
//Tries to use ranged weapons, but will switch to melee
//weapons if the 2nd config has melee and they are being
//attacked by someone using melee.
int GN_RunRangedSupportAIRoutine(object oIntruder)
{
    //This only works on party NPCs.
    if (!IsObjectPartyMember(OBJECT_SELF))
    {
        return 0;
    }

    object oLeader = GetPartyLeader();

    //Make sure we're not the party leader, though
    //this should never happen anyway
    if (OBJECT_SELF == oLeader)
    {
        return 0;
    }

    //Make sure we're not dead.
    if ( GetCurrentHitPoints(OBJECT_SELF) < 1 )
    {
        return 0;
    }

    //If this returns TRUE, then it is handling a weapon
    //swapping action this round and we shouldn't do
    //anything else.
    //RWT-OEI 11/01/04 - Only check this if we're in Ranged
    //Suport Mode
    int nCurAI = GetNPCAIStyle(OBJECT_SELF);
    if ( nCurAI == NPC_AISTYLE_PARTY_RANGED )
    {
        if ( GN_CheckRangedPreferred() )
        {
            return 0;
        }
    }

	// ST: 25% chance for Party Members to try to lob a grenade or launch a rocket
	//     if equipped with a rocket launcher (ie Mira). (2005-06-10)
	if ((nCurAI == NPC_AISTYLE_PARTY_RANGED) && !GetSoloMode() && IsObjectPartyMember(OBJECT_SELF)) {
		if ((d4() > 1) && ST_GetHasRocketLauncher()) {
			object oTarget = ST_FindPartyGrenadeTarget();
			object oLeader = GetPartyLeader();
			float fModDist = 30.0;
			
			// ST: Don't pick another target here if the GrenadeTarget function did
			//     not find a target, or we lose all situational awareness to not
			//     blow up partymembers too.
			/*
	    	if (!GetIsObjectValid(oTarget) 
	    		|| GetIsDead(oTarget)
	    		|| !GetIsEnemy(oTarget)
	    		|| !GetObjectSeen(oTarget)
	    		|| (GetDistanceBetween2D(oLeader, oTarget) > fModDist))
	    	{
	    		oTarget = OBJECT_INVALID;
	    		if (GetIsObjectValid(oIntruder) 
	    			&& !GetIsDead(oIntruder)
	    			&& GetIsEnemy(oIntruder)
	    			&& GetObjectSeen(oIntruder)
	    			&& (GetDistanceBetween2D(oLeader, oIntruder) <= fModDist)) 
	    		{
	    			oTarget = oIntruder;
	    		}
	    	}
	    	*/	
	    	
	    	// ST: Do standard AI if no valid target was found.
	    	if (!GetIsObjectValid(oTarget))
	    		return GN_RunDefaultAIRoutine(oIntruder);		
			
			talent tUse = GN_GetGrenadeTalent((GetRacialType(oTarget) == RACIAL_TYPE_DROID));			
			
			// ST: Added filter checks...
	        if(GetIsObjectValid(oTarget) 
	        	&& GetIsTalentValid(tUse) 
	        	&& GetCreatureHasTalent(tUse)
	        	&& ST_ShouldUseDisablingPower(tUse, oTarget)
	        	&& !GetHasSpellEffect(GetIdFromTalent(tUse), oTarget)) 
	        {
	            return ST_ActionUseTalent(tUse, oTarget);
	        }			
		}
	}

    //If we get here, we need to just go ahead with our normal
    //attack behaviors.
    // ST: ...and return the success/failure of that operation.
    return GN_RunDefaultAIRoutine(oIntruder);
}

//RWT-OEI 08/28/04
//For Party NPCs, will determine if they should switch
//to a Melee configuration or ranged configuration if
//the options are available to them.
//Return 1 if we weren't using the right weapon but were
//able to queue an action to correct it.
//Return 0 if we are using the right weapon or were unable
//to find a better configuration.
int GN_CheckRangedPreferred()
{

    //The main point of this AI function is to
    //try and use ranged as much as possible.
    //So... if we haven't been attacked by
    //melee for X rounds, switch to ranged if we have it
    //If we have been attacked by melee in the last
    //X rounds, switch to melee if we have it.
    //I'm using the LocalNumbers I added for HealerAI
    //since we're not on healer AI if we're here, obviously.
    //int SW_NUMBER_HEALERAI_THRESHOLD = 8;
    //int SW_NUMBER_HEALERAI_PERCENTAGE = 9;
    //1 = Melee
    //2 = Ranged
    int nHitByMelee = GetLocalNumber(OBJECT_SELF, SW_NUMBER_HEALERAI_THRESHOLD);
    if ( nHitByMelee > 0 )
    {
        //AurPostString( "We have been hit by melee.", 20,21,2.0f);
        nHitByMelee--;
        SetLocalNumber(OBJECT_SELF, SW_NUMBER_HEALERAI_THRESHOLD, nHitByMelee);

        //Make sure we are using melee weapons right now
        object oWeapon = GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON);
        int nType = 0;

        if ( GetIsObjectValid(oWeapon))
        {
            nType = GN_GetWeaponTypeFromBaseItem(GetBaseItemType(oWeapon));
        }
        //AurPostString( IntToString(nType),20,22,2.0f);
        if ( nType == 2 )
        {
            //We are using ranged but getting hit by melee. See if we
            //should switch to the second config
            object oWeapon2 = GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON2);
            int nType2 = 0;
            if ( GetIsObjectValid(oWeapon2) )
            {
                nType2 = GN_GetWeaponTypeFromBaseItem(GetBaseItemType(oWeapon2));
            }
            //AurPostString( IntToString(nType2),20,23,2.0f);
            if ( nType2 != 2 )
            {
                //Our second config is NOT ranged, switch to it
                //AurPostString( "Ranged ----> Melee",20,24,2.0f);
                ClearAllActions();
                ActionSwitchWeapons();
                return 1;
            }
            //Otherwise the other slot is no better, can't do anything.
        }//Otherwise we're not using ranged right now, so stick with what
         //we're using.
     }
     else
     {  //If we haven't been hit by Melee in the last X number of rounds
        //(see KOTOR_HENCH_EVENT_ON_ATTACKED in k_ai_master for the exact
        //number of rounds) then make sure we're using a ranged configuration
        //if we have one
        //AurPostString( "We have not been hit by melee recently", 20, 25, 2.0f);
        object oWeapon = GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON);
        int nType = 0;
        if ( GetIsObjectValid(oWeapon))
        {
            nType = GN_GetWeaponTypeFromBaseItem(GetBaseItemType(oWeapon));
        }

        //AurPostString(IntToString(nType),20,26,2.0f);
        if ( nType != 2 )
        {
            //We're not using a ranged weapon right now, so see if we have
            //ranged in our other config
            object oWeapon2 = GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON2);
            int nType2 = 0;
            if ( GetIsObjectValid(oWeapon2) )
            {
                nType2 = GN_GetWeaponTypeFromBaseItem(GetBaseItemType(oWeapon2));
            }
            //AurPostString(IntToString(nType2),20,27,2.0f);
            if ( nType2 == 2 )
            {
                //2nd slot has ranged, so switch to it.
                //AurPostString( "Melee ----> Ranged",20,28,2.0f);
                ClearAllActions();
                ActionSwitchWeapons();
                return 1;
            }
        }//Otherwise our other slot doesn't have ranged either
    }//Otherwise we're already using ranged
    //AurPostString( "Couldn't improve any",20,29,2.0f);
    //If we get here, there was nothing we could do here or
    //everything was already ideal, so just return 0.
    return 0;
}

//RWT-OEI 08/28/04 - GN_IsJedi
//Returns true if the object passed in has one
//of the many Jedi classes.
int GN_IsJedi(object oObject )
{
    if ( GetLevelByClass(CLASS_TYPE_JEDICONSULAR) > 0 )
        return 1;

    if ( GetLevelByClass(CLASS_TYPE_JEDIGUARDIAN) > 0 )
        return 1;

    if ( GetLevelByClass(CLASS_TYPE_JEDISENTINEL) > 0)
        return 1;

    if ( GetLevelByClass(CLASS_TYPE_JEDIWEAPONMASTER) > 0 )
        return 1;

    if ( GetLevelByClass(CLASS_TYPE_JEDIMASTER) > 0 )
        return 1;

    if ( GetLevelByClass(CLASS_TYPE_JEDIWATCHMAN) > 0 )
        return 1;

    if ( GetLevelByClass(CLASS_TYPE_SITHMARAUDER) > 0 )
        return 1;

    if ( GetLevelByClass(CLASS_TYPE_SITHLORD) > 0 )
        return 1;

    if ( GetLevelByClass(CLASS_TYPE_SITHASSASSIN) > 0 )
        return 1;

    return 0;//Not a Jedi.
}

//RWT-OEI 09/08/04
//GN_RuNDefaultPuppetAIRoutine()
//This function decides and executes all
//functions that are not related to staying close
//to the owner.
//In otherwords, the AI should never get to this
//function unless they are already safely within
//range of their owner
int GN_RunDefaultPuppetAIRoutine(object oIntruder)
{
    //AurPostString( "Default Puppet AI", 20, 20, 2.0f );
    //If we're not a party puppet, just run default AI routines
    if ( !GetIsPuppet(OBJECT_SELF) )
    {
        GN_RunDefaultAIRoutine(oIntruder);
        return 0;
    }

    //If the owner is disabled, don't do anything
    object oOwner = GetPUPOwner(OBJECT_SELF);

    if ( !GetIsObjectValid(oOwner) )
    {
        return 0;//This is a major error
    }

    if ( GetCurrentHitPoints(oOwner) < 1 )
    {
        //Owner is disabled, so shut down
        //AurPostString( "Owner is down.", 20, 22, 2.0f );
        ClearAllActions();
        return 0;
    }
    else
    {
        //AurPostString( "Owner has HP: " + IntToString(GetCurrentHitPoints(oOwner)), 20, 21, 2.0f);
    }

    //First priority is to heal any droids in the party that are in need
    //of healing.
    //This var is used to determine which droid
    //in the party to heal, if any.
    object oHealDroid = OBJECT_INVALID;

    int nThreshold = GetLocalNumber(OBJECT_SELF, SW_NUMBER_HEALERAI_THRESHOLD);
    int nRand = Random(200) % 2;
    if ( nThreshold > 0  && nRand == 1)
    {
        //Check to see if any of the party member droids are damaged.
        //AurPostString( "Checking need to heal.", 20, 20, 4.0f );
        int i = 0;
        for (i = 0; i < 3; ++i )
        {
            object oMember = GetPartyMemberByIndex(i);
            if ( GetIsObjectValid(oMember) )
            {
                if ( GetRacialType(oMember) == RACIAL_TYPE_DROID )
                {
                    int nCurrentHP = GetCurrentHitPoints(oMember);
                    int nMaxHP = GetMaxHitPoints(oMember);

                    int nPercentage = (nCurrentHP * 100) / nMaxHP;

                    if ( nPercentage < nThreshold && nCurrentHP > 0 )
                    {
                        // AurPostString( "Found wounded droid in party:" + IntToString(nPercentage) + "/" + IntToString( nThreshold ), 20, 21, 4.0f );
                        //Make sure they're within 10 meters.
                        //TODO: Enable this check once we're confident in the rest.

                        if ( GetDistanceToObject2D(oMember) <= 10.0f )
                        {
                           // AurPostString( "Setting ohealdroid to:" + GetTag(oMember),20,24,4.0f );
                            oHealDroid = oMember;
                            //break;
                        }
                    }
                }
            }
        }

        //AurPostString( "Damaged droid is: " + GetTag(oHealDroid), 20, 25, 4.0f );
        if ( GetIsObjectValid(oHealDroid) )
        {
            ClearAllActions();
            //AurPostString( "Attempting to heal.", 20, 22, 4.0f );
            //If we get here, then we have a valid droid in the party that
            //is in need of healing. Go ahead and take care of it.
            int nHealAmount = GetLocalNumber(OBJECT_SELF, SW_NUMBER_HEALERAI_PERCENTAGE);
            if ( nHealAmount < 1 )
            {
                nHealAmount = 10;
            }

            //Face the right direction
            SetFacingPoint(GetPosition(oHealDroid));

            int nCurrentHP = GetCurrentHitPoints(oHealDroid);
            int nMaxHP = GetMaxHitPoints(oHealDroid);

            //Don't heal over 100% health.
            if ( (nMaxHP - nCurrentHP ) < nHealAmount )
            {
                nHealAmount = nMaxHP - nCurrentHP;
            }

            effect eHeal = EffectHeal( nHealAmount );
            ApplyEffectToObject( DURATION_TYPE_INSTANT, eHeal, oHealDroid);

            effect eBeam = EffectBeam( VFX_BEAM_STUN_RAY, OBJECT_SELF, BODY_NODE_HAND);

            ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eBeam, oHealDroid, 1.0f );

            effect eHealField = EffectVisualEffect( 1048 );

            ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eHealField, oHealDroid, 3.0f );

            //Jump out now as this was our action for this round.
            return 0;
        }
    }

    //If owner is in combat, attack his target by default
    if ( !GetIsInCombat(oOwner) )
    {
        return 0;//Don't do any attacks if the owner isn't in combat.
    }

    object oTarget = GetLastHostileTarget(oOwner);

    if ( GetIsObjectValid( oTarget ) && GetObjectSeen(oTarget,OBJECT_SELF))
    {
        //AurPostString( "Ordering an attack.", 20, 23, 2.0f );
        //We have a valid target. Go ahead and attack it too.
        ActionAttack(oTarget);
        ST_SetLastAttackTarget(oTarget);
    }

    return 0;
}


// ------------------------------------------------------------------
// ST: Added this function to handle Special Droid Weapons.
// ------------------------------------------------------------------
int ST_RunBotAIRoutine(object oIntruder) {
	
	// ST: Special case - Use T3M4s renewable shield if present and it's not already active.
	//     Since it has infinite uses the only thing you have to lose is a combat round...
	if (IsObjectPartyMember(OBJECT_SELF)
		&& (GetTag(GetItemInSlot(INVENTORY_SLOT_BELT)) == "d_t3m4_03") 
		&& !GetHasSpellEffect(114)) 
	{
		talent tShield = TalentSpell(114);
		if (GetIsTalentValid(tShield) && GetCreatureHasTalent(tShield)) {
			// DebugMessage("BotAIRoutine - Using T3M4s renewable shield!");
        	return ST_ActionUseTalent(tShield, OBJECT_SELF, FALSE);
		}
	}
	
	// ST: Use new target filtering routine...
	oIntruder = ST_SelectAttackTarget(oIntruder);
	int bShockOnly = ST_HasOnlyDroidShockArm();
	
	// ST: Pick attack form... 25% chance of using default attack instead of droid special.
	// ST: 2006-07-17 - ...but not if I have a shock arm but no conventional weapons equipped.
	if ((d4() > 3) && !bShockOnly) {
		// DebugMessage("BotAIRoutine - Randomizer Fallthrough to DefaultAI, shouldn't exclusively use SPABs!");
		return GN_RunDefaultAIRoutine(oIntruder);	
	}
		
	object oTarget 	= GN_DetermineAttackTarget(oIntruder);
	talent tUse 	= GetCreatureTalentRandom(0x8000);
	talent tTemp;
    
    // ST: 25% chance of using a droid weapon instead of a ranged combat feat.
    //     Exception: T3M4's shock arm, it has a 50% chance of being used since it has infinite charges.    
    if(GetIsTalentValid(tUse) 
    	&& ((d4() > 3) || ((d4() > 2) && (GetTypeFromTalent(tUse) == TALENT_TYPE_FORCE) && (GetIdFromTalent(tUse) == 278)))) 
    {
    	// DebugMessage("BotAIRoutine - Found a valid bot weapon to use! id=" + IntToString(GetIdFromTalent(tUse)));
    }
	else  {
		// ST: 2006-07-17 - If having no weapons but a shock arm, use it instead of a combat feat!
		if (bShockOnly) {
			tUse = TalentSpell(278);
		}
		else {
        	tUse = GetCreatureTalentRandom(0x1111);
	    	tUse = ST_GetCorrectCombatFeat(tUse); 
	    	// DebugMessage("BotAIRoutine - Picking a combat feat to use, if any available. id=" + IntToString(GetIdFromTalent(tUse)));	          
		}
    }	
	
	// ST: No need to check AI style here since you can only get to this
	//     function by using the proper AI style...
    if (GetIsTalentValid(tUse) && IsObjectPartyMember(OBJECT_SELF)) {
    	object oLeader = GetPartyLeader();
    	float fModDist = ST_DEFENSIVE_RADIUS - 0.5;
    	
    	if (GetIsTalentValid(tUse) && (GetTypeFromTalent(tUse) == TALENT_TYPE_FORCE)) {
    		// DebugMessage("BotAIRoutine - Droid weapon used! Adding +10m to radius...");
    		fModDist += 10.0;
    	}
    	else {
    		fModDist += ST_GetAttackRange();	
    		// DebugMessage("BotAIRoutine - Normal weapon used! New attack radius is " + FloatToString(fModDist, 4, 1));
    	}
    	
		oTarget = ST_GetTargetInRange(fModDist, oTarget, oIntruder);	
    	
	    // ST: SPECIAL CASE! A bit hackish but, have to put down here since the target is 
	    //     needed for checking if it's a droid...
	    //     Check if I have G0T0's DROID SRAMBLER and if selected target is another bot!
	    if ((d4() > 3)
	    	&& (GetRacialType(oTarget) == RACIAL_TYPE_DROID)
	    	&& GetIsObjectValid(oTarget)
	    	&& GetIsEnemy(oTarget)
	    	&& GetHasFeat(234)
	    	&& !GetHasSpellEffect(FORCE_POWER_DROID_TRICK, oTarget)
	    	&& !GetHasFeatEffect(234, oTarget)
	    	&& ST_ShouldUseDisablingPower(tUse, oTarget)) 
	    {
	    	// ST: These feats can't be used by the talent functions for some reason. 
	    	//     The creature just stands there doing nothing. This workaround should do for now...
	    	ClearAllActions();
	    	ActionCastSpellAtObject(FORCE_POWER_DROID_TRICK, oTarget, 0 , TRUE);	
			return TRUE;
	    } 	       	
    	
    	// ST: Check if the bot weapon is worth using on the enemy.
    	tUse = GN_CheckDroidUtilityUsage(oTarget, tUse);
    	
    	/*
		DebugMessage("BotAIRoutine - DONE WITH CHECK, trying to use talent id " 
			+ IntToString(GetIdFromTalent(tUse)) 
			+ "("
			+ (GetTypeFromTalent(tUse) == 0 ? "force" : "feat")
			+ ") on target "
			+ GetName(oTarget));
		*/
    }   
    
    if(GetIsObjectValid(oTarget) 
    	&& GetIsEnemy(oTarget)
    	&& GetIsTalentValid(tUse) 
    	&& ST_ShouldUseDisablingPower(tUse, oTarget)) 
    {
        return ST_ActionUseTalent(tUse, oTarget);
    }        	   	
    
    // ST: No special case applicable. Dwooo... Use standard attack instead.
	return GN_RunDefaultAIRoutine(oIntruder);
}