#include "jd_force_include"

void main()
{
    int nDC;
    int nDamage;
    float fRadius;
 
    object oTarget;
    int nTrapID = GetTrapBaseType(OBJECT_SELF);
    location lTrap = GetLocation(OBJECT_SELF);
    object oCaster = GetTrapCreator(OBJECT_SELF);

    int nMinorDMG = JD_GetDemoDMG(1,40,oCaster);
    int nAverageDMG = JD_GetDemoDMG(2,80,oCaster);
    int nStrongDMG = JD_GetDemoDMG(3,120,oCaster);
    int nDeadlyDMG = JD_GetDemoDMG(4,160,oCaster);
    int nDevaDMG = JD_GetDemoDMG(5,200,oCaster);
    int nTopDMG = JD_GetDemoDMG(6,240,oCaster);

    int nMinorDC = JD_GetDemoDC(15,oCaster,oTarget);
    int nAverageDC = JD_GetDemoDC(20,oCaster,oTarget);
    int nStrongDC = JD_GetDemoDC(25,oCaster,oTarget);
    int nDeadlyDC = JD_GetDemoDC(30,oCaster,oTarget);
    int nDevaDC = JD_GetDemoDC(35,oCaster,oTarget);
    int nTopDC = JD_GetDemoDC(40,oCaster,oTarget);

    float fMinor = JD_GetDemoRadius(0.1,3.0,oCaster);
    float fAverage = JD_GetDemoRadius(0.2,3.0,oCaster);
    float fStrong = JD_GetDemoRadius(0.3,3.0,oCaster);
    float fDeadly = JD_GetDemoRadius(0.4,3.0,oCaster);
    float fDeva = JD_GetDemoRadius(0.5,3.0,oCaster);
    float fTop = JD_GetDemoRadius(0.6,3.0,oCaster);

    Db_PostString("Trap Fired", 5,5,4.0);
    //FLASH STUN MINE
    if( nTrapID == TRAP_BASE_TYPE_FLASH_STUN_MINOR ||
        nTrapID == TRAP_BASE_TYPE_FLASH_STUN_AVERAGE ||
        nTrapID == TRAP_BASE_TYPE_FLASH_STUN_STRONG ||
        nTrapID == TRAP_BASE_TYPE_FLASH_STUN_DEADLY ||
        nTrapID == TRAP_BASE_TYPE_FLASH_STUN_DEVASTATING)
    {
        //The only difference between the flash traps is the DC.  Therefore I am
        //using 1 section of the if statement.
        if(nTrapID == TRAP_BASE_TYPE_FLASH_STUN_MINOR) {nDC = 15 ;}
        if(nTrapID == TRAP_BASE_TYPE_FLASH_STUN_AVERAGE) {nDC = 20 ;}
        if(nTrapID == TRAP_BASE_TYPE_FLASH_STUN_STRONG) {nDC = 25 ;}
        if(nTrapID == TRAP_BASE_TYPE_FLASH_STUN_DEADLY) {nDC = 30 ;}
        if(nTrapID == TRAP_BASE_TYPE_FLASH_STUN_DEVASTATING) {nDC = 35 ;}

        // DJS-OEI 1/27/2004
        // Increase the radius for each rank in Demolitions
        float fRadius = 3.3;
        int nDemoSkill = GetOwnerDemolitionsSkill( OBJECT_SELF );
        if( nDemoSkill > 0 ) {
            fRadius += 0.1 * nDemoSkill;
        }

        //RWT-OEI 05/24/04 - +1 to the DC per 5 points of Demolitions Skill
        nDC += (nDemoSkill / 5);

        effect eStun = EffectStunned();
        eStun = SetEffectIcon(eStun, 63 );//RWT-OEI 07/08/04 - Added effect for this
        oTarget = GetFirstObjectInShape(SHAPE_SPHERE, fRadius, lTrap, TRUE);
        while(GetIsObjectValid(oTarget))
        {
            if(GetIsEnemy(oTarget,OBJECT_SELF) && !GetIsNeutral(oTarget) )
            {
            	if(!WillSave(oTarget, 15) && GetRacialType(oTarget) != RACIAL_TYPE_DROID && !GetIsNeutral(oTarget, OBJECT_SELF))
            	{
                		ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStun, oTarget, RoundsToSeconds(3));
            	}
            	oTarget = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lTrap, TRUE);
		}
        }
    }
    //FRAGMENTATION MINE
    else if(nTrapID == TRAP_FRAGMENTATION_MINE_MINOR  ||
            nTrapID == TRAP_FRAGMENTATION_MINE_AVERAGE ||
            nTrapID == TRAP_FRAGMENTATION_MINE_STRONG ||
            nTrapID == TRAP_FRAGMENTATION_MINE_DEADLY ||
            nTrapID == TRAP_FRAGMENTATION_MINE_DEVASTATING )
    {
        effect eDamage;

        if(nTrapID == TRAP_FRAGMENTATION_MINE_MINOR) {nDamage = nMinorDMG; nDC = nMinorDC; fRadius = fMinor;}
        if(nTrapID == TRAP_FRAGMENTATION_MINE_AVERAGE) {nDamage = nAverageDMG; nDC = nAverageDC; fRadius = fAverage;}
        if(nTrapID == TRAP_FRAGMENTATION_MINE_STRONG) {nDamage = nStrongDMG; nDC = nStrongDC; fRadius = fStrong;}
        if(nTrapID == TRAP_FRAGMENTATION_MINE_DEADLY) {nDamage = nDeadlyDMG; nDC = nDeadlyDC; fRadius = fDeadly;}
        if(nTrapID == TRAP_FRAGMENTATION_MINE_DEVASTATING) {nDamage = nDevaDMG; nDC = nDevaDC; fRadius = fDeva;}

        oTarget = GetFirstObjectInShape(SHAPE_SPHERE, fRadius, lTrap, TRUE);
        while(GetIsObjectValid(oTarget))
        {
            if(GetIsEnemy(oTarget,OBJECT_SELF) && !GetIsNeutral(oTarget) )
            {
                int nDamageNew = GetReflexAdjustedDamage(nDamage, oTarget, nDC);
                eDamage = EffectDamage(nDamageNew, DAMAGE_TYPE_PIERCING);
                ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
            }
            oTarget = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lTrap, TRUE);
        }
    }
    //LASER SLICING TRAP - THIS IS NOW THE PLASMA MINE
    else if(nTrapID == TRAP_PLASMA_MINOR ||
            nTrapID == TRAP_PLASMA_AVERAGE ||
            nTrapID == TRAP_PLASMA_STRONG ||
            nTrapID == TRAP_PLASMA_DEADLY ||
            nTrapID == TRAP_PLASMA_DEVASTATING )
    {
        ApplyEffectAtLocation(DURATION_TYPE_INSTANT, EffectVisualEffect(1044),GetLocation(OBJECT_SELF));

        effect eDamage;

        if(nTrapID == TRAP_PLASMA_MINOR) {nDamage = nMinorDMG; nDC = nMinorDC; fRadius = fMinor;}
        if(nTrapID == TRAP_PLASMA_AVERAGE) {nDamage = nAverageDMG; nDC = nAverageDC; fRadius = fAverage;}
        if(nTrapID == TRAP_PLASMA_STRONG) {nDamage = nStrongDMG; nDC = nStrongDC; fRadius = fStrong;}
        if(nTrapID == TRAP_PLASMA_DEADLY) {nDamage = nDeadlyDMG; nDC = nDeadlyDC; fRadius = fDeadly;}
        if(nTrapID == TRAP_PLASMA_DEVASTATING) {nDamage = nDevaDMG; nDC = nDevaDC; fRadius = fDeva;}

        oTarget = GetFirstObjectInShape(SHAPE_SPHERE, fRadius, lTrap, TRUE);
        while(GetIsObjectValid(oTarget))
        {
            if(GetIsEnemy(oTarget,OBJECT_SELF) && !GetIsNeutral(oTarget) )
            {
                int nDamageNew = GetReflexAdjustedDamage(nDamage, oTarget, nDC);
                eDamage = EffectDamage(nDamageNew, DAMAGE_TYPE_BLASTER);
                ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
            }
            oTarget = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lTrap, TRUE);
        }
    }
    //GAS POISON TRAP
    else if(nTrapID == TRAP_BASE_TYPE_POISON_GAS_MINOR ||
            nTrapID == TRAP_BASE_TYPE_POISON_GAS_AVERAGE ||
            nTrapID == TRAP_BASE_TYPE_POISON_GAS_STRONG ||
            nTrapID == TRAP_BASE_TYPE_POISON_GAS_DEADLY ||
            nTrapID == TRAP_BASE_TYPE_POISON_GAS_DEVASTATING )
    {
        effect ePoison;
        //The only difference between the poison traps is the poison type.  Therefore I am
        //using 1 section of the if statement.
        if(nTrapID == TRAP_BASE_TYPE_POISON_GAS_MINOR) {ePoison = EffectPoison(POISON_DAMAGE_MILD);}
        if(nTrapID == TRAP_BASE_TYPE_POISON_GAS_AVERAGE) {ePoison = EffectPoison(POISON_DAMAGE_AVERAGE);}
        if(nTrapID == TRAP_BASE_TYPE_POISON_GAS_STRONG) {ePoison = EffectPoison(POISON_ABILITY_AND_DAMAGE_AVERAGE);}
        if(nTrapID == TRAP_BASE_TYPE_POISON_GAS_DEADLY) {ePoison = EffectPoison(POISON_DAMAGE_VIRULENT);}
        if(nTrapID == TRAP_BASE_TYPE_POISON_GAS_DEVASTATING) {ePoison = EffectPoison(POISON_ABILITY_AND_DAMAGE_VIRULENT);}

        ePoison = SetEffectIcon(ePoison, 110);//RWT-OEI 07/08/04
        // DJS-OEI 1/27/2004
        // Increase the radius for each rank in Demolitions
        float fRadius = 3.3;
        int nDemoSkill = GetOwnerDemolitionsSkill( OBJECT_SELF );
        if( nDemoSkill > 0 ) {
            fRadius += 0.2 * nDemoSkill;//RWT-OEI 05/24/04 - Changed from .1 to .2 per Fergus
        }

        oTarget = GetFirstObjectInShape(SHAPE_SPHERE, fRadius, lTrap, TRUE);
        while(GetIsObjectValid(oTarget))
        {
            if(GetIsEnemy(oTarget,OBJECT_SELF) && !GetIsNeutral(oTarget) )
            {
            	if(GetRacialType(oTarget) != RACIAL_TYPE_DROID  && !GetIsNeutral(oTarget, OBJECT_SELF))
            	{
                		ApplyEffectToObject(DURATION_TYPE_PERMANENT, ePoison, oTarget);
            	}
            	oTarget = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lTrap, TRUE);
		}
        }
    }
    //SONIC CHARGE TRAP
    else if ( nTrapID == TRAP_SONIC_MINOR ||
              nTrapID == TRAP_SONIC_AVERAGE ||
              nTrapID == TRAP_SONIC_STRONG ||
              nTrapID == TRAP_SONIC_DEADLY ||
              nTrapID == TRAP_SONIC_DEVASTATING )
    {
        effect eDamage;
        effect eDex;
        if (nTrapID == TRAP_SONIC_MINOR)
        {
            eDex = EffectAbilityDecrease(ABILITY_DEXTERITY, 2);
        }
        else if (nTrapID == TRAP_SONIC_AVERAGE)
        {
            eDex = EffectAbilityDecrease(ABILITY_DEXTERITY, 4);
        }
        else if (nTrapID == TRAP_SONIC_STRONG)
        {
            eDex = EffectAbilityDecrease(ABILITY_DEXTERITY, 6);
        }
        else if (nTrapID == TRAP_SONIC_DEADLY)
        {
            eDex = EffectAbilityDecrease(ABILITY_DEXTERITY, 8);
        }
        else if (nTrapID == TRAP_SONIC_DEVASTATING)
        {
            eDex = EffectAbilityDecrease(ABILITY_DEXTERITY, 10);
        }

        if(nTrapID == TRAP_SONIC_MINOR) {nDamage = nMinorDMG; nDC = nMinorDC; fRadius = fMinor;}
        if(nTrapID == TRAP_SONIC_AVERAGE) {nDamage = nAverageDMG; nDC = nAverageDC; fRadius = fAverage;}
        if(nTrapID == TRAP_SONIC_STRONG) {nDamage = nStrongDMG; nDC = nStrongDC; fRadius = fStrong;}
        if(nTrapID == TRAP_SONIC_DEADLY) {nDamage = nDeadlyDMG; nDC = nDeadlyDC; fRadius = fDeadly;}
        if(nTrapID == TRAP_SONIC_DEVASTATING) {nDamage = nDevaDMG; nDC = nDevaDC; fRadius = fDeva;}

        oTarget = GetFirstObjectInShape(SHAPE_SPHERE, fRadius, lTrap, TRUE);
        ApplyEffectAtLocation(DURATION_TYPE_INSTANT, EffectVisualEffect(3007),GetSpellTargetLocation());
        while (GetIsObjectValid(oTarget))
        {
            if(GetIsEnemy(oTarget,OBJECT_SELF) && !GetIsNeutral(oTarget) )
            {
                int nDamageNew = GetReflexAdjustedDamage(nDamage, oTarget, nDC);
                eDamage = EffectDamage( nDamageNew, DAMAGE_TYPE_SONIC);
                ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
                if (nDamage <= nDamageNew)
                {
                    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDex, oTarget, 30.0);
                }
            }
            oTarget = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lTrap, TRUE);
        }
    }
    //JD FRAGMENTATION MINE
    else if(nTrapID == JD_TRAP_FRAG_MINOR ||
            nTrapID == JD_TRAP_FRAG_AVERAGE ||
            nTrapID == JD_TRAP_FRAG_STRONG ||
            nTrapID == JD_TRAP_FRAG_DEADLY ||
            nTrapID == JD_TRAP_FRAG_DEVASTATING ||
            nTrapID == JD_TRAP_FRAG_TOP )
   {
        if(nTrapID == JD_TRAP_FRAG_MINOR) {nDamage = nMinorDMG; nDC = nMinorDC; fRadius = fMinor;}
        if(nTrapID == JD_TRAP_FRAG_AVERAGE) {nDamage = nAverageDMG; nDC = nAverageDC; fRadius = fAverage;}
        if(nTrapID == JD_TRAP_FRAG_STRONG) {nDamage = nStrongDMG; nDC = nStrongDC; fRadius = fStrong;}
        if(nTrapID == JD_TRAP_FRAG_DEADLY) {nDamage = nDeadlyDMG; nDC = nDeadlyDC; fRadius = fDeadly;}
        if(nTrapID == JD_TRAP_FRAG_DEVASTATING) {nDamage = nDevaDMG; nDC = nDevaDC; fRadius = fDeva;}
        if(nTrapID == JD_TRAP_FRAG_TOP) {nDamage = nTopDMG; nDC = nTopDC; fRadius = fTop;}

        ApplyEffectAtLocation(DURATION_TYPE_INSTANT, EffectVisualEffect(1044),GetSpellTargetLocation());
        int nVFX = 3003;
        oTarget = GetFirstObjectInShape(SHAPE_SPHERE, fRadius, lTrap, FALSE);
        while(GetIsObjectValid(oTarget))
        {
            if(GetIsEnemy(oTarget,OBJECT_SELF) && !GetIsNeutral(oTarget) )
            {
		    JD_SignalEnemyEvent( oTarget );
                JD_SignalPartyEvent( GetFirstPC(), nTrapID );
		    int nSaves = ReflexSave(oTarget, nDC, SAVING_THROW_TYPE_NONE);
                if(nSaves == 0)
                {
                    ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDamage(nDamage, DAMAGE_TYPE_PIERCING), oTarget);
                }
                else
                {
                    int nApply;
                    if( GetHasFeat( FEAT_EVASION, oTarget ) ) {
                        nApply = 0;
                    }
                    else {
                        nApply = nDamage / 2;
                    }
                    ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDamage(nApply, DAMAGE_TYPE_PIERCING), oTarget);
                }
            }
            oTarget = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lTrap, FALSE);
        }
    }
    //JD PLASMA MINE
    else if(nTrapID == JD_TRAP_PLASMA_MINOR ||
            nTrapID == JD_TRAP_PLASMA_AVERAGE ||
            nTrapID == JD_TRAP_PLASMA_STRONG ||
            nTrapID == JD_TRAP_PLASMA_DEADLY ||
            nTrapID == JD_TRAP_PLASMA_DEVASTATING ||
            nTrapID == JD_TRAP_PLASMA_TOP )
    {
        if(nTrapID == JD_TRAP_PLASMA_MINOR) {nDamage = nMinorDMG; nDC = nMinorDC; fRadius = fMinor;}
        if(nTrapID == JD_TRAP_PLASMA_AVERAGE) {nDamage = nAverageDMG; nDC = nAverageDC; fRadius = fAverage;}
        if(nTrapID == JD_TRAP_PLASMA_STRONG) {nDamage = nStrongDMG; nDC = nStrongDC; fRadius = fStrong;}
        if(nTrapID == JD_TRAP_PLASMA_DEADLY) {nDamage = nDeadlyDMG; nDC = nDeadlyDC; fRadius = fDeadly;}
        if(nTrapID == JD_TRAP_PLASMA_DEVASTATING) {nDamage = nDevaDMG; nDC = nDevaDC; fRadius = fDeva;}
        if(nTrapID == JD_TRAP_PLASMA_TOP) {nDamage = nTopDMG; nDC = nTopDC; fRadius = fTop;}

        ApplyEffectAtLocation(DURATION_TYPE_INSTANT, EffectVisualEffect(1044),GetSpellTargetLocation());
        int nVFX = 3010;
        effect eFlame = EffectVisualEffect(VFX_IMP_FLAME);
        oTarget = GetFirstObjectInShape(SHAPE_SPHERE, fRadius, lTrap, FALSE);
        while(GetIsObjectValid(oTarget))
        {
            if(GetIsEnemy(oTarget,OBJECT_SELF) && !GetIsNeutral(oTarget) )
            {
		    JD_SignalEnemyEvent( oTarget );
                JD_SignalPartyEvent( GetFirstPC(), nTrapID );
		    int nSaves = ReflexSave(oTarget, nDC, SAVING_THROW_TYPE_FIRE);
                if(nSaves == 0)
                {
                    ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDamage(nDamage, DAMAGE_TYPE_FIRE), oTarget);
                    ApplyEffectToObject(DURATION_TYPE_INSTANT, eFlame, oTarget);
                }
                else
                {
                    int nApply;
                    if( GetHasFeat( FEAT_EVASION, oTarget ) ) {
                        nApply = 0;
                    }
                    else {
                        nApply = nDamage / 2;
                    }
                    ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDamage(nApply, DAMAGE_TYPE_FIRE), oTarget);
                }
            }
            oTarget = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lTrap, FALSE);
        }
    }
    //JD SONIC TRAP
    else if ( nTrapID == JD_TRAP_SONIC_MINOR ||
              nTrapID == JD_TRAP_SONIC_AVERAGE ||
              nTrapID == JD_TRAP_SONIC_STRONG ||
              nTrapID == JD_TRAP_SONIC_DEADLY ||
              nTrapID == JD_TRAP_SONIC_DEVASTATING ||
              nTrapID == JD_TRAP_SONIC_TOP )
    {
        int nDex;
        if(nTrapID == JD_TRAP_SONIC_MINOR) {nDamage = nMinorDMG; nDC = nMinorDC; fRadius = fMinor; nDex = 2;}
        if(nTrapID == JD_TRAP_SONIC_AVERAGE) {nDamage = nAverageDMG; nDC = nAverageDC; fRadius = fAverage; nDex = 4;}
        if(nTrapID == JD_TRAP_SONIC_STRONG) {nDamage = nStrongDMG; nDC = nStrongDC; fRadius = fStrong; nDex = 6;}
        if(nTrapID == JD_TRAP_SONIC_DEADLY) {nDamage = nDeadlyDMG; nDC = nDeadlyDC; fRadius = fDeadly; nDex = 8;}
        if(nTrapID == JD_TRAP_SONIC_DEVASTATING) {nDamage = nDevaDMG; nDC = nDevaDC; fRadius = fDeva; nDex = 10;}
        if(nTrapID == JD_TRAP_SONIC_TOP) {nDamage = nTopDMG; nDC = nTopDC; fRadius = fTop; nDex = 12;}

        int nVFX = 3007;

        effect eDex = EffectAbilityDecrease(ABILITY_DEXTERITY, nDex);
        eDex = SetEffectIcon(eDex, 42);
        oTarget = GetFirstObjectInShape(SHAPE_SPHERE, fRadius, lTrap, FALSE);
        while(GetIsObjectValid(oTarget))
        {
            if(GetIsEnemy(oTarget,OBJECT_SELF) && !GetIsNeutral(oTarget) )
            {
		    JD_SignalEnemyEvent( oTarget );
                JD_SignalPartyEvent( GetFirstPC(), nTrapID );
		    int nSaves = WillSave(oTarget, nDC, SAVING_THROW_TYPE_SONIC);
                if(nSaves == 0)
                {
                    ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDamage(nDamage, DAMAGE_TYPE_SONIC), oTarget);
                    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDex, oTarget, 30.0);
                }
                else
                {
                    int nApply;
                    if( GetHasFeat( FEAT_EVASION, oTarget ) ) {
                        nApply = 0;
                    }
                    else {
                        nApply = nDamage / 2;
                    }
                    ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDamage(nApply, DAMAGE_TYPE_FIRE), oTarget);
                }
            }
            oTarget = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lTrap, FALSE);
        }
    }
}

