// a_master_anim
// DJS-OEI 9/8/2004
// This script plays fake combat animations between the Jedi Master
// and the player.


// 26/01/2006 by tslrp
// The lightsabre of the Jedi master turns off during the cutscene despite the
// SetLightsaberPower(TRUE) command. Seems the delayed CreatureFlourishWeapon command
// overrides the lightsabre state again allowing it to deactivate after a short while.
// Since PlayAnimation doesn't cause this problem, use it to trigger the appropriate 
// weapon flourish. - TA

// Returns the animation number for flourish weapon (??_Wield_Idle_To_Melee in animations.2da) 
// depending on the lightsabre type oCreature has equipped. Doesn't work for other weapons.
// The value -1 is returned if no fitting animation was found.
int GetFlourishAnimation(object oCreature=OBJECT_SELF) {
	int nMainWeaponType = GetBaseItemType(GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON, oCreature));
	int nOffWeaponType = GetBaseItemType(GetItemInSlot(INVENTORY_SLOT_LEFTWEAPON, oCreature));
	int nAnimationNumber = -1;

	if(nMainWeaponType == BASE_ITEM_DOUBLE_BLADED_LIGHTSABER) {
		nAnimationNumber = 10000 + 173;
	} else {
		if(nMainWeaponType == BASE_ITEM_LIGHTSABER || nMainWeaponType == BASE_ITEM_SHORT_LIGHTSABER) {
			if(nOffWeaponType == BASE_ITEM_LIGHTSABER || nOffWeaponType == BASE_ITEM_SHORT_LIGHTSABER) {
				nAnimationNumber = 10000 + 214;
			} else {
				nAnimationNumber = 10000 + 132;
			}
		}
	}
	return nAnimationNumber;
}


void main()
{
    object oInvisoKreia = GetObjectByTag( "InvisoKreia" );
    object oMaster = OBJECT_INVALID;
    int nLocalNum = GetLocalNumber( oInvisoKreia, 12 );
    switch( nLocalNum ) {
        case 1:
        {
            oMaster = GetObjectByTag( "kavar" );
            break;
        }
        case 2:
        {
            oMaster = GetObjectByTag( "npc_vrook" );
            break;
        }
        case 3:
        {
            oMaster = GetObjectByTag( "zezkaiel" );
            break;
        }
        case 4:
        {
            oMaster = GetObjectByTag( "vash" );
            break;
        }
    }

    if( GetIsObjectValid( oMaster ) ) {
        // This is the cutscene where the Jedi Master
        // is dueling with the player.
        object oPC = GetFirstPC();
        if( !GetIsObjectValid( oPC ) ) {
            AurPostString( "Could not find Player's Character to set up cutscene positioning.", 10, 10, 2.0 );
            return;
        }

        SetLightsaberPowered( oMaster, TRUE );
        SetLightsaberPowered( oPC, TRUE );
        SetFakeCombatState( oMaster, TRUE );
        SetFakeCombatState( oPC, TRUE );
        AssignCommand( oMaster, PlayAnimation( ANIMATION_LOOPING_READY, 1.0, -1.0 ) );
        AssignCommand( oPC, PlayAnimation( ANIMATION_LOOPING_READY, 1.0, -1.0 ) );

	  // TA: Choose correct flourish animation.
	  int nFlourishAnimation = GetFlourishAnimation(oMaster);
	  if(nFlourishAnimation >= 0) {
		  DelayCommand(2.0, AssignCommand(oMaster, PlayAnimation(nFlourishAnimation)));
	  } else {
        	  DelayCommand( 2.0, CreatureFlourishWeapon( oMaster ) );
	  }

        DelayCommand( 2.5, ActionPlayAnimation( ANIMATION_LOOPING_READY, 1.0, -1.0 ) );
    }
}
