// ST: tr_leave_ehawk.nss (003EBO_s.rim)

#include "k_inc_hawk"

void ExitToDxunOnderon();
void ExitToKorriban();
void DoEbo004ExitHawk();

void main() {
    object oEnter = GetEnteringObject();
    
    // ST: Merged tr_leave_ehawk from 003EBO and 004EBO so they both
    //     work if put in Override.
    if (GetTag(GetArea(oEnter)) == "004EBO") {
        DoEbo004ExitHawk();
        return; 
    }
    
    SetNPCSelectability(NPC_KREIA, TRUE);
    SetNPCSelectability(NPC_ATTON, TRUE);
        
    if (oEnter == GetFirstPC()) {
        // ST: In combat
        if (GetGlobalNumber("003_IN_COMBAT") == 1) {
            BarkString(OBJECT_INVALID, 135165); 
            return;
        }       
        // ST: In space
        else if (GetGlobalNumber("003EBO_RETURN_DEST") == 8) {
            BarkString(OBJECT_INVALID, 129942); 
            return;         
        }
        // ST: Landed on Dxun
        else if (GetGlobalNumber("003EBO_RETURN_DEST") == 4) {
            SetGlobalFadeOut();
            SetFadeUntilScript();
            AurPostString("Leaving the hawk", 15, 22, 10.0);
            DelayCommand(1.0, ExitToDxunOnderon());
        }   
        // ST: Landed on Korriban       
        else if (GetGlobalNumber("003EBO_RETURN_DEST") == 6) {
            SetGlobalFadeOut();
            SetFadeUntilScript();
            AurPostString("Leaving the hawk", 15, 22, 10.0);
            DelayCommand(1.0, ExitToKorriban());
        }
        else {
            SetGlobalFadeOut();
            SetFadeUntilScript();   
            ShowPartySelectionGUI("check_party_gui", -1, -1, TRUE);     
        }           
    }
}

void ExitToDxunOnderon () {
    if (GetGlobalBoolean("401_FIRST_ENTER") && (GetGlobalNumber("502OND_End_First") > 0)) {
        AurPostString("Atton is selectable", 5, 19, 10.0);
        SetNPCSelectability(NPC_ATTON, TRUE);
    }
    else {
        SetNPCSelectability(NPC_ATTON, FALSE);
        AurPostString("Atton is NOT selectable", 5, 19, 10.0);
    }   
    AurPostString("Showing party selection", 5, 20, 10.0);
    ShowPartySelectionGUI("check_party_gui"); 
}

void ExitToKorriban() {
    SetNPCSelectability(NPC_KREIA, FALSE);
    AurPostString("Kreia is NOT selectable", 5, 19, 10.0);
    AurPostString("Showing party selection", 5, 20, 10.0);
    ShowPartySelectionGUI("check_party_gui");   
}

void DoEbo004ExitHawk() {
    if (GetEnteringObject() == GetFirstPC()) {
        int nDest = GetGlobalNumber("003EBO_RETURN_DEST");
        string sDest;
        
        switch (nDest) {
            case 0:  sDest = "106PER"; 		break;
            case 1:  sDest = "201TEL"; 		break;
            case 2:  sDest = "262TEL"; 		break;
            case 3:  sDest = "301NAR"; 		break;
            case 4:  sDest = "401DXN"; 		break;
            case 5:  sDest = "601DAN"; 		break;
            case 6:  sDest = "701KOR"; 		break;
            case 7:  sDest = "801DRO"; 		break;
            case 8:  sDest = "ERROR";  		break;
            case 9:  sDest = "901MAL"; 		break;
            case 10: sDest = "ERROR";  		break;
            case 12: sDest = "954COR"; 	    	break;
            case 13: sDest = "975HOT";	    	break;
            default: sDest = "ERROR";
        }
        
        if (sDest == "ERROR")
            AurPostString("EBO ERROR: No module sepcified!", 5, 15, 10.0);
        else
            StartNewModule(sDest, "WP_from_ebonhawk");
    }
}