{
    
    SWFP_PRIVATE_SAVE_VERSUS_TYPE = SAVING_THROW_TYPE_ELECTRICAL;
    SWFP_HARMFUL = TRUE;
    JD_ForcePowerCost( OBJECT_SELF, GetSpellId(), FALSE);
    object oTarget 	= GetSpellTargetObject();
    location lLoc		= GetLocation(oTarget);

    float fDelay		= 0.0;
    float fRadius       = Sp_CalcRange( 25.0 );
    
    int nNumDice        = GetHitDice(OBJECT_SELF);
    int nDamage;
    int bHit 		= FALSE;
    int nCurrDmg		= nDamage;
    int nSpellId		= GetSpellId();


    effect eLightning 	= EffectBeam(VFX_BEAM_LIGHTNING_DARK_L, OBJECT_SELF, BODY_NODE_HAND_LEFT);
    effect eStruck 	= EffectVisualEffect(VFX_PRO_LIGHTNING_L);
    effect eDam 		= EffectDamage(nDamage, DAMAGE_TYPE_ELECTRICAL);
    effect eForce 	= EffectDamageForcePoints(nDamage);
    
    object oLast = OBJECT_SELF;
    object oUse = oTarget;

    object oCaster      = GetLastSpellCaster();
    int nDcMod          = 5;
    int nDifficulty     = JD_GetSaveDC(oCaster, nDcMod);
    int nSave           = ReflexSave(oUse, nDifficulty, SWFP_PRIVATE_SAVE_VERSUS_TYPE);

    while(GetIsObjectValid(oUse)) {
       	            	
    	if (GetIsEnemy(oUse, OBJECT_SELF)) {
	        JD_SignalEnemyEvent( oUse );
              JD_SignalPartyEvent( GetFirstPC(), JD_CHAIN );
	        bHit 	= FALSE;
		  nSave     = ReflexSave(oUse, nDifficulty, SWFP_PRIVATE_SAVE_VERSUS_TYPE);
	        nDamage 	= JD_CalcDamage( OBJECT_SELF, nNumDice, 2, 0 );
	        if (nSave > 0) {
	        	nCurrDmg 	= nDamage / 2;          	
	            eDam 		= EffectDamage(nCurrDmg, DAMAGE_TYPE_ELECTRICAL);
	            eForce 		= EffectDamageForcePoints(nDamage/2);
	            bHit 		= TRUE; 
	        }
	        else { 
	        	nCurrDmg 	= nDamage;
	        	eDam 		= EffectDamage(nCurrDmg, DAMAGE_TYPE_ELECTRICAL);
	        	eForce 	= EffectDamageForcePoints(nDamage);    
			bHit 		= TRUE;             		
	       }
      
             if (bHit) {
	            	eLightning 	= EffectBeam(VFX_BEAM_LIGHTNING_DARK_S, oLast, (oLast == OBJECT_SELF ? BODY_NODE_HAND_LEFT : BODY_NODE_CHEST));
        			        			 
	                DelayCommand(fDelay, RemoveEffect(oUse, eStruck));
			    DelayCommand(fDelay, RemoveEffect(oUse, eLightning));
	                DelayCommand(fDelay, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLightning, oUse, 0.5));
	                DelayCommand(fDelay + 0.10, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eStruck, oUse));
	                DelayCommand(fDelay + 0.30, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oUse));
                      DelayCommand(fDelay + 0.30, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eForce, oUse)); 

	        		fDelay += 0.2;
	        		oLast = oUse;
	            }                
	    }
                   
        if (oUse == oTarget) 
        	oUse = GetFirstObjectInShape(SHAPE_SPHERE, fRadius, lLoc, TRUE, OBJECT_TYPE_CREATURE);
        else
        	oUse = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lLoc, TRUE, OBJECT_TYPE_CREATURE);
       	
        if (oUse == oTarget)
        	oUse = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lLoc, TRUE, OBJECT_TYPE_CREATURE);        
    }

    effect eBeam = EffectBeam(VFX_BEAM_LIGHTNING_DARK_L, OBJECT_SELF, BODY_NODE_HAND_LEFT);
    DelayCommand(0.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam, oTarget, 0.5));     
}


