{
	int nDice		  = 6;
	object oTarget 	  = GetSpellTargetObject();
	int nSpellId 	  = GetSpellId();
	int nBeam 		  = 2049;
	effect eVisSparks = EffectVisualEffect(1047);		
	effect eVisCharge = EffectVisualEffect(VFX_IMP_FORCE_BREACH);
	effect eVisBoom   = EffectVisualEffect(VFX_FNF_GRENADE_THERMAL_DETONATOR);
	effect eGlue	  = EffectEntangle();
	effect eStop	  = EffectMovementSpeedDecrease(1); // ST: FIX - was 99...
	effect eOuch	  = EffectCutSceneHorrified();
      JD_ForcePowerCost( OBJECT_SELF, GetSpellId(), FALSE);		
	// Apply windup effects, then trigger the explosion...
	if( !JD_BetterRelatedPowerExists( oTarget, JD_DESTRUCT_MSTR ) ) {
		JD_RemoveRelatedPowers( oTarget, JD_DESTRUCT_MSTR );
            JD_SignalPartyEvent( GetFirstPC(), JD_DESTRUCT_MSTR ); 
		JD_SignalEnemyEvent( oTarget );
		ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eGlue, oTarget, 3.0);
		ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStop, oTarget, 3.0);
		DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOuch, oTarget, 1.0));
		DelayCommand(3.0, ST_DestructionDamage(oTarget, GetHitDice(OBJECT_SELF), nSpellId, nDice));
      }
	
	// Apply the visual effects on the primary target in sequence.
	DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVisCharge, oTarget));
	DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVisSparks, oTarget));
	DelayCommand(3.0, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVisBoom, oTarget));
	
	// Draw the visual effect...
	int i;
	int nSpots = 4;
	float fAngleInc = 360.0 / nSpots;
	float fAngle = 0.0;	
	vector loc;

	object oLast  = OBJECT_INVALID;
	object oTop   = OBJECT_INVALID;
	object oFirst = OBJECT_INVALID;
	effect eBeam;
	
	for (i = 0; i < (nSpots*2); i++) {
		loc = GetPosition(oTarget);
		loc.x += cos(fAngle) * ((i % 2) ? 0.5 : 1.5); 
		loc.y += sin(fAngle) * ((i % 2) ? 0.5 : 1.5); 
		if (i % 2)
			loc.z += 2.8;
		else
			loc.z -= 0.25;

		object oInv = CreateObject(OBJECT_TYPE_PLACEABLE, "plc_invisible", Location(loc, (fAngle - 180.0)));
		if (GetIsObjectValid(oInv)) {
			if ((i % 2)) {
				if (!GetIsObjectValid(oFirst))
					oFirst = oInv;
				
				// Beams going up
				if (GetIsObjectValid(oTop)) {
					eBeam = EffectBeam(nBeam, oTop, BODY_NODE_CHEST);
					DelayCommand(IntToFloat(i) / 5.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam, oInv, 2.7 - (IntToFloat(i) / 5.0)));
				}
				// Top ring of beams...
				if (GetIsObjectValid(oLast)) {
					eBeam = EffectBeam(nBeam, oLast, BODY_NODE_CHEST);
					DelayCommand(IntToFloat(i+1) / 5.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam, oInv, 2.3 - (IntToFloat(i+1) / 5.0)));
				}
				// Final link in top ring of beams...
				if ((i == ((nSpots*2) - 1)) && GetIsObjectValid(oFirst)) {
					eBeam = EffectBeam(nBeam, oFirst, BODY_NODE_CHEST);
					DelayCommand(IntToFloat(i+1) / 5.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam, oInv, 2.3 - (IntToFloat(i+1) / 5.0)));						
				}
				
				// Beams going down on target
				eBeam = EffectBeam(nBeam, oInv, BODY_NODE_CHEST);
				DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam, oTarget, 0.7));
				
				oLast = oInv;					
			}
			else {
				oTop = oInv;									
			}
			
			AssignCommand(oInv, DestroyObject(oInv, 3.0, TRUE));			
		}
		
		if (i % 2)
			fAngle += fAngleInc;
			
		if (fAngle > 360.0)
			fAngle = fAngle - 360.0;	
	}	
}
