{  
	object oTarget = GetSpellTargetObject();    
	if ( GetObjectType(oTarget) == OBJECT_TYPE_TRIGGER )
	{
      	JD_ForcePowerCost( OBJECT_SELF, GetSpellId(), FALSE);
            float fRange = Sp_CalcRange( 25.0 );
            eLink1 = EffectBeam(VFX_BEAM_DROID_DESTROY, oTarget, BODY_NODE_CHEST);
            eLink1 = EffectLinkEffects(eLink1, EffectVisualEffect(VFX_PRO_LIGHTNING_L));

            eLink2 = EffectDroidStun();
            eLink2 = EffectLinkEffects(eLink2, EffectVisualEffect(1008));
            eLink2 = SetEffectIcon(eLink2, 5);

            effect eLink3 = EffectBeam(VFX_BEAM_DROID_DESTROY, OBJECT_SELF, BODY_NODE_HAND);
            eLink3 = EffectLinkEffects(eLink3, EffectVisualEffect(VFX_PRO_LIGHTNING_L));

		location lTarget = GetLocation(oTarget);

            object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, fRange, lTarget, TRUE, OBJECT_TYPE_TRIGGER);
            while(GetIsObjectValid(oTarget))
            {
            	int nDamage = JD_CalcDamage( OBJECT_SELF, GetHitDice(OBJECT_SELF), 6, 0 );
            	effect eDamage = EffectDamage(nDamage, DAMAGE_TYPE_ELECTRICAL);

                	int bIsMine2 = FALSE;
                	if (GetObjectType(oTarget) == OBJECT_TYPE_TRIGGER)
                	{
                    int nMineType2 = GetTrapBaseType(oTarget);
                    if ( !GetIsTrapped(oTarget) )
                    {
                        nMineType2 = -1;
                    }
                if ( nMineType2 == TRAP_BASE_TYPE_FLASH_STUN_MINOR             ||
                     nMineType2 == TRAP_BASE_TYPE_FRAGMENTATION_MINE_MINOR     ||
                     nMineType2 == TRAP_BASE_TYPE_LASER_SLICING_MINOR          ||
                     nMineType2 == TRAP_BASE_TYPE_POISON_GAS_MINOR            ||
                     nMineType2 == TRAP_BASE_TYPE_SONIC_CHARGE_MINOR )
                    {
                        bIsMine2 = TRUE;
                    }
                }
                if(bIsMine2)
                {
                        ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage , oTarget);
                        float fDuration = JD_CalcDuration( OBJECT_SELF, 12.0 );
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink1, oTarget, fLightningDuration);
                        ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink2, oTarget, fDuration);
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink3, oTarget, fLightningDuration);
                        if ( bIsMine2 )
                        {
                            AssignCommand(oTarget,ExecuteScript( "k_trp_generic",oTarget));
                            DetonateMine(oTarget);
                        }
                }
                oTarget = GetNextObjectInShape(SHAPE_SPHERE, fRange, lTarget, TRUE, OBJECT_TYPE_TRIGGER);
            }
        }
    else if ( GetObjectType(oTarget) == OBJECT_TYPE_CREATURE )
    {
    
    SWFP_PRIVATE_SAVE_VERSUS_TYPE = SAVING_THROW_TYPE_ELECTRICAL;
    SWFP_HARMFUL = TRUE;
    JD_ForcePowerCost( OBJECT_SELF, GetSpellId(), FALSE);
    object oTarget 	= GetSpellTargetObject();
    location lLoc		= GetLocation(oTarget);

    float fDelay		= 0.0;
    float fRadius       = Sp_CalcRange( 15.0 );
    
    int nNumDice        = GetHitDice(OBJECT_SELF);
    int nDamage;
    int bHit 		= FALSE;
    int nCurrDmg		= nDamage;
    int nSpellId		= GetSpellId();


    effect eLightning 	= EffectBeam(VFX_BEAM_LIGHTNING_DARK_L, OBJECT_SELF, BODY_NODE_HAND_LEFT);
    effect eStruck 	= EffectVisualEffect(VFX_PRO_LIGHTNING_L);
    effect eDam 		= EffectDamage(nDamage, DAMAGE_TYPE_ELECTRICAL);
    effect eForce 	= EffectDamageForcePoints(nDamage);
    effect eStun 		= EffectDroidStun();
    
    object oLast = OBJECT_SELF;
    object oUse = oTarget;

    object oCaster      = GetLastSpellCaster();
    int nDcMod          = 5;
    int nDifficulty     = JD_GetSaveDC(oCaster, nDcMod);
    int nSave           = ReflexSave(oUse, nDifficulty, SWFP_PRIVATE_SAVE_VERSUS_TYPE);
    	
    while(GetIsObjectValid(oUse)) {
       	            	
    	if (GetIsEnemy(oUse, OBJECT_SELF) && (GetRacialType(oUse) == RACIAL_TYPE_DROID) ) {
	        JD_SignalEnemyEvent( oUse );
              JD_SignalPartyEvent( GetFirstPC(), FORCE_POWER_DROID_STUN );
	        bHit 	= FALSE;
		  nSave     = ReflexSave(oUse, nDifficulty, SWFP_PRIVATE_SAVE_VERSUS_TYPE);
	        nDamage 	= JD_CalcDamage( OBJECT_SELF, nNumDice, 2, 0 );
	        if (nSave > 0) {
	        	nCurrDmg 	= nDamage / 2;          	
	            eDam 		= EffectDamage(nCurrDmg, DAMAGE_TYPE_ELECTRICAL);
	            eForce 	= EffectDamageForcePoints(nDamage/2);
			eStun 	= EffectForceFizzle();
	            bHit 		= TRUE; 
	        }
	        else { 
	        	nCurrDmg 	= nDamage;
	        	eDam 		= EffectDamage(nCurrDmg, DAMAGE_TYPE_ELECTRICAL);
	        	eForce 	= EffectDamageForcePoints(nDamage);    
			bHit 		= TRUE;             		
	       }
             if (bHit) {
	            	eLightning 	= EffectBeam(VFX_BEAM_LIGHTNING_DARK_S, oLast, (oLast == OBJECT_SELF ? BODY_NODE_HAND_LEFT : BODY_NODE_CHEST));
        			        			 
	                DelayCommand(fDelay, RemoveEffect(oUse, eStruck));
			    DelayCommand(fDelay, RemoveEffect(oUse, eLightning));
	                DelayCommand(fDelay, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLightning, oUse, 0.5));
	                DelayCommand(fDelay + 0.10, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eStruck, oUse));
	                DelayCommand(fDelay + 0.30, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oUse));
                      DelayCommand(fDelay + 0.30, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eForce, oUse)); 
	                DelayCommand(fDelay + 0.30, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStun, oUse, JD_CalcDuration( OBJECT_SELF, 12.0 ) ) );

	        		fDelay += 0.2;
	        		oLast = oUse;
	            }                
	    }
                   
        if (oUse == oTarget) 
        	oUse = GetFirstObjectInShape(SHAPE_SPHERE, fRadius, lLoc, TRUE, OBJECT_TYPE_CREATURE);
        else
        	oUse = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lLoc, TRUE, OBJECT_TYPE_CREATURE);
       	
        if (oUse == oTarget)
        	oUse = GetNextObjectInShape(SHAPE_SPHERE, fRadius, lLoc, TRUE, OBJECT_TYPE_CREATURE);        
    }

    effect eBeam = EffectBeam(VFX_BEAM_LIGHTNING_DARK_L, OBJECT_SELF, BODY_NODE_HAND_LEFT);
    DelayCommand(0.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam, oTarget, 0.5));     
    }
}


