#include "jd_constants"
/*****JD Added*****/
int JD_BetterRelatedPowerExists( object oTarget, int nPowerID );
void JD_RemoveRelatedPowers( object oTarget, int nPowerID );
float JD_GetDemoRadius(float fRadiusMod,float fStaticRadius,object oCaster);
int JD_GetDemoDMG(int nDMGMod, int nStaticDMG,object oCaster);
int JD_GetDemoDC(int nDCMod,object oCaster,object oVictom);
int JD_CalcDamage( object oCaster, int nNumDice, int nSizeDice, int nFlatAmount );
int JD_GetIsPrep(object oCaster, int nSpellId);
int JD_GetIsPrepNotRez(object oCaster, int nSpellId);
void JD_ForcePowerCost( object oCaster, int nSpellId, int nIsBuff);
float JD_CalcDuration( object oCaster, float fDuration );
int JD_CalcBuffBonus( object oCaster, int nBonus  );
int JD_GetSaveDC(object oCaster = OBJECT_SELF,int nDcMod = 0);

#include "k_inc_debug"

float fLightningDuration = 1.0;

//These variables are set in the script run area.
int SWFP_PRIVATE_SAVE_TYPE;
int SWFP_PRIVATE_SAVE_VERSUS_TYPE;
int SWFP_DAMAGE;
int SWFP_DAMAGE_TYPE;
int SWFP_DAMAGE_VFX;
int SWFP_HARMFUL;
int SWFP_SHAPE;

//Runs the script section for the particular force power.
void  Sp_RunForcePowers();
//Immunity and Resist Spell check for the force power.
//The eDamage checks whether the target is immune to the damage effect
int Sp_BlockingChecks(object oTarget, effect eEffect, effect eEffect2, effect eDamage);
//Makes the necessary saving throws
//int Sp_MySavingThrows(object oTarget, int iSpellDC = 0);
//Remove an effect of a specific type
void Sp_RemoveSpecificEffect(int nEffectTypeID, object oTarget);
//Remove an effect from a specific force power.
void Sp_RemoveSpellEffects(int nSpell_ID, object oCaster, object oTarget);
// Delays the application of a spell effect by an amount determined by distance.
float Sp_GetSpellEffectDelay(location SpellTargetLocation, object oTarget);
//Randomly delays the effect application for a default of 0.0 to 0.75 seconds
float Sp_GetRandomDelay(float fMinimumTime = 0.0, float MaximumTime = 0.75);
//Gets a saving throw appropriate to the jedi using the force power.
int Sp_GetJediDCSave();
///Apply effects in a sphere shape.
void Sp_SphereSaveHalf(object oAnchor, float fSize, int nCounter, effect eLink1, float fDuration1, effect eLink2, float fDuration);
//Apply effects to a single target.
void Sp_SingleTarget(object oAnchor, effect eLink1, float fDuration1, effect eLink2, float fDuration2);
//Apply effect to an area and negate on a save.
void Sp_SphereBlocking(object oAnchor, float fSize, int nCounter, effect eLink1, float fDuration1, effect eLink2, float fDuration);
// /Apply effect to an object and negate on a save.
void Sp_SingleTargetBlocking(object oAnchor, effect eLink1, float fDuration1, effect eLink2, float fDuration2);
//Apply effects for a for power.
void Sp_ApplyForcePowerEffects(float fTime, effect eEffect, object oTarget);
//Apply effects to targets.
void Sp_ApplyEffects(int nBlocking, object oAnchor, float fSize, int nCounter, effect eLink1, float fDuration1, effect eLink2, float fDuration2, int nRacial = RACIAL_TYPE_ALL);
//Removes all effects from the spells , Knights Mind, Mind Mastery and Battle Meditation
void Sp_RemoveBuffSpell();
//Prints a string for the spell stript
void SP_MyPrintString(string sString);
//Posts a string for the spell script
void SP_MyPostString(string sString, int n1 = 5, int n2 = 10, float fTime = 4.0);
//Interates through given a time period and a damage amount and hurts someone.  Checks if the person is in conversation.
void SP_InterativeDamage(effect eDamage, int nSecondsRemaining, object oTarget);
//Checks to see if the target is a Turret
int SP_CheckAppearanceTurret(object oTarget, int nFeedback = FALSE);
//Checks to see if the target is a Mark 1, 2, 4 or Spyder Droid
int SP_CheckAppearanceGeoDroid(object oTarget);
//Checks if the character already has Energy Resistance and Improved Energy Resistance
int SP_CheckEnergyResistance(object oTarget);
//This checks all of the delayed effect applications to make sure the target is still hostile and has not surrendered
void SP_MyApplyEffectToObject(int nDurationType, effect eEffect, object oTarget, float fDuration=0.0);
//Checks droids appearance type and if they have shields up
int SP_CheckAppearanceGeoDroidShields(object oTarget, int nFeedback = FALSE);
//Check push compatibility, if true is passed in for the Whirlwind an addition check for shields is made
int SP_CheckForcePushViability(object oTarget, int Whirlwind);

// DJS-OEI 12/9/2003
//void Sp_RemoveRelatedPowers( object oTarget, int nPowerID );
//int Sp_BetterRelatedPowerExists( object oTarget, int nPowerID );
void Sp_RemoveRelatedPowersInRadius( int nPowerID, float nRadius );
int Sp_IsJedi( object oTarget );

// DJS-OEI 3/25/2004
// Due to the addition of Lightsaber/Consular Forms and their
// frequent modification of damage, I've implemented this function
// to calculate the damage for a Force Power based on the parameters
// passed in, as well as adding in modifiers based on the target
// or caster's active Form.
//int Sp_CalcDamage( object oTarget, int nNumDice, int nSizeDice, int nFlatAmount=0 );

// DJS-OEI 3/28/2004
// Similar to Sp_CalcDamage(), this function calculates the duration
// of a Force Power, taking into account the base duration as well
// as modifiers due to Consular Forms.
//float Sp_CalcDuration( float fBaseDuration );

// DJS-OEI 3/29/2004
// Similar to Sp_CalcDamage(), this function calculates the range
// of a Force Power, taking into account the base range as well
// as modifiers due to Consular Forms.
float Sp_CalcRange( float fBaseRange );

//::///////////////////////////////////////////////
//:: Apply Delayed Effect
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    This checks all of the delayed effect applications
    to make sure the target is still hostile and has
    not surrendered
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: May 20, 2003
//:://////////////////////////////////////////////
void SP_MyApplyEffectToObject(int nDurationType, effect eEffect, object oTarget, float fDuration=0.0)
{
    if(GetIsEnemy(oTarget))
    {
        ApplyEffectToObject(nDurationType, eEffect, oTarget, fDuration);
    }
}

//::///////////////////////////////////////////////
//:: Interative Damage
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Interates through given a time period and a
    damage amount and hurts someone.  Checks if
    the person is in conversation.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: April 5, 2003
//:://////////////////////////////////////////////
void SP_InterativeDamage(effect eDamage, int nSecondsRemaining, object oTarget)
{
    if(GetIsObjectValid(oTarget) && GetIsEnemy(oTarget))
    {
        if(!GetIsConversationActive() && !GetIsDead(oTarget) && GetIsEnemy(oTarget))
        {
             if (nSecondsRemaining % 2 == 0)
             {
                  ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
             }
             --nSecondsRemaining;
             if (nSecondsRemaining > 0)
             {
                DelayCommand(1.0f, SP_InterativeDamage(eDamage, nSecondsRemaining, oTarget));
             }
        }
    }
}

//::///////////////////////////////////////////////
//:: Blocking Checks
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Does the Spell Resistance and Immunity
    Checks
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Aug 15, 2002
//:://////////////////////////////////////////////

int Sp_BlockingChecks(object oTarget, effect eEffect1, effect eEffect2, effect eDamage)
{
    int nReturn = FALSE;
    //MODIFIED by Preston Watamaniuk on April 11th
    //Put the immunity check in place for Force Powers.
    if(GetIsLinkImmune(oTarget, eEffect1) || GetIsLinkImmune(oTarget, eEffect2) || GetIsLinkImmune(oTarget, eDamage))
    {
        DisplayFeedBackText(oTarget, 1);
        nReturn = TRUE;
    }

    // DJS-OEI 7/20/2004
    // Form/Stance re-design.
    /*
    // DJS-OEI 3/29/2004
    // Users of the Power of the Dark Side III Consular Form
    // are immune to any spell with the Form Mask for that Form.
    if( GetSpellFormMask( GetSpellId() ) & FORM_MASK_POWER_OF_THE_DARK_SIDE ) {
        if( IsFormActive( oTarget, FORM_CONSULAR_POWER_OF_THE_DARK_SIDE_III ) ) {
            DisplayFeedBackText(oTarget, 1);
            nReturn = TRUE;
        }
    }
    */

    if(ResistForce(OBJECT_SELF, oTarget))
    {
        DisplayFeedBackText(oTarget, 0);
        nReturn = TRUE;
    }

    if(nReturn == TRUE)
    {
        ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectForceResisted(OBJECT_SELF), oTarget);
    }

    return nReturn;
}

// DJS-OEI 3/16/2004
int Sp_IsJedi( object oTarget ) {

    if( ( GetLevelByClass( CLASS_TYPE_JEDICONSULAR, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_JEDIGUARDIAN, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_JEDIMASTER, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_JEDISENTINEL, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_JEDIWATCHMAN, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_JEDIWEAPONMASTER, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_SITHASSASSIN, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_SITHLORD, oTarget ) > 0 ) ||
        ( GetLevelByClass( CLASS_TYPE_SITHMARAUDER, oTarget ) > 0 ) ) {
        return TRUE;
    }
    return FALSE;
}
/*
// DJS-OEI 3/25/2004
// Due to the addition of Lightsaber/Consular Forms and their
// frequent modification of damage, I've implemented this function
// to calculate the damage for a Force Power based on the parameters
// passed in, as well as adding in modifiers based on the target
// or caster's active Form.
int Sp_CalcDamage( object oTarget, int nNumDice, int nSizeDice, int nFlatAmount ) {

    int nDamage = 0;
    int nMod = 0;
    int nCounter = 0;

    if( nFlatAmount != 0 ) {
        nDamage = nFlatAmount;
    }
    else {

        switch( nSizeDice ) {
            case 2:
                nDamage = (d2( nNumDice )) + GetAbilityModifier(ABILITY_WISDOM) + GetAbilityModifier(ABILITY_CHARISMA);
                break;
            case 3:
                nDamage = (d3( nNumDice )) + GetAbilityModifier(ABILITY_WISDOM) + GetAbilityModifier(ABILITY_CHARISMA);
                break;
            case 4:
                nDamage = (d4( nNumDice )) + GetAbilityModifier(ABILITY_WISDOM) + GetAbilityModifier(ABILITY_CHARISMA);
                break;
            case 6:
                nDamage = (d6( nNumDice )) + GetAbilityModifier(ABILITY_WISDOM) + GetAbilityModifier(ABILITY_CHARISMA);
                break;
            case 8:
                nDamage = (d8( nNumDice )) + GetAbilityModifier(ABILITY_WISDOM) + GetAbilityModifier(ABILITY_CHARISMA);
                break;
            case 10:
                nDamage = (d10( nNumDice )) + GetAbilityModifier(ABILITY_WISDOM) + GetAbilityModifier(ABILITY_CHARISMA);
                break;
            case 12:
                nDamage = (d12( nNumDice )) + GetAbilityModifier(ABILITY_WISDOM) + GetAbilityModifier(ABILITY_CHARISMA);
                break;
            case 20:
                nDamage = (d20( nNumDice )) + GetAbilityModifier(ABILITY_WISDOM) + GetAbilityModifier(ABILITY_CHARISMA);
                break;
            case 100:
                nDamage = (d100( nNumDice )) + GetAbilityModifier(ABILITY_WISDOM) + GetAbilityModifier(ABILITY_CHARISMA);
                break;
            default:
                SP_MyPrintString("SP_CalcDamage() - Invalid Die Size:" + IntToString(nSizeDice));
                return 0;
                break;
        }
}
    /////////////////////////////////////////////////
    // Modify damage due to caster's Form --JD--
    /////////////////////////////////////////////////
    if(IsFormActive(OBJECT_SELF, FORM_FORCE_I_FOCUS)){ 
		nDamage += (nDamage*10)/100;
		int nDamageAdded = nDamage/10;
		SP_MyPrintString(IntToString(nDamage) + "added - " + IntToString(nDamageAdded));
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_II_POTENCY)){ 
		nDamage += (nDamage*20)/100;
		int nDamageAdded = nDamage/20;
		SP_MyPrintString(IntToString(nDamage) + "added - " + IntToString(nDamageAdded));
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_III_AFFINITY)){
		nDamage += (nDamage*30)/100;
		int nDamageAdded = nDamage/30;
		SP_MyPrintString(IntToString(nDamage) + "added - " + IntToString(nDamageAdded));
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_IV_MASTERY)){ 
		nDamage += (nDamage*40)/100;
		int nDamageAdded = nDamage/40;
		SP_MyPrintString(IntToString(nDamage) + "added - " + IntToString(nDamageAdded));
	}

    // DJS-OEI 7/20/2004
    // Form/Stance re-design.
    /////////////////////////////////////////////////
    // Modifiers due to caster's Form
    /////////////////////////////////////////////////
    // The Force Focus Form increases damage
    // for offensive Force Powers.

    /*
    // The Force Focus Lightsaber Form I-III increases damage
    // for offensive Force Powers.
    if( IsFormActive( OBJECT_SELF, FORM_CONSULAR_FORCE_FOCUS_I ) ) {
        // +1 to damage.
        nDamage += 1;
    }
    else if( IsFormActive( OBJECT_SELF, FORM_CONSULAR_FORCE_FOCUS_II ) ) {
        // +3 to damage.
        nDamage += 3;
    }
    else if( IsFormActive( OBJECT_SELF, FORM_CONSULAR_FORCE_FOCUS_III ) ) {
        // If the damage is a flat amount, just add 5. Otherwise, the
        // damage was calculated with die rolls. Increase the damage
        // by 1 for each die rolled.
        if( nFlatAmount == 0 ) {
            nDamage += nNumDice;
        }
        else {
            nDamage += 5;
        }
    }

    // The Force Potency Form I-III increases damage for offensive
    // Force Powers.
    if( IsFormActive( OBJECT_SELF, FORM_CONSULAR_FORCE_POTENCY_I ) ) {
        // If the damage is a flat amount, just add 5. Otherwise, the
        // damage was calculated with die rolls. Increase the damage
        // by 1 for each die rolled.
        if( nFlatAmount == 0 ) {
            nDamage += nNumDice;
        }
        else {
            nDamage += 5;
        }
    }
    else if( IsFormActive( OBJECT_SELF, FORM_CONSULAR_FORCE_POTENCY_II ) ) {
        // If the damage is a flat amount, just add 7. Otherwise, the
        // damage was calculated with die rolls. Increase the damage
        // by 1 for each die rolled.
        if( nFlatAmount == 0 ) {
            nDamage += nNumDice;
        }
        else {
            nDamage += 7;
        }
    }
    else if( IsFormActive( OBJECT_SELF, FORM_CONSULAR_FORCE_POTENCY_III ) ) {
        // If the damage is a flat amount, just add 10. Otherwise, the
        // damage was calculated with die rolls. Increase the damage
        // by 2 for each die rolled.
        if( nFlatAmount == 0 ) {
            nDamage += nNumDice*2;
        }
        else {
            nDamage += 10;
        }
    }

    // The Power of the Dark Side Form I-III increases damage for offensive
    // Force Powers.
    if( IsFormActive( OBJECT_SELF, FORM_CONSULAR_POWER_OF_THE_DARK_SIDE_I ) ||
        IsFormActive( OBJECT_SELF, FORM_CONSULAR_POWER_OF_THE_DARK_SIDE_II ) ) {
        // If the damage is a flat amount, add nothing. Otherwise, the
        // damage was calculated with die rolls. Increase the damage
        // by 1 for each die rolled.
        if( nFlatAmount == 0 ) {
            nDamage += nNumDice;
        }
    }
    else if( IsFormActive( OBJECT_SELF, FORM_CONSULAR_POWER_OF_THE_DARK_SIDE_III ) ) {
        // If the damage is a flat amount, add nothing. Otherwise, the
        // damage was calculated with die rolls. Increase the damage
        // by 2 for each die rolled.
        if( nFlatAmount == 0 ) {
            nDamage += nNumDice*2;
        }
    }

    /////////////////////////////////////////////////
    // Modifiers due to target's Form
    /////////////////////////////////////////////////

    // The Ancient III Lightsaber Form and Force Armor III Form
    // both reduce damage by 1/2 of the target's level.
    if( IsFormActive( oTarget, FORM_LIGHTSABER_ANCIENT_III ) ||
        IsFormActive( oTarget, FORM_CONSULAR_FORCE_SHELL_III ) ) {
        nMod = GetHitDice( oTarget )/2;
        if( nDamage > nMod ) {
            nDamage -= nMod;
        }
        else {
            nDamage = 0;
        }
    }

    // The Force Armor II Form reduces damage by 4.
    if( IsFormActive( oTarget, FORM_CONSULAR_FORCE_SHELL_II ) ) {
        if( nDamage > 4 ) {
            nDamage -= 4;
        }
        else {
            nDamage = 0;
        }
    }
    

    return nDamage;
}

float Sp_CalcDuration( float fBaseDuration ) {

    float fFinalDuration = fBaseDuration;

    	if(IsFormActive(OBJECT_SELF, FORM_FORCE_I_FOCUS)){ 
		fFinalDuration = fFinalDuration * 2.00f;
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_II_POTENCY)){ 
		fFinalDuration = fFinalDuration * 3.00f;
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_III_AFFINITY)){
		fFinalDuration = fFinalDuration * 4.00f;
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_IV_MASTERY)){ 
		fFinalDuration = fFinalDuration * 6.00f;
	}

    return fFinalDuration;
}
*/
float Sp_CalcRange( float fBaseRange ) {

    float fFinalRange = fBaseRange;

    	if(IsFormActive(OBJECT_SELF, FORM_FORCE_I_FOCUS)){ 
		fFinalRange = fFinalRange * 1.00f;
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_II_POTENCY)){ 
		fFinalRange = fFinalRange * 2.00f;
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_III_AFFINITY)){
		fFinalRange = fFinalRange * 3.00f;
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_IV_MASTERY)){ 
		fFinalRange = fFinalRange * 4.00f;
	}
    return fFinalRange;
}
/*
int Sp_MySavingThrows(object oTarget, int iSpellDC = 0)
{
    int nSave;
    int nMod;

    // FAK - OEI , for allowing spell based DC
    if (iSpellDC > 0)
    {
        nMod = iSpellDC;
    }
    else
    {
        nMod = Sp_GetJediDCSave();
    }

    // DJS-OEI 7/20/2004
    // Form/Stance re-design.
    /////////////////////////////////////////////////
    // Modifiers due to caster's Form
    /////////////////////////////////////////////////
    if( IsFormActive( OBJECT_SELF, FORM_FORCE_IV_MASTERY ) ) {
        // +2 bonus to DC.
        nMod += 2;
    }

    /////////////////////////////////////////////////
    // Modifiers due to target's Form
    /////////////////////////////////////////////////
    // If the target has a bonus to saves, we just decrease
    // the DC by that amount. If it's a penalty, we increase it.
    if( IsFormActive( oTarget, FORM_SABER_II_MAKASHI ) ||
        IsFormActive( oTarget, FORM_FORCE_I_FOCUS ) ) {
        // +2 bonus to save.
        nMod -= 2;
    }
    else if( IsFormActive( oTarget, FORM_SABER_VI_NIMAN ) ) {
        // +1 bonus to save.
        nMod -= 1;
    }
    else if( IsFormActive( oTarget, FORM_SABER_VII_JUYO ) ||
             IsFormActive( oTarget, FORM_FORCE_IV_MASTERY ) ) {
        // -4 penalty to save.
        nMod += 4;
    }

    /*
    /////////////////////////////////////////////////
    // Modifiers due to caster's Form
    /////////////////////////////////////////////////

    // DJS-OEI 3/25/2004
    // The Power of the Dark Side Form provides bonuses to the
    // DC of the save.
    if( IsFormActive( OBJECT_SELF, FORM_CONSULAR_POWER_OF_THE_DARK_SIDE_I ) ) {
        // +1 bonus to DC.
        nMod += 1;
    }
    else if( IsFormActive( OBJECT_SELF, FORM_CONSULAR_POWER_OF_THE_DARK_SIDE_II ) ||
             IsFormActive( OBJECT_SELF, FORM_CONSULAR_POWER_OF_THE_DARK_SIDE_III ) ) {
        // +2 bonus to DC.
        nMod += 2;
    }

    /////////////////////////////////////////////////
    // Modifiers due to target's Form
    /////////////////////////////////////////////////

    // DJS-OEI 3/16/2004
    // The Total Defense Stance gives Jedis a +4 to their
    // saving throws versus force powers. We just decrease
    // the DC by that amount.
    if( IsInTotalDefense( oTarget ) && Sp_IsJedi( oTarget ) ) {
        nMod -= 4;
    }

    // DJS-OEI 3/25/2004
    // The Ancient Lightsaber Form provides bonuses to saves,
    // which we handle as decreases to the DC.
    if( IsFormActive( oTarget, FORM_LIGHTSABER_ANCIENT_I ) ||
        IsFormActive( oTarget, FORM_LIGHTSABER_ANCIENT_II ) ) {
        // +1 bonus to save.
        nMod -= 1;
    }
    else if( IsFormActive( oTarget, FORM_LIGHTSABER_ANCIENT_III ) ) {
        // +2 bonus to save.
        nMod -= 2;
    }

    // DJS-OEI 3/25/2004
    // The Force Armor I-III Form provides bonuses to saves,
    // which we handle as decreases to the DC.
    if( IsFormActive( oTarget, FORM_CONSULAR_FORCE_SHELL_I ) ) {
        // +2 bonus to save.
        nMod -= 2;
    }
    else if( IsFormActive( oTarget, FORM_CONSULAR_FORCE_SHELL_II ) ) {
        // +4 bonus to save.
        nMod -= 4;
    }
    else if( IsFormActive( oTarget, FORM_CONSULAR_FORCE_SHELL_III ) ) {
        // +6 bonus to save.
        nMod -= 6;
    }
    /////////////////////////////

    if( nMod < 0 ) {
        nMod = 0;
    }

    if(SWFP_PRIVATE_SAVE_TYPE == SAVING_THROW_FORT)
    {
        nSave = FortitudeSave(oTarget,nMod, SWFP_PRIVATE_SAVE_VERSUS_TYPE);
        SP_MyPrintString("Fort Save = " + IntToString(nSave) + " For DC of " + IntToString(nMod));
    }
    else if(SWFP_PRIVATE_SAVE_TYPE == SAVING_THROW_REFLEX)
    {
        nSave = ReflexSave(oTarget, nMod, SWFP_PRIVATE_SAVE_VERSUS_TYPE);
        SP_MyPrintString("Reflex Save = " + IntToString(nSave)+" For DC of " + IntToString(nMod));
    }
    else if(SWFP_PRIVATE_SAVE_TYPE == SAVING_THROW_WILL)
    {
        nSave = WillSave(oTarget, nMod, SWFP_PRIVATE_SAVE_VERSUS_TYPE);
        SP_MyPrintString("Will Save = " + IntToString(nSave)+" For DC of " + IntToString(nMod));
    }
    if(nSave > 0)
    {
        ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectForceResisted(OBJECT_SELF), oTarget);
        DisplayFeedBackText(oTarget, 2);
    }
    return nSave;
}
*/
void Sp_RemoveSpellEffects(int nSpell_ID, object oCaster, object oTarget)
{
    int bValid = FALSE;
    effect eAOE;
    if(GetHasSpellEffect(nSpell_ID, oTarget))
    {
        eAOE = GetFirstEffect(oTarget);
        while (GetIsEffectValid(eAOE) && bValid == FALSE)
        {
            if (GetEffectCreator(eAOE) == oCaster)
            {
                if(GetEffectSpellId(eAOE) == nSpell_ID)
                {
                    RemoveEffect(oTarget, eAOE);
                    bValid = TRUE;
                }
            }
            eAOE = GetNextEffect(oTarget);
        }
    }
}

void Sp_RemoveSpecificEffect(int nEffectTypeID, object oTarget)
{
    //Declare major variables
    //Get the object that is exiting the AOE
    int bValid = FALSE;
    effect eAOE;
    //Search through the valid effects on the target.
    eAOE = GetFirstEffect(oTarget);
    while (GetIsEffectValid(eAOE))
    {
        if (GetEffectType(eAOE) == nEffectTypeID)
        {
            //If the effect was created by the spell then remove it
            bValid = TRUE;
            RemoveEffect(oTarget, eAOE);
        }
        //Get next effect on the target
        eAOE = GetNextEffect(oTarget);
    }
}

float Sp_GetSpellEffectDelay(location SpellTargetLocation, object oTarget)
{
    float fDelay;
    return fDelay = GetDistanceBetweenLocations(SpellTargetLocation, GetLocation(oTarget))/20;
}

float Sp_GetRandomDelay(float fMinimumTime = 0.4, float MaximumTime = 1.1)
{
    float fRandom = MaximumTime - fMinimumTime;
    int nRandom;
    if(fRandom < 0.0)
    {
        return 0.0;
    }
    else
    {
        nRandom = FloatToInt(fRandom  * 10.0);
        nRandom = Random(nRandom) + 1;
        fRandom = IntToFloat(nRandom);
        fRandom /= 10.0;
        return fRandom + fMinimumTime;
    }
}

int Sp_GetJediDCSave()
{
    int nDC = GetSpellSaveDC();
    return nDC;
}

void Sp_ApplyForcePowerEffects(float fTime, effect eEffect, object oTarget)
{
    float fDelay;
    int nRoll = d6();
    fDelay = IntToFloat(nRoll)/10.0;
    if(fTime == 1000.0)
    {
        ApplyEffectToObject(DURATION_TYPE_PERMANENT, eEffect, oTarget);
    }
    else if(fTime == 0.0)
    {
        DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eEffect, oTarget));
    }
    else
    {
        ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eEffect, oTarget, fTime);
    }
}

int SP_CheckEnergyResistance(object oTarget)
{
    // DJS-OEI 12/9/2003
    // Added Master Energy Resistance to the check.
    if( GetHasSpellEffect(FORCE_POWER_RESIST_COLD_HEAT_ENERGY, oTarget) ||
        GetHasSpellEffect(FORCE_POWER_RESIST_POISON_DISEASE_SONIC, oTarget) ||
        GetHasSpellEffect(FORCE_POWER_MASTER_ENERGY_RESISTANCE, oTarget) )
    {
        return TRUE;
    }
    return FALSE;
}
//::///////////////////////////////////////////////
//:: While Loop Effect Delivery
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Uses these values to deliver the effects in the
    loop.

    SWFP_PRIVATE_SAVE_TYPE;
    SWFP_PRIVATE_SAVE_VERSUS_TYPE;
    SWFP_DAMAGE;
    SWFP_DAMAGE_TYPE;
    SWFP_DAMAGE_VFX;
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Aug 2, 2002
//:://////////////////////////////////////////////

void Sp_ApplyEffects(int nBlocking, object oAnchor, float fSize, int nCounter, effect eLink1, float fDuration1, effect eLink2, float fDuration2, int nRacial = RACIAL_TYPE_ALL)
{
    int nCnt = 0;
    object oTarget;
    //By setting the counter to 1 you specify a single target.
    //By setting the counter to 1000, you specify all targets in a shape.
    //By setting the counter to another number you specify that many targets maximum.
    if(nCounter > 1)
    {
        oTarget = GetFirstObjectInShape(SWFP_SHAPE, fSize, GetLocation(oAnchor));
    }
    else if(nCounter == 1)
    {
        oTarget = oAnchor;
    }
    while(GetIsObjectValid(oTarget) && nCnt < nCounter)
    {
        if(nRacial == GetRacialType(oTarget) || nRacial == RACIAL_TYPE_ALL)
        {
            int nIdx = 0; // Index for the for loop link application.
            effect eUse;  // Current effect to use
            float fUse;   // Current duration to use
            int nDamage;  // The damage as set from SWFP_DAMAGE
            int bFizzle;  // Tracks whether the Fizzle has played on the caster yet or not.
            effect eDamage; // The damage effect which will be linked after the saves are done and checked with blocking.
            if((GetIsEnemy(oTarget) && SWFP_HARMFUL == TRUE) || (GetIsFriend(oTarget) && SWFP_HARMFUL == FALSE))
            {
                SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), SWFP_HARMFUL));
                //eDamage = EffectDamage(SWFP_DAMAGE, SWFP_DAMAGE_TYPE);
                int nResist = FALSE;
                int nSaves = -1;
                if(SWFP_HARMFUL == TRUE)
                {
                    nResist = Sp_BlockingChecks(oTarget, eLink1, eLink2, eDamage);
                }
                //By adding another index the number of links added to this function can increase.
                for(nIdx; nIdx <= 1; nIdx++)
                {
                    if(nIdx == 0)
                    {
                        eUse = eLink1;
                        fUse = fDuration1;
                    }
                    else
                    {
                        eUse = eLink2;
                        fUse = fDuration2;
                    }
                    if(nResist == FALSE)
                    {
                        //MODIFIED by Preston Watamaniuk March 23
                         //Moved the save call down to here from up above with the resist inorder to help
                         //feedback system not make useless save calls.
                        //MODIFIED by Preston Watamaniuk March 24
                         //Made the default value of nSave -1 so that I only do it once.
                        //MODIFIED by Preston Watamaniuk April 5
                         //Made sure to set nSaves to FALSE so that it would fall through the function.
                        if(SWFP_HARMFUL == TRUE && nSaves == -1)
                        {
                            int nDcMod          = 0;
                            int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
                            nSaves              = FortitudeSave(oTarget, nDifficulty);
                        }
                        else
                        {
                            nSaves = 0;
                        }
                        if(nSaves == 0)
                        {
                            if(nIdx == 1 && SWFP_DAMAGE > 0)
                            //Damage effects are always linked to the eDamage effect which is kept seperate from
                            //all other eLink types coming in.
                            {
                                eDamage = EffectDamage(SWFP_DAMAGE, SWFP_DAMAGE_TYPE);
                                eDamage = EffectLinkEffects(eDamage, EffectVisualEffect(SWFP_DAMAGE_VFX));
                                ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
                            }
                            if(GetIsEffectValid(eUse))
                            {
                                Sp_ApplyForcePowerEffects(fUse, eUse, oTarget);
                            }
                        }
                        //If the blocking flag is true then do not apply any effects on a save.
                        else if(nSaves > 0 && nBlocking == FALSE)
                        {
                            if(nIdx == 1 && SWFP_DAMAGE > 0)
                            {
                                SWFP_DAMAGE /= 2;
                                eDamage = EffectDamage(SWFP_DAMAGE, SWFP_DAMAGE_TYPE);
                                eDamage = EffectLinkEffects(eDamage, EffectVisualEffect(SWFP_DAMAGE_VFX));
                                ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
                            }
                            if(GetIsEffectValid(eUse))
                            {
                                Sp_ApplyForcePowerEffects(fUse, eUse, oTarget);
                            }
                        }
                    }
                    if(nResist > 0 || (nSaves > 0 && nBlocking > 0))
                    {
                        if(bFizzle == FALSE)
                        {
                            ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectForceFizzle(), OBJECT_SELF);
                            bFizzle = TRUE;
                        }
                    }
                }
                nCnt++;
            }
        }
        oTarget = GetNextObjectInShape(SWFP_SHAPE, fSize, GetLocation(oAnchor), FALSE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_PLACEABLE);
    }
}

//::///////////////////////////////////////////////
//:: Remove Buff Bonuses
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Goes through and removes all of the bonuses
    from people in a 30m radius from Force Mind,
    Knight Mind, Mind Mastery and Battle Meditation
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Aug 7, 2002
//:://////////////////////////////////////////////
void Sp_RemoveBuffSpell()
{
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, 30.0, GetLocation(OBJECT_SELF));
    while(GetIsObjectValid(oTarget))
    {
        if(GetFactionEqual(oTarget))
        {
            //Declare major variables
            int bValid = FALSE;
            effect eAOE;
            if(GetHasSpellEffect(FORCE_POWER_FORCE_MIND, oTarget) ||
               GetHasSpellEffect(FORCE_POWER_MIND_MASTERY, oTarget) ||
               GetHasSpellEffect(FORCE_POWER_KNIGHT_MIND, oTarget) ||
               GetHasSpellEffect(SPECIAL_ABILITY_BATTLE_MEDITATION, oTarget))
            {
                //Search through the valid effects on the target.
                eAOE = GetFirstEffect(oTarget);
                while (GetIsEffectValid(eAOE) && bValid == FALSE)
                {
                    //If the effect was created by the spell then remove it
                    if(GetEffectSpellId(eAOE) == FORCE_POWER_FORCE_MIND ||
                       GetEffectSpellId(eAOE) == FORCE_POWER_MIND_MASTERY ||
                       GetEffectSpellId(eAOE) == FORCE_POWER_KNIGHT_MIND ||
                       GetEffectSpellId(eAOE) == SPECIAL_ABILITY_BATTLE_MEDITATION)
                    {
                        RemoveEffect(oTarget, eAOE);
                    }
                    //Get next effect on the target
                    eAOE = GetNextEffect(oTarget);
                }
            }
        }
        oTarget = GetNextObjectInShape(SHAPE_SPHERE, 30.0, GetLocation(OBJECT_SELF));
    }
}

//::///////////////////////////////////////////////
//:: Check for Appearance Type Turret
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Checks to see if the target is a Turret
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: April 10, 2003
//:://////////////////////////////////////////////
int SP_CheckAppearanceTurret(object oTarget, int nFeedback = FALSE)
{
    int nCheck = FALSE;

    SP_MyPostString("Appearance = " + IntToString(GetAppearanceType(oTarget)));

    // DJS-OEI 10/24/2004
    // Added some new Turret types.
    if(GetAppearanceType(oTarget) == 182 ||
       GetAppearanceType(oTarget) == 183 ||
       GetAppearanceType(oTarget) == 640 ||
       GetAppearanceType(oTarget) == 657 )
    {
        if(nFeedback == TRUE)
        {
            DisplayFeedBackText(oTarget, 1);
        }
        nCheck = TRUE;
    }
    return nCheck;
}

//::///////////////////////////////////////////////
//:: Check Droid Appearance Type
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Checks to see if the target is a Mark 1, 2, 4
    or Spyder Droid
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: April 10, 2003
//:://////////////////////////////////////////////
int SP_CheckAppearanceGeoDroid(object oTarget)
{
    int nCheck = FALSE;
    if(GetAppearanceType(oTarget) == 59 ||
       GetAppearanceType(oTarget) == 60 ||
       GetAppearanceType(oTarget) == 61 ||
       GetAppearanceType(oTarget) == 65)
    {
        nCheck = TRUE;
    }
    return nCheck;
}

//::///////////////////////////////////////////////
//:: Check Droid Appearance Type and and Shields
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Checks to see if the target is a Mark 1, 2, 4
    or Spyder Droid and has a shield activated
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: April 10, 2003
//:://////////////////////////////////////////////
int SP_CheckAppearanceGeoDroidShields(object oTarget, int nFeedback = FALSE)
{
    int nCheck = FALSE;
    if(GetAppearanceType(oTarget) == 59 ||
       GetAppearanceType(oTarget) == 60 ||
       GetAppearanceType(oTarget) == 61 ||
       GetAppearanceType(oTarget) == 65)
    {
        if(GetHasSpellEffect(110, oTarget) ||
           GetHasSpellEffect(111, oTarget) ||
           GetHasSpellEffect(112, oTarget) ||
           GetHasSpellEffect(113, oTarget) ||
           GetHasSpellEffect(114, oTarget) ||
           GetHasSpellEffect(115, oTarget))
         {
            if(nFeedback == TRUE)
            {
                DisplayFeedBackText(oTarget, 1);
            }

            nCheck = TRUE;
         }
    }
    return nCheck;
}

//::///////////////////////////////////////////////
//:: Force Push Viability
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Returns TRUE if the target can be force pushed
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: June 12, 2003
//:://////////////////////////////////////////////
int SP_CheckForcePushViability(object oTarget, int Whirlwind)
{
    int bValid = FALSE;

    SP_MyPrintString("Push Check Start");
    if(GetCreatureSize(oTarget) != CREATURE_SIZE_LARGE &&
       GetCreatureSize(oTarget) != CREATURE_SIZE_HUGE)
    {
        SP_MyPrintString("Size is OK");
        if(SP_CheckAppearanceTurret(oTarget) == FALSE)
        {
            SP_MyPrintString("I am not a turret");
            if((Whirlwind == TRUE && SP_CheckAppearanceGeoDroidShields(oTarget) == FALSE) ||
                Whirlwind == FALSE)
            {
                SP_MyPrintString("I am whirlwind without droid shiled or not whirlwind");
                if(GetCreatureMovmentType(oTarget) != MOVEMENT_SPEED_IMMOBILE)
                {
                    SP_MyPrintString("Returning Push True");
                    bValid = TRUE;
                }
            }
        }
    }

    if(bValid == FALSE)
    {
        DisplayFeedBackText(oTarget, 1);
    }
    return bValid;
}


void SP_MyPrintString(string sString)
{
    if(!ShipBuild())
    {
        sString = "SPELL GENERIC DEBUG STRING: " + sString;
        PrintString(sString);
    }
}

void SP_MyPostString(string sString, int n1 = 5, int n2 = 10, float fTime = 4.0)
{
    sString = "DEBUG: " + sString;
    AurPostString(sString,10,10,3.0);
}

void Sp_RemoveRelatedPowersInRadius( int nPowerID, float nRadius ) {

    // DJS-OEI 12/10/2003
    // This function makes use of the Sp_RemoveRelatedPowers()
    // function to allow removal of lesser related powers on multiple
    // targets in a radius. These targets must be of the same
    // faction as the caster (OBJECT_SELF). This may need to be
    // changed if/when new force powers are created that require
    // ranged removal versus enemies.
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, nRadius, GetLocation(OBJECT_SELF));
    while(GetIsObjectValid(oTarget))
    {
        if(GetFactionEqual(oTarget))
        {
            JD_RemoveRelatedPowers( oTarget, nPowerID );
        }
        oTarget = GetNextObjectInShape(SHAPE_SPHERE, nRadius, GetLocation(OBJECT_SELF));
    }
}

//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: July 30, 2002
//:://////////////////////////////////////////////  

int JD_GetSaveDC(object oCaster = OBJECT_SELF,int nDcMod = 0)
{
   int nDc = 0;;
   int StockDC = GetSpellSaveDC();
   if(GetFeatAcquired(JD_SUPERIOR_FOCUS_SIX, oCaster)){
      nDc = GetHitDice(OBJECT_SELF) / 1;
   }
   else if(GetFeatAcquired(JD_SUPERIOR_FOCUS_FIVE, oCaster)){  
      nDc = GetHitDice(OBJECT_SELF) / 2;
   }   
   else if(GetFeatAcquired(JD_SUPERIOR_FOCUS_FOUR, oCaster)){  
      nDc = GetHitDice(OBJECT_SELF) / 3;
   }
   else if(GetFeatAcquired(JD_SUPERIOR_FOCUS_THREE, oCaster)){  
      nDc = GetHitDice(OBJECT_SELF) / 4;
   }  
   else if(GetFeatAcquired(JD_SUPERIOR_FOCUS_TWO, oCaster)){  
      nDc = GetHitDice(OBJECT_SELF) / 5;
   } 
   else if(GetFeatAcquired(JD_SUPERIOR_FOCUS_ONE, oCaster)){  
      nDc = GetHitDice(OBJECT_SELF) / 6;
   } 
   nDc += StockDC;
   if(nDc > 110){
      nDc = 110;
   }
   return nDc;   
}

void JD_SignalPartyEvent(object oParty, int nSpell, int bHarmful=TRUE) {   
   int nCnt = 0;
   if(IsObjectPartyMember(OBJECT_SELF))
   {
      oParty = GetPartyMemberByIndex(nCnt);
   }
   else
   {
      oParty = OBJECT_SELF;
   }
   while(nCnt < 3)
   {
	if( GetIsObjectValid(oParty) )
      {
         SignalEvent(oParty, EventSpellCastAt(GetSpellTargetObject(), FORCE_POWER_FORCE_STORM, bHarmful));
      }
      nCnt++;
      if(IsObjectPartyMember(OBJECT_SELF))
      {
         oParty = GetPartyMemberByIndex(nCnt);
      }
      else
      {
         oParty = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_FRIEND, OBJECT_SELF, nCnt);
      }
   }
}

void JD_SignalEnemyEvent( object oParty ) {   
   int nCnt = 0;
   if(IsObjectPartyMember(OBJECT_SELF))
   {
      oParty = GetPartyMemberByIndex(nCnt);
   }
   else
   {
      oParty = OBJECT_SELF;
   }
   while(nCnt < 3)
   {
	if( GetIsObjectValid(oParty) )
      {
         SignalEvent(oParty, EventSpellCastAt(GetFirstPC(), FORCE_POWER_FORCE_STORM, TRUE));
      }
      nCnt++;
      if(IsObjectPartyMember(OBJECT_SELF))
      {
         oParty = GetPartyMemberByIndex(nCnt);
      }
      else
      {
         oParty = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_FRIEND, OBJECT_SELF, nCnt);
      }
   }
}

location GetBehindLocation(object oTarget) {
    vector vBehind = GetPosition(oTarget) + AngleToVector(GetFacing(OBJECT_SELF)) * 0.5;
    return Location(vBehind, GetFacing(OBJECT_SELF));
}

int JD_CalcBuffBonus( object oCaster, int nBonus  ) {
   if(GetFeatAcquired(JD_FOCUS_BUFF_NINE)){
      nBonus += (nBonus * 100) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_EIGHT)){  
      nBonus += (nBonus * 80) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_SEVEN)){  
      nBonus += (nBonus * 70) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_SIX)){  
      nBonus += (nBonus * 60) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_FIVE)){  
      nBonus += (nBonus * 50) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_FOUR)){  
      nBonus += (nBonus * 40) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_THREE)){  
      nBonus += (nBonus * 30) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_TWO)){  
      nBonus += (nBonus * 20) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_ONE)){  
      nBonus += (nBonus * 10) / 100;
   }
   if (((nBonus + 1) > nBonus) && (GetFeatAcquired(JD_FOCUS_BUFF_NINE) ||
      GetFeatAcquired(JD_FOCUS_BUFF_EIGHT) ||
      GetFeatAcquired(JD_FOCUS_BUFF_SEVEN) ||
      GetFeatAcquired(JD_FOCUS_BUFF_SIX)   ||
      GetFeatAcquired(JD_FOCUS_BUFF_FIVE)  ||
      GetFeatAcquired(JD_FOCUS_BUFF_FOUR)  ||
      GetFeatAcquired(JD_FOCUS_BUFF_THREE) ||
      GetFeatAcquired(JD_FOCUS_BUFF_TWO)   ||
      GetFeatAcquired(JD_FOCUS_BUFF_ONE))) {
      nBonus += 1;
   }
   return nBonus;   
}

float JD_CalcDuration( object oCaster, float fDuration ){
   if(GetFeatAcquired(JD_EXTEND_NINE, oCaster)){
      fDuration += (fDuration * 100) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_EIGHT, oCaster)){  
      fDuration += (fDuration * 80) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_SEVEN, oCaster)){  
      fDuration += (fDuration * 70) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_SIX, oCaster)){  
      fDuration += (fDuration * 60) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_FIVE, oCaster)){  
      fDuration += (fDuration * 50) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_FOUR, oCaster)){  
      fDuration += (fDuration * 40) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_THREE, oCaster)){  
      fDuration += (fDuration * 30) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_TWO, oCaster)){  
      fDuration += (fDuration * 20) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_ONE, oCaster)){  
      fDuration += (fDuration * 10) / 100;
   }
   if(IsFormActive(oCaster, FORM_FORCE_IV_MASTERY)){
      fDuration += (fDuration * 50) / 100;
   }
   return fDuration;
}

void JD_ForcePowerCost( object oCaster, int nSpellId, int nIsBuff) {
   int nCost = 0;
   int nStartCost = GetSpellForcePointCost();
   if(GetFeatAcquired(JD_EXTEND_NINE, oCaster)){
      nCost = (nStartCost * 100) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_EIGHT, oCaster)){  
      nCost = (nStartCost * 80) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_SEVEN, oCaster)){  
      nCost = (nStartCost * 70) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_SIX, oCaster)){  
      nCost = (nStartCost * 60) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_FIVE, oCaster)){  
      nCost = (nStartCost * 50) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_FOUR, oCaster)){  
      nCost = (nStartCost * 40) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_THREE, oCaster)){  
      nCost = (nStartCost * 30) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_TWO, oCaster)){  
      nCost = (nStartCost * 20) / 100;
   }
   else if(GetFeatAcquired(JD_EXTEND_ONE, oCaster)){  
      nCost = (nStartCost * 10) / 100;
   }
   if(GetFeatAcquired(JD_FOCUS_BUFF_NINE, oCaster) && (nIsBuff == TRUE)){
      nCost += (nStartCost * 100) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_EIGHT, oCaster) && (nIsBuff == TRUE)){  
      nCost += (nStartCost * 80) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_SEVEN, oCaster) && (nIsBuff == TRUE)){  
      nCost += (nStartCost * 70) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_SIX, oCaster) && (nIsBuff == TRUE)){  
      nCost += (nStartCost * 60) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_FIVE, oCaster) && (nIsBuff == TRUE)){  
      nCost += (nStartCost * 50) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_FOUR, oCaster) && (nIsBuff == TRUE)){  
      nCost += (nStartCost * 40) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_THREE, oCaster) && (nIsBuff == TRUE)){  
      nCost += (nStartCost * 30) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_TWO, oCaster) && (nIsBuff == TRUE)){  
      nCost += (nStartCost * 20) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_BUFF_ONE, oCaster) && (nIsBuff == TRUE)){  
      nCost += (nStartCost * 10) / 100;
   }
   if(GetFeatAcquired(JD_FOCUS_DAMAGE_NINE, oCaster) && (nIsBuff == FALSE)){
      nCost += (nStartCost * 100) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_EIGHT, oCaster) && (nIsBuff == FALSE)){  
      nCost += (nStartCost * 80) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_SEVEN, oCaster) && (nIsBuff == FALSE)){  
      nCost += (nStartCost * 70) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_SIX, oCaster) && (nIsBuff == FALSE)){  
      nCost += (nStartCost * 60) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_FIVE, oCaster) && (nIsBuff == FALSE)){  
      nCost += (nStartCost * 50) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_FOUR, oCaster) && (nIsBuff == FALSE)){  
      nCost += (nStartCost * 40) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_THREE, oCaster) && (nIsBuff == FALSE)){  
      nCost += (nStartCost * 30) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_TWO, oCaster) && (nIsBuff == FALSE)){  
      nCost += (nStartCost * 20) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_ONE, oCaster) && (nIsBuff == FALSE)){  
      nCost += (nStartCost * 10) / 100;
   }
   if(nCost > 0){
       effect eForceCost = EffectDamageForcePoints(nCost);
       ApplyEffectToObject(DURATION_TYPE_INSTANT, eForceCost , oCaster);
   }
}

int JD_GetIsPrep(object oCaster, int nSpellId) {
   if ((nSpellId == JD_REZ_SUP_MSTR)
   || (nSpellId == JD_PREP)
   || (nSpellId == JD_PREP_IMP)
   || (nSpellId == JD_PREP_MSTR) 
   || (nSpellId == JD_PREP_SUP) 
   || (nSpellId == JD_PREP_SUP_IMP) 
   || (nSpellId == JD_PREP_SUP_MSTR)) {
      return TRUE;
   }
   return FALSE;
}

int JD_GetIsPrepNotRez(object oCaster, int nSpellId) {
   if ((nSpellId == JD_PREP)
   || (nSpellId == JD_PREP_IMP)
   || (nSpellId == JD_PREP_MSTR) 
   || (nSpellId == JD_PREP_SUP) 
   || (nSpellId == JD_PREP_SUP_IMP) 
   || (nSpellId == JD_PREP_SUP_MSTR)) {
      return TRUE;
   }
   return FALSE;
}

int JD_CalcDamage( object oCaster, int nNumDice, int nSizeDice, int nFlatAmount ) {

   int nDamage = 0;
   int nCount;
   int nRoll = 0;
   if((nNumDice > 0) && (nSizeDice > 0)) {
      for (nCount = 1; nCount <= nNumDice; nCount++) {
         nRoll = Random(nSizeDice) + 1;
         if(GetFeatAcquired(JD_MAXIMIZE_NINE, OBJECT_SELF)){
            if(nRoll < 10) { 
               nRoll = 10;
            }
         }
         else if(GetFeatAcquired(JD_MAXIMIZE_EIGHT, OBJECT_SELF)){  
            if(nRoll < 9) { 
               nRoll = 9;
            }
         }  
         else if(GetFeatAcquired(JD_MAXIMIZE_SEVEN, OBJECT_SELF)){  
            if(nRoll < 8) { 
               nRoll = 8;
            }
         } 
         else if(GetFeatAcquired(JD_MAXIMIZE_SIX, OBJECT_SELF)){  
            if(nRoll < 7) { 
               nRoll = 7;
            }
         }  
         else if(GetFeatAcquired(JD_MAXIMIZE_FIVE, OBJECT_SELF)){  
            if(nRoll < 6) { 
               nRoll = 6;
            }
         } 
         else if(GetFeatAcquired(JD_MAXIMIZE_FOUR, OBJECT_SELF)){  
            if(nRoll < 5) { 
               nRoll = 5;
            }
         } 
         else if(GetFeatAcquired(JD_MAXIMIZE_THREE, OBJECT_SELF)){  
            if(nRoll < 4) { 
               nRoll = 4;
            }
         } 
         else if(GetFeatAcquired(JD_MAXIMIZE_TWO, OBJECT_SELF)){  
            if(nRoll < 3) { 
               nRoll = 3;
            }
         } 
         else if(GetFeatAcquired(JD_MAXIMIZE_ONE, OBJECT_SELF)){  
            if(nRoll < 2) { 
               nRoll = 2;
            }
         } 
         nDamage += nRoll;
      }
   }
   nDamage += GetAbilityModifier(ABILITY_WISDOM) + GetAbilityModifier(ABILITY_CHARISMA) + nFlatAmount;

   if(GetHasSpellEffect(JD_PREP_SUP_MSTR, OBJECT_SELF)) {
      nDamage += 90;
   } 
   else if(GetHasSpellEffect(JD_PREP_SUP_IMP, OBJECT_SELF)){
      nDamage += 75;
   } 
   else if(GetHasSpellEffect(JD_PREP_SUP, OBJECT_SELF)){
      nDamage += 60;
   } 
   else if(GetHasSpellEffect(JD_PREP_MSTR, OBJECT_SELF)){
      nDamage += 45;
   } 
   else if(GetHasSpellEffect(JD_PREP_IMP, OBJECT_SELF)){
      nDamage += 30;
   } 
   else if(GetHasSpellEffect(JD_PREP, OBJECT_SELF)){
      nDamage += 15;
   }   
   if(GetFeatAcquired(JD_EMPOWER_NINE, OBJECT_SELF)){
      nDamage += (GetHitDice(oCaster) * 3);
   }
   else if(GetFeatAcquired(JD_EMPOWER_EIGHT, OBJECT_SELF)){  
      nDamage += (GetHitDice(OBJECT_SELF) / 3) + (GetHitDice(OBJECT_SELF) * 2);
   }  
   else if(GetFeatAcquired(JD_EMPOWER_SEVEN, OBJECT_SELF)){  
      nDamage += (GetHitDice(OBJECT_SELF) / 6) + (GetHitDice(OBJECT_SELF) * 2);
   } 
   else if(GetFeatAcquired(JD_EMPOWER_SIX, OBJECT_SELF)){  
      nDamage += (GetHitDice(OBJECT_SELF) * 2);
   } 
   else if(GetFeatAcquired(JD_EMPOWER_FIVE, OBJECT_SELF)){  
      nDamage += (GetHitDice(OBJECT_SELF) / 3) + GetHitDice(OBJECT_SELF);
   } 
   else if(GetFeatAcquired(JD_EMPOWER_FOUR, OBJECT_SELF)){  
      nDamage += (GetHitDice(OBJECT_SELF) / 6) + GetHitDice(OBJECT_SELF);
   } 
   else if(GetFeatAcquired(JD_EMPOWER_THREE, OBJECT_SELF)){  
      nDamage += GetHitDice(OBJECT_SELF);
   } 
   else if(GetFeatAcquired(JD_EMPOWER_TWO, OBJECT_SELF)){  
      nDamage += (GetHitDice(oCaster) / 3);
   } 
   else if(GetFeatAcquired(JD_EMPOWER_ONE, OBJECT_SELF)){  
      nDamage += (GetHitDice(oCaster) / 6);
   } 
   if(GetFeatAcquired(JD_FOCUS_DAMAGE_NINE, OBJECT_SELF)){
      nDamage += (nDamage * 100) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_EIGHT, OBJECT_SELF)){  
      nDamage += (nDamage * 80) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_SEVEN, OBJECT_SELF)){  
      nDamage += (nDamage * 70) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_SIX, OBJECT_SELF)){  
      nDamage += (nDamage * 60) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_FIVE, OBJECT_SELF)){  
      nDamage += (nDamage * 50) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_FOUR, OBJECT_SELF)){  
      nDamage += (nDamage * 40) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_THREE, OBJECT_SELF)){  
      nDamage += (nDamage * 30) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_TWO, OBJECT_SELF)){  
      nDamage += (nDamage * 20) / 100;
   }
   else if(GetFeatAcquired(JD_FOCUS_DAMAGE_ONE, OBJECT_SELF)){  
      nDamage += (nDamage * 10) / 100;
   }
   if(IsFormActive(OBJECT_SELF, FORM_FORCE_I_FOCUS)){ 
      nDamage += (nDamage*50)/100;
      int nDamageAdded = nDamage/50;
      SP_MyPrintString(IntToString(nDamage) + "added - " + IntToString(nDamageAdded));
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_II_POTENCY)){ 
      nDamage += (nDamage*100)/100;
      int nDamageAdded = nDamage/100;
      SP_MyPrintString(IntToString(nDamage) + "added - " + IntToString(nDamageAdded));
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_III_AFFINITY)){
      nDamage += (nDamage*150)/100;
      int nDamageAdded = nDamage/150;
      SP_MyPrintString(IntToString(nDamage) + "added - " + IntToString(nDamageAdded));
	}
	else if(IsFormActive(OBJECT_SELF, FORM_FORCE_IV_MASTERY)){ 
      nDamage += (nDamage*200)/100;
      int nDamageAdded = nDamage/200;
      SP_MyPrintString(IntToString(nDamage) + "added - " + IntToString(nDamageAdded));
	}
   return nDamage;
}

int JD_GetDemoDC(int nDCMod,object oCaster,object oVictom)
{
    int nDC = 0;	
    if(GetHasFeat(FEAT_UNCANNY_DODGE_2,oVictom))
    {
        nDC -= 20;
    }
    else if(GetHasFeat(FEAT_UNCANNY_DODGE_1,oVictom))
    {
        nDC -= 10;
    }
    if(GetHasFeat(FEAT_WEAPON_SPECIALIZATION_GRENADE,oCaster))
    {
        nDC += 10;
    }
    if( GetSkillRank( SKILL_DEMOLITIONS, oCaster ) > 0 ) {
        nDC += (nDCMod + GetSkillRank( SKILL_DEMOLITIONS, oCaster ) ); 
    }
    if(nDC > 110) {
        nDC = 110;
    }
    return nDC;
}

int JD_GetDemoDMG(int nDMGMod, int nStaticDMG, object oCaster)
{
   int nDamage = 0;
   if( GetSkillRank( SKILL_DEMOLITIONS, oCaster ) > 0 ) {
      nDamage += (nDMGMod * GetSkillRank( SKILL_DEMOLITIONS, oCaster ) );
   }
   if(GetHasSpellEffect(JD_PREP_SUP_MSTR, OBJECT_SELF)) {
      nDamage += 90;
   } 
   else if(GetHasSpellEffect(JD_PREP_SUP_IMP, OBJECT_SELF)){
      nDamage += 75;
   } 
   else if(GetHasSpellEffect(JD_PREP_SUP, OBJECT_SELF)){
      nDamage += 60;
   } 
   else if(GetHasSpellEffect(JD_PREP_MSTR, OBJECT_SELF)){
      nDamage += 45;
   } 
   else if(GetHasSpellEffect(JD_PREP_IMP, OBJECT_SELF)){
      nDamage += 30;
   } 
   else if(GetHasSpellEffect(JD_PREP, OBJECT_SELF)){
      nDamage += 15;
   } 
   if(GetFeatAcquired(JD_DEMO_SIX, OBJECT_SELF)){  
      nDamage += 120;
   }
   else if(GetFeatAcquired(JD_DEMO_FIVE, OBJECT_SELF)){  
      nDamage += 100;
   }
   else if(GetFeatAcquired(JD_DEMO_FOUR, OBJECT_SELF)){  
      nDamage += 80;
   }
   else if(GetFeatAcquired(JD_DEMO_THREE, OBJECT_SELF)){  
      nDamage += 60;
   }
   else if(GetFeatAcquired(JD_DEMO_TWO, OBJECT_SELF)){  
      nDamage += 40;
   }
   else if(GetFeatAcquired(JD_DEMO_ONE, OBJECT_SELF)){  
      nDamage += 20;
   }
   //SendMessageToPC(GetPartyLeader(),"Before calc " + IntToString(nDamage)); 
   if(GetFeatAcquired(FEAT_WEAPON_SPECIALIZATION_GRENADE, OBJECT_SELF)){ 
      //SendMessageToPC(GetPartyLeader(), "Before 250 grenade " + IntToString(nDamage));   
      nDamage = (nDamage * 300) / 100;
	  //SendMessageToPC(GetPartyLeader(),"After 250 grenade " + IntToString(nDamage));
	  //SendMessageToPC(GetPartyLeader(),IntToString(FEAT_WEAPON_SPECIALIZATION_GRENADE) + " " + IntToString(48));
   }
   else if(GetFeatAcquired(FEAT_WEAPON_FOCUS_GRENADE , OBJECT_SELF)){
      //SendMessageToPC(GetPartyLeader(),"Before 200 grenade " + IntToString(nDamage));    
      nDamage = (nDamage * 250) / 100;
	  //SendMessageToPC(GetPartyLeader(),"After 200 grenade " + IntToString(nDamage));
	  //SendMessageToPC(GetPartyLeader(),IntToString(FEAT_WEAPON_FOCUS_GRENADE) + " " + IntToString(34));
   }
   else if(GetFeatAcquired(FEAT_WEAPON_PROFICIENCY_GRENADE, OBJECT_SELF)){  
      //SendMessageToPC(GetPartyLeader(),"Before 150 grenade " + IntToString(nDamage)); 
      nDamage = (nDamage * 200) / 100;
	  //SendMessageToPC(GetPartyLeader(),"After 150 grenade " + IntToString(nDamage));
	  //SendMessageToPC(GetPartyLeader(),IntToString(FEAT_WEAPON_PROFICIENCY_GRENADE) + " " + IntToString(41));
   }
   nDamage += nStaticDMG + GetAbilityModifier(ABILITY_DEXTERITY) + GetAbilityModifier(ABILITY_INTELLIGENCE);
   if((GetObjectByTag("T3M4") == OBJECT_SELF) || (GetObjectByTag("HK47") == OBJECT_SELF)){  
      //SendMessageToPC(GetPartyLeader(),  "Before Boost " + IntToString(nDamage));
      nDamage = nDamage * 5;
	  //SendMessageToPC(GetPartyLeader(),  "After Boost " + IntToString(nDamage));
   }
   if (nDamage > 10000) {
      nDamage = 10000;
   }
   return nDamage;
}

float JD_GetDemoRadius(float fRadiusMod,float fStaticRadius,object oCaster)
{
   float fRadius;
   if( GetSkillRank( SKILL_DEMOLITIONS, oCaster ) > 0 ) {
      fRadius = (fRadiusMod * GetSkillRank( SKILL_DEMOLITIONS, oCaster ) );
   }
   fRadius += fStaticRadius;
   if(fRadius > 10.0){
     fRadius = 10.0; 
   }
   return fRadius;
}


/**********possible reduce force power cost feats**********************/
/*
    if( GetSpellFormMask( GetSpellId() ) & FORM_MASK_REGENERATION ) {
        object oSpellTarget = GetSpellTargetObject();
        if( GetIsObjectValid( oSpellTarget ) ) {
            if( IsFormActive( oSpellTarget, FORM_CONSULAR_REGENERATION_III ) ) {
                int nCost = ( GetSpellBaseForcePointCost( GetSpellId() ) * 20 ) / 100;
                eLink1 = EffectHealForcePoints( nCost );
                ApplyEffectToObject( DURATION_TYPE_INSTANT, eLink1, oSpellTarget );
            }
        }
    }
*/

void JD_RemoveRelatedPowers( object oTarget, int nPowerID )
{
    int nRelated1 = -1;
    int nRelated2 = -1;
    int nRelated3 = -1;
    int nRelated4 = -1;
    int nRelated5 = -1;
    int nRelated6 = -1;
    int nRelated7 = -1;

    switch ( nPowerID )
    {
        case FORCE_POWER_SLOW:
            nRelated1 = FORCE_POWER_AFFLICTION;
            nRelated2 = FORCE_POWER_PLAGUE;
            break;
        case FORCE_POWER_AFFLICTION:
            nRelated1 = FORCE_POWER_PLAGUE;
            break;
        case FORCE_POWER_FEAR:
        	nRelated1 = FORCE_POWER_HORROR;
        	nRelated2 = FORCE_POWER_INSANITY;
        	break;
        case FORCE_POWER_HORROR:
        	nRelated1 = FORCE_POWER_INSANITY;
        	break;            
        case FORCE_POWER_FORCE_AURA:
            nRelated1 = FORCE_POWER_FORCE_SHIELD;
            nRelated2 = FORCE_POWER_FORCE_ARMOR;
            nRelated3 = FORCE_POWER_FORCE_ENLIGHTENMENT;
            break;
        case FORCE_POWER_FORCE_SHIELD:
            nRelated1 = FORCE_POWER_FORCE_ARMOR;
            nRelated2 = FORCE_POWER_FORCE_ENLIGHTENMENT;
            break;
        case FORCE_POWER_RESIST_FORCE:
            nRelated1 = FORCE_POWER_FORCE_IMMUNITY;
            break;
        case FORCE_POWER_FORCE_MIND:
            nRelated1 = FORCE_POWER_KNIGHT_MIND;
            nRelated2 = FORCE_POWER_MIND_MASTERY;
            nRelated3 = FORCE_POWER_FORCE_ENLIGHTENMENT;
            break;
        case FORCE_POWER_KNIGHT_MIND:
            nRelated1 = FORCE_POWER_MIND_MASTERY;
            nRelated2 = FORCE_POWER_FORCE_ENLIGHTENMENT;
            break;
        case FORCE_POWER_RESIST_POISON_DISEASE_SONIC:
            nRelated1 = FORCE_POWER_RESIST_COLD_HEAT_ENERGY;
            nRelated2 = FORCE_POWER_MASTER_ENERGY_RESISTANCE;
            break;
        case FORCE_POWER_RESIST_COLD_HEAT_ENERGY:
            nRelated1 = FORCE_POWER_MASTER_ENERGY_RESISTANCE;
            break;
        case FORCE_POWER_STUN:
            nRelated1 = FORCE_POWER_HOLD;
            nRelated2 = FORCE_POWER_SLEEP;
            break;
        case FORCE_POWER_HOLD:
            nRelated1 = FORCE_POWER_SLEEP;
            break;
        case FORCE_POWER_SPEED_BURST:
            nRelated1 = FORCE_POWER_KNIGHT_SPEED;
            nRelated2 = FORCE_POWER_SPEED_MASTERY;
            nRelated3 = FORCE_POWER_FORCE_ENLIGHTENMENT;
            break;
        case FORCE_POWER_KNIGHT_SPEED:
            nRelated1 = FORCE_POWER_SPEED_MASTERY;
            nRelated2 = FORCE_POWER_FORCE_ENLIGHTENMENT;
            break;
        case FORCE_POWER_FORCE_BARRIER:
            nRelated1 = FORCE_POWER_IMPROVED_FORCE_BARRIER;
            nRelated2 = FORCE_POWER_MASTER_FORCE_BARRIER;
            break;
        case FORCE_POWER_IMPROVED_FORCE_BARRIER:
            nRelated1 = FORCE_POWER_MASTER_FORCE_BARRIER;
            break;
        case FORCE_POWER_BATTLE_MEDITATION_PC:
            nRelated1 = FORCE_POWER_IMPROVED_BATTLE_MEDITATION_PC;
            nRelated2 = FORCE_POWER_MASTER_BATTLE_MEDITATION_PC;
            break;
        case FORCE_POWER_IMPROVED_BATTLE_MEDITATION_PC:
            nRelated1 = FORCE_POWER_MASTER_BATTLE_MEDITATION_PC;
            break;
        case FORCE_POWER_BAT_MED_ENEMY:
            nRelated1 = FORCE_POWER_IMP_BAT_MED_ENEMY;
            nRelated2 = FORCE_POWER_MAS_BAT_MED_ENEMY;
            break;
        case FORCE_POWER_IMP_BAT_MED_ENEMY:
            nRelated1 = FORCE_POWER_MAS_BAT_MED_ENEMY;
            break;
        case FORCE_POWER_CRUSH_OPPOSITION_I:
            nRelated1 = FORCE_POWER_CRUSH_OPPOSITION_II;
            nRelated2 = FORCE_POWER_CRUSH_OPPOSITION_III;
            nRelated3 = FORCE_POWER_CRUSH_OPPOSITION_IV;
            nRelated4 = FORCE_POWER_CRUSH_OPPOSITION_V;
            nRelated5 = FORCE_POWER_CRUSH_OPPOSITION_VI;
            break;
        case FORCE_POWER_CRUSH_OPPOSITION_II:
            nRelated1 = FORCE_POWER_CRUSH_OPPOSITION_III;
            nRelated2 = FORCE_POWER_CRUSH_OPPOSITION_IV;
            nRelated3 = FORCE_POWER_CRUSH_OPPOSITION_V;
            nRelated4 = FORCE_POWER_CRUSH_OPPOSITION_VI;
            break;
        case FORCE_POWER_CRUSH_OPPOSITION_III:
            nRelated1 = FORCE_POWER_CRUSH_OPPOSITION_IV;
            nRelated2 = FORCE_POWER_CRUSH_OPPOSITION_V;
            nRelated3 = FORCE_POWER_CRUSH_OPPOSITION_VI;
            break;
        case FORCE_POWER_CRUSH_OPPOSITION_IV:
            nRelated1 = FORCE_POWER_CRUSH_OPPOSITION_V;
            nRelated2 = FORCE_POWER_CRUSH_OPPOSITION_VI;
            break;
        case FORCE_POWER_CRUSH_OPPOSITION_V:
            nRelated1 = FORCE_POWER_CRUSH_OPPOSITION_VI;
            break;
        case FORCE_POWER_FORCE_BODY:
            nRelated1 = FORCE_POWER_IMPROVED_FORCE_BODY;
            nRelated2 = FORCE_POWER_MASTER_FORCE_BODY;
            break;
        case FORCE_POWER_IMPROVED_FORCE_BODY:
            nRelated1 = FORCE_POWER_MASTER_FORCE_BODY;
            break;
        case FORCE_POWER_FORCE_SCREAM:
            nRelated1 = FORCE_POWER_IMPROVED_FORCE_SCREAM;
            nRelated2 = FORCE_POWER_MASTER_FORCE_SCREAM;
            break;
        case FORCE_POWER_IMPROVED_FORCE_SCREAM:
            nRelated1 = FORCE_POWER_MASTER_FORCE_SCREAM;
            break;
        case FORCE_POWER_FURY:
            nRelated1 = FORCE_POWER_IMPROVED_FURY;
            nRelated2 = FORCE_POWER_MASTER_FURY;
            break;
        case FORCE_POWER_IMPROVED_FURY:
            nRelated1 = FORCE_POWER_MASTER_FURY;
            break;
        case FORCE_POWER_WOOKIEE_RAGE_I:
            nRelated1 = FORCE_POWER_WOOKIEE_RAGE_II;
            nRelated2 = FORCE_POWER_WOOKIEE_RAGE_III;
            break;
        case FORCE_POWER_WOOKIEE_RAGE_II:
            nRelated1 = FORCE_POWER_WOOKIEE_RAGE_III;
            break;
        case FORCE_POWER_INSPIRE_FOLLOWERS_I:
            nRelated1 = FORCE_POWER_INSPIRE_FOLLOWERS_II;
            nRelated2 = FORCE_POWER_INSPIRE_FOLLOWERS_III;
            nRelated3 = FORCE_POWER_INSPIRE_FOLLOWERS_IV;
            nRelated4 = FORCE_POWER_INSPIRE_FOLLOWERS_V;
            nRelated5 = FORCE_POWER_INSPIRE_FOLLOWERS_VI;
            break;
        case FORCE_POWER_INSPIRE_FOLLOWERS_II:
            nRelated1 = FORCE_POWER_INSPIRE_FOLLOWERS_III;
            nRelated2 = FORCE_POWER_INSPIRE_FOLLOWERS_IV;
            nRelated3 = FORCE_POWER_INSPIRE_FOLLOWERS_V;
            nRelated4 = FORCE_POWER_INSPIRE_FOLLOWERS_VI;
            break;
        case FORCE_POWER_INSPIRE_FOLLOWERS_III:
            nRelated1 = FORCE_POWER_INSPIRE_FOLLOWERS_IV;
            nRelated2 = FORCE_POWER_INSPIRE_FOLLOWERS_V;
            nRelated3 = FORCE_POWER_INSPIRE_FOLLOWERS_VI;
            break;
        case FORCE_POWER_INSPIRE_FOLLOWERS_IV:
            nRelated1 = FORCE_POWER_INSPIRE_FOLLOWERS_V;
            nRelated2 = FORCE_POWER_INSPIRE_FOLLOWERS_VI;
            break;
        case FORCE_POWER_INSPIRE_FOLLOWERS_V:
            nRelated1 = FORCE_POWER_INSPIRE_FOLLOWERS_VI;
            break;
        case FORCE_POWER_MIND_TRICK:
            nRelated1 = FORCE_POWER_CONFUSION;
            break;
        case FORCE_POWER_BEAST_TRICK:
            nRelated1 = FORCE_POWER_BEAST_CONFUSION;
            break;
        case FORCE_POWER_DROID_TRICK:
            nRelated1 = FORCE_POWER_DROID_CONFUSION;
            break;
        case JD_BLIND:					      
            nRelated1 = JD_BLIND;		      
            break;
        case JD_BLIND_IMP:					
            nRelated1 = JD_BLIND;		      
            nRelated2 = JD_BLIND_IMP;		
            break;
        case JD_BLIND_MSTR:					
            nRelated1 = JD_BLIND;		      
            nRelated2 = JD_BLIND_IMP;		
            nRelated3 = JD_BLIND_MSTR;		
            break;
        case JD_DECEIVE:					
            nRelated1 = JD_DECEIVE;		
            break;
        case JD_DECEIVE_IMP:					
            nRelated1 = JD_DECEIVE;		
            nRelated2 = JD_DECEIVE_IMP;		
            break;
        case JD_DECEIVE_MSTR:					
            nRelated1 = JD_DECEIVE;		
            nRelated2 = JD_DECEIVE_IMP;		
            nRelated3 = JD_DECEIVE_MSTR;		
            break;
        case JD_LEECH:					      
            nRelated1 = JD_LEECH;		      
            break;
        case JD_LEECH_IMP:					
            nRelated1 = JD_LEECH;		      
            nRelated2 = JD_LEECH_IMP;		
            break;
        case JD_LEECH_MSTR:					
            nRelated1 = JD_LEECH;		      
            nRelated2 = JD_LEECH_IMP;		
            nRelated3 = JD_LEECH_MSTR;		
            break;
        case JD_ENERGY:					      
            nRelated1 = JD_ENERGY;		      
            break;
        case JD_ENERGY_IMP:					
            nRelated1 = JD_ENERGY;		      
            nRelated2 = JD_ENERGY_IMP;		
            break;
        case JD_ENERGY_MSTR:					
            nRelated1 = JD_ENERGY;		      
            nRelated2 = JD_ENERGY_IMP;		
            nRelated3 = JD_ENERGY_MSTR;		
            break;
        case JD_STATIC:					      
            nRelated1 = JD_STATIC;		      
            break;
        case JD_STATIC_IMP:					
            nRelated1 = JD_STATIC;		      
            nRelated2 = JD_STATIC_IMP;		
            break;
        case JD_STATIC_MSTR:					
            nRelated1 = JD_STATIC;		      
            nRelated2 = JD_STATIC_IMP;		
            nRelated3 = JD_STATIC_MSTR;		
            break;
        case JD_CONTAGION:					
            nRelated1 = JD_CONTAGION;		
            break;
        case JD_CONTAGION_IMP:				
            nRelated1 = JD_CONTAGION;		
            nRelated2 = JD_CONTAGION_IMP;	
            break;
        case JD_CONTAGION_MSTR:				
            nRelated1 = JD_CONTAGION;		
            nRelated2 = JD_CONTAGION_IMP;	
            nRelated3 = JD_CONTAGION_MSTR;	
            break;
        case JD_BOMBARD:					
            nRelated1 = JD_BOMBARD;		
            break;
        case JD_BOMBARD_IMP:					
            nRelated1 = JD_BOMBARD;		
            nRelated2 = JD_BOMBARD_IMP;		
            break;
        case JD_BOMBARD_MSTR:					
            nRelated1 = JD_BOMBARD;		
            nRelated2 = JD_BOMBARD_IMP;		
            nRelated3 = JD_BOMBARD_MSTR;		
            break;
        case JD_DESTRUCT:					
            nRelated1 = JD_DESTRUCT;		
            break;
        case JD_DESTRUCT_IMP:					
            nRelated1 = JD_DESTRUCT;		
            nRelated2 = JD_DESTRUCT_IMP;		
            break;
        case JD_DESTRUCT_MSTR:				
            nRelated1 = JD_DESTRUCT;		
            nRelated2 = JD_DESTRUCT_IMP;		
            nRelated3 = JD_DESTRUCT_MSTR;	
            break;
        case JD_INFERNO:					
            nRelated1 = JD_INFERNO;		
            break;
        case JD_INFERNO_IMP:					
            nRelated1 = JD_INFERNO;		
            nRelated2 = JD_INFERNO_IMP;		
            break;
        case JD_INFERNO_MSTR:					
            nRelated1 = JD_INFERNO;		
            nRelated2 = JD_INFERNO_IMP;		
            nRelated3 = JD_INFERNO_MSTR;		
            break;
        case JD_REGEN:					      
            nRelated1 = JD_REGEN;		      
            break;
        case JD_REGEN_IMP:					
            nRelated1 = JD_REGEN;		      
            nRelated2 = JD_REGEN_IMP;		
            break;
        case JD_REGEN_MSTR:					
            nRelated1 = JD_REGEN;		      
            nRelated2 = JD_REGEN_IMP;		
            nRelated3 = JD_REGEN_MSTR;		
            break;
        case JD_PROTECT:					
            nRelated1 = JD_PROTECT;		
            break;
        case JD_PROTECT_IMP:					
            nRelated1 = JD_PROTECT;		
            nRelated2 = JD_PROTECT_IMP;		
            break;
        case JD_PROTECT_MSTR:					
            nRelated1 = JD_PROTECT;		
            nRelated2 = JD_PROTECT_IMP;		
            nRelated3 = JD_PROTECT_MSTR;		
            break;
        case JD_GRIP:					      
            nRelated1 = JD_GRIP;		      
            break;
        case JD_GRIP_IMP:					
            nRelated1 = JD_GRIP;		      
            nRelated2 = JD_GRIP_IMP;		
            break;
        case JD_GRIP_MSTR:					
            nRelated1 = JD_GRIP;		      
            nRelated2 = JD_GRIP_IMP;		
            nRelated3 = JD_GRIP_MSTR;		
            break;
        case JD_OMNI:					      
            nRelated1 = JD_OMNI;		      
            break;
        case JD_OMNI_IMP:					
            nRelated1 = JD_OMNI;		      
            nRelated2 = JD_OMNI_IMP;		
            break;
        case JD_OMNI_MSTR:					
            nRelated1 = JD_OMNI;		      
            nRelated2 = JD_OMNI_IMP;		
            nRelated3 = JD_OMNI_MSTR;		
            break;
        case JD_FREEZE:					      
            nRelated1 = JD_FREEZE;		      
            break;
        case JD_FREEZE_IMP:					
            nRelated1 = JD_FREEZE;		      
            nRelated2 = JD_FREEZE_IMP;		
            break;
        case JD_FREEZE_MSTR:					
            nRelated1 = JD_FREEZE;		      
            nRelated2 = JD_FREEZE_IMP;		
            nRelated3 = JD_FREEZE_MSTR;		
            break;
        case JD_HOLD:					      
            nRelated1 = JD_HOLD;		      
            break;
        case JD_HOLD_IMP:					
            nRelated1 = JD_HOLD;		      
            nRelated2 = JD_HOLD_IMP;		
            break;
        case JD_HOLD_MSTR:					
            nRelated1 = JD_HOLD;		      
            nRelated2 = JD_HOLD_IMP;		
            nRelated3 = JD_HOLD_MSTR;		
            break;
        case JD_SAPWILL:					
            nRelated1 = JD_SAPWILL;		
            break;
        case JD_SAPWILL_IMP:					
            nRelated1 = JD_SAPWILL;		
            nRelated2 = JD_SAPWILL_IMP;		
            break;
        case JD_SAPWILL_MSTR:					
            nRelated1 = JD_SAPWILL;		
            nRelated2 = JD_SAPWILL_IMP;		
            nRelated3 = JD_SAPWILL_MSTR;		
            break;
        case JD_WEAKEN:					      
            nRelated1 = JD_WEAKEN;		      
            break;
        case JD_WEAKEN_IMP:					
            nRelated1 = JD_WEAKEN;		      
            nRelated2 = JD_WEAKEN_IMP;		
            break;
        case JD_WEAKEN_MSTR:					
            nRelated1 = JD_WEAKEN;		      
            nRelated2 = JD_WEAKEN_IMP;		
            nRelated3 = JD_WEAKEN_MSTR;		
            break;
        case JD_STRIKE:				
            nRelated1 = JD_STRIKE;		      
            break;
        case JD_STRIKE_IMP:					
            nRelated1 = JD_STRIKE;		      
            nRelated2 = JD_STRIKE_IMP;		
            break;
        case JD_STRIKE_MSTR:					
            nRelated1 = JD_STRIKE;		      
            nRelated2 = JD_STRIKE_IMP;		
            nRelated3 = JD_STRIKE_MSTR;		
            break;
        case JD_HURRICANE:					
            nRelated1 = JD_HURRICANE;		
            break;
        case JD_HURRICANE_IMP:				
            nRelated1 = JD_HURRICANE;		
            nRelated2 = JD_HURRICANE_IMP;	
            break;
        case JD_HURRICANE_MSTR:				
            nRelated1 = JD_HURRICANE;		
            nRelated2 = JD_HURRICANE_IMP;	
            nRelated3 = JD_HURRICANE_MSTR;	
            break;
        case JD_DEMO:					      
            nRelated1 = JD_DEMO;		      
            break;
        case JD_IMP_DEMO:					
            nRelated1 = JD_DEMO;		      
            nRelated2 = JD_IMP_DEMO;		
            break;
        case JD_MSTR_DEMO:					
            nRelated1 = JD_DEMO;		      
            nRelated2 = JD_IMP_DEMO;		
            nRelated3 = JD_MSTR_DEMO;		
            break;
        case JD_AWARE:					      
            nRelated1 = JD_AWARE;		      
            break;
        case JD_IMP_AWARE:					
            nRelated1 = JD_AWARE;		      
            nRelated2 = JD_IMP_AWARE;		
            break;
        case JD_MSTR_AWARE:					
            nRelated1 = JD_AWARE;		      
            nRelated2 = JD_IMP_AWARE;		
            nRelated3 = JD_MSTR_AWARE;		
            break;
        case JD_COMP:					      
            nRelated1 = JD_COMP;		      
            break;
        case JD_IMP_COMP:					
            nRelated1 = JD_COMP;		      
            nRelated2 = JD_IMP_COMP;		
            break;
        case JD_MSTR_COMP:					
            nRelated1 = JD_COMP;		      
            nRelated2 = JD_IMP_COMP;		
            nRelated3 = JD_MSTR_COMP;		
            break;
        case JD_PERS:					      
            nRelated1 = JD_PERS;		      
            break;	
        case JD_IMP_PERS:					
            nRelated1 = JD_PERS;		      
            nRelated2 = JD_IMP_PERS;		
            break;
        case JD_MSTR_PERS:					
            nRelated1 = JD_PERS;		      
            nRelated2 = JD_IMP_PERS;		
            nRelated3 = JD_MSTR_PERS;		
            break;
        case JD_REPAIR:					      
            nRelated1 = JD_REPAIR;		      
            break;
        case JD_IMP_REPAIR:					
            nRelated1 = JD_REPAIR;		      
            nRelated2 = JD_IMP_REPAIR;		
            break;
        case JD_MSTR_REPAIR:					
            nRelated1 = JD_REPAIR;		      
            nRelated2 = JD_IMP_REPAIR;		
            nRelated3 = JD_MSTR_REPAIR;		
            break;
        case JD_SECURITY:					
            nRelated1 = JD_SECURITY;		
            break;
        case JD_IMP_SECURITY:					
            nRelated1 = JD_SECURITY;		
            nRelated2 = JD_IMP_SECURITY;		
            break;
        case JD_MSTR_SECURITY:				
            nRelated1 = JD_SECURITY;		
            nRelated2 = JD_IMP_SECURITY;		
            nRelated3 = JD_MSTR_SECURITY;	
            break;
        case JD_STEALTH:					
            nRelated1 = JD_STEALTH;		
            break;
        case JD_IMP_STEALTH:					
            nRelated1 = JD_STEALTH;		
            nRelated2 = JD_IMP_STEALTH;		
            break;
        case JD_MSTR_STEALTH:					
            nRelated1 = JD_STEALTH;		
            nRelated2 = JD_IMP_STEALTH;		
            nRelated3 = JD_MSTR_STEALTH;		
            break;
        case JD_TREAT_INJURY:					
            nRelated1 = JD_TREAT_INJURY;		
            break;
        case JD_IMP_TREAT_INJURY:				
            nRelated1 = JD_TREAT_INJURY;		
            nRelated2 = JD_IMP_TREAT_INJURY;	
            break;
        case JD_MSTR_TREAT_INJURY:				
            nRelated1 = JD_TREAT_INJURY;		
            nRelated2 = JD_IMP_TREAT_INJURY;	
            nRelated3 = JD_MSTR_TREAT_INJURY;	
            break;
        case JD_RECK:					      
            nRelated1 = JD_RECK;		      
            break;
        case JD_RECK_IMP:					
            nRelated1 = JD_RECK;		      
            nRelated2 = JD_RECK_IMP;		
            break;
        case JD_RECK_MSTR:					
            nRelated1 = JD_RECK;		      
            nRelated2 = JD_RECK_IMP;		
            nRelated3 = JD_RECK_MSTR;		
            break;
        case JD_RAGE:					      
            nRelated1 = JD_RAGE;		      
            break;
        case JD_RAGE_IMP:					
            nRelated1 = JD_RAGE;		      
            nRelated2 = JD_RAGE_IMP;		
            break;
        case JD_RAGE_MSTR:					
            nRelated1 = JD_RAGE;		      
            nRelated2 = JD_RAGE_IMP;		
            nRelated3 = JD_RAGE_MSTR;		
            break;
        case JD_HEAL_FORCE_MINOR:				
            nRelated1 = JD_HEAL_FORCE_MINOR;	
            break;
        case JD_HEAL_FORCE_AVERAGE:				
            nRelated1 = JD_HEAL_FORCE_MINOR;	
            nRelated2 = JD_HEAL_FORCE_AVERAGE;	
            break;
        case JD_HEAL_FORCE_STRONG:				
            nRelated1 = JD_HEAL_FORCE_MINOR;	
            nRelated2 = JD_HEAL_FORCE_AVERAGE;	
            nRelated3 = JD_HEAL_FORCE_STRONG;	
        case JD_REZ_SUP_MSTR:					
            nRelated1 = JD_REZ_SUP_MSTR;		
            nRelated2 = JD_PREP;		      
            nRelated3 = JD_PREP_IMP;		
            nRelated4 = JD_PREP_MSTR;	      
            nRelated5 = JD_PREP_SUP;	      
            nRelated6 = JD_PREP_SUP_IMP;	      
            nRelated7 = JD_PREP_SUP_MSTR;	
            break;
        case JD_PREP:    					
            nRelated1 = JD_REZ_SUP_MSTR;		
            nRelated2 = JD_PREP;		      
            nRelated3 = JD_PREP_IMP;		
            nRelated4 = JD_PREP_MSTR;	      
            nRelated5 = JD_PREP_SUP;	      
            nRelated6 = JD_PREP_SUP_IMP;	      
            nRelated7 = JD_PREP_SUP_MSTR;	
            break;
        case JD_PREP_IMP:    					
            nRelated1 = JD_REZ_SUP_MSTR;		
            nRelated2 = JD_PREP;		      
            nRelated3 = JD_PREP_IMP;		
            nRelated4 = JD_PREP_MSTR;	      
            nRelated5 = JD_PREP_SUP;	      
            nRelated6 = JD_PREP_SUP_IMP;	      
            nRelated7 = JD_PREP_SUP_MSTR;	
            break;
        case JD_PREP_MSTR:    				
            nRelated1 = JD_REZ_SUP_MSTR;		
            nRelated2 = JD_PREP;		      
            nRelated3 = JD_PREP_IMP;		
            nRelated4 = JD_PREP_MSTR;	      
            nRelated5 = JD_PREP_SUP;	      
            nRelated6 = JD_PREP_SUP_IMP;	      
            nRelated7 = JD_PREP_SUP_MSTR;	
            break;
        case JD_PREP_SUP:    				      
            nRelated1 = JD_REZ_SUP_MSTR;		
            nRelated2 = JD_PREP;		      
            nRelated3 = JD_PREP_IMP;		
            nRelated4 = JD_PREP_MSTR;	      
            nRelated5 = JD_PREP_SUP;	      
            nRelated6 = JD_PREP_SUP_IMP;	      
            nRelated7 = JD_PREP_SUP_MSTR;	
            break;
        case JD_PREP_SUP_IMP:    				
            nRelated1 = JD_REZ_SUP_MSTR;		
            nRelated2 = JD_PREP;		      
            nRelated3 = JD_PREP_IMP;		
            nRelated4 = JD_PREP_MSTR;	      
            nRelated5 = JD_PREP_SUP;	      
            nRelated6 = JD_PREP_SUP_IMP;	      
            nRelated7 = JD_PREP_SUP_MSTR;	
            break;
        case JD_PREP_SUP_MSTR:    				
            nRelated1 = JD_REZ_SUP_MSTR;		
            nRelated2 = JD_PREP;		      
            nRelated3 = JD_PREP_IMP;		
            nRelated4 = JD_PREP_MSTR;	      
            nRelated5 = JD_PREP_SUP;	      
            nRelated6 = JD_PREP_SUP_IMP;	      
            nRelated7 = JD_PREP_SUP_MSTR;	
            break;
        default:
            return;
    }

    effect eRelatedEffect;
    if( GetHasSpellEffect(nRelated1, oTarget) ||
        GetHasSpellEffect(nRelated2, oTarget) ||
        GetHasSpellEffect(nRelated3, oTarget) ||
        GetHasSpellEffect(nRelated4, oTarget) ||
        GetHasSpellEffect(nRelated5, oTarget) ||
        GetHasSpellEffect(nRelated6, oTarget) ||
        GetHasSpellEffect(nRelated7, oTarget) )
    {
        eRelatedEffect = GetFirstEffect(oTarget);
        while (GetIsEffectValid(eRelatedEffect))
        {
            if( GetEffectSpellId(eRelatedEffect) == nRelated1 ||
                GetEffectSpellId(eRelatedEffect) == nRelated2 ||
                GetEffectSpellId(eRelatedEffect) == nRelated3 ||
                GetEffectSpellId(eRelatedEffect) == nRelated4 ||
                GetEffectSpellId(eRelatedEffect) == nRelated5 ||
                GetEffectSpellId(eRelatedEffect) == nRelated6 ||
                GetEffectSpellId(eRelatedEffect) == nRelated7 )
            {
                RemoveEffect(oTarget, eRelatedEffect);
            }
            eRelatedEffect = GetNextEffect(oTarget);
        }
    }
}

int JD_BetterRelatedPowerExists( object oTarget, int nPowerID )
{
    int bBetterExists = 0;

    int nRelated1 = -1;
    int nRelated2 = -1;
    int nRelated3 = -1;
    int nRelated4 = -1;
    int nRelated5 = -1;
    int nRelated6 = -1;

    switch ( nPowerID )
    {
        case FORCE_POWER_SLOW:
            nRelated1 = FORCE_POWER_AFFLICTION;
            nRelated2 = FORCE_POWER_PLAGUE;
            break;
        case FORCE_POWER_AFFLICTION:
            nRelated1 = FORCE_POWER_PLAGUE;
            break;
        case FORCE_POWER_FEAR:
        	nRelated1 = FORCE_POWER_HORROR;
        	nRelated2 = FORCE_POWER_INSANITY;
        	break;
        case FORCE_POWER_HORROR:
        	nRelated1 = FORCE_POWER_INSANITY;
        	break;
        case FORCE_POWER_FORCE_AURA:
            nRelated1 = FORCE_POWER_FORCE_SHIELD;
            nRelated2 = FORCE_POWER_FORCE_ARMOR;
            break;
        case FORCE_POWER_FORCE_SHIELD:
            nRelated1 = FORCE_POWER_FORCE_ARMOR;
            break;
        case FORCE_POWER_RESIST_FORCE:
            nRelated1 = FORCE_POWER_FORCE_IMMUNITY;
            break;
        case FORCE_POWER_FORCE_MIND:
            nRelated1 = FORCE_POWER_KNIGHT_MIND;
            nRelated2 = FORCE_POWER_MIND_MASTERY;
            break;
        case FORCE_POWER_KNIGHT_MIND:
            nRelated1 = FORCE_POWER_MIND_MASTERY;
            break;
        case FORCE_POWER_RESIST_POISON_DISEASE_SONIC:
            nRelated1 = FORCE_POWER_RESIST_COLD_HEAT_ENERGY;
            nRelated2 = FORCE_POWER_MASTER_ENERGY_RESISTANCE;
            break;
        case FORCE_POWER_RESIST_COLD_HEAT_ENERGY:
            nRelated1 = FORCE_POWER_MASTER_ENERGY_RESISTANCE;
            break;
        case FORCE_POWER_STUN:
            nRelated1 = FORCE_POWER_HOLD;
            nRelated2 = FORCE_POWER_SLEEP;
            break;
        case FORCE_POWER_HOLD:
            nRelated1 = FORCE_POWER_SLEEP;
            break;
        case FORCE_POWER_SPEED_BURST:
            nRelated1 = FORCE_POWER_KNIGHT_SPEED;
            nRelated2 = FORCE_POWER_SPEED_MASTERY;
            break;
        case FORCE_POWER_KNIGHT_SPEED:
            nRelated1 = FORCE_POWER_SPEED_MASTERY;
            break;
        case FORCE_POWER_FORCE_BARRIER:
            nRelated1 = FORCE_POWER_IMPROVED_FORCE_BARRIER;
            nRelated2 = FORCE_POWER_MASTER_FORCE_BARRIER;
            break;
        case FORCE_POWER_IMPROVED_FORCE_BARRIER:
            nRelated1 = FORCE_POWER_MASTER_FORCE_BARRIER;
            break;
        case FORCE_POWER_BATTLE_MEDITATION_PC:
            nRelated1 = FORCE_POWER_IMPROVED_BATTLE_MEDITATION_PC;
            nRelated2 = FORCE_POWER_MASTER_BATTLE_MEDITATION_PC;
            break;
        case FORCE_POWER_IMPROVED_BATTLE_MEDITATION_PC:
            nRelated1 = FORCE_POWER_MASTER_BATTLE_MEDITATION_PC;
            break;
        case FORCE_POWER_BAT_MED_ENEMY:
            nRelated1 = FORCE_POWER_IMP_BAT_MED_ENEMY;
            nRelated2 = FORCE_POWER_MAS_BAT_MED_ENEMY;
            break;
        case FORCE_POWER_IMP_BAT_MED_ENEMY:
            nRelated1 = FORCE_POWER_MAS_BAT_MED_ENEMY;
            break;
        case FORCE_POWER_CRUSH_OPPOSITION_I:
            nRelated1 = FORCE_POWER_CRUSH_OPPOSITION_II;
            nRelated2 = FORCE_POWER_CRUSH_OPPOSITION_III;
            nRelated3 = FORCE_POWER_CRUSH_OPPOSITION_IV;
            nRelated4 = FORCE_POWER_CRUSH_OPPOSITION_V;
            nRelated5 = FORCE_POWER_CRUSH_OPPOSITION_VI;
            break;
        case FORCE_POWER_CRUSH_OPPOSITION_II:
            nRelated1 = FORCE_POWER_CRUSH_OPPOSITION_III;
            nRelated2 = FORCE_POWER_CRUSH_OPPOSITION_IV;
            nRelated3 = FORCE_POWER_CRUSH_OPPOSITION_V;
            nRelated4 = FORCE_POWER_CRUSH_OPPOSITION_VI;
            break;
        case FORCE_POWER_CRUSH_OPPOSITION_III:
            nRelated1 = FORCE_POWER_CRUSH_OPPOSITION_IV;
            nRelated2 = FORCE_POWER_CRUSH_OPPOSITION_V;
            nRelated3 = FORCE_POWER_CRUSH_OPPOSITION_VI;
            break;
        case FORCE_POWER_CRUSH_OPPOSITION_IV:
            nRelated1 = FORCE_POWER_CRUSH_OPPOSITION_V;
            nRelated2 = FORCE_POWER_CRUSH_OPPOSITION_VI;
            break;
        case FORCE_POWER_CRUSH_OPPOSITION_V:
            nRelated1 = FORCE_POWER_CRUSH_OPPOSITION_VI;
            break;
        case FORCE_POWER_FORCE_BODY:
            nRelated1 = FORCE_POWER_IMPROVED_FORCE_BODY;
            nRelated2 = FORCE_POWER_MASTER_FORCE_BODY;
            break;
        case FORCE_POWER_IMPROVED_FORCE_BODY:
            nRelated1 = FORCE_POWER_MASTER_FORCE_BODY;
            break;
        case FORCE_POWER_FORCE_SCREAM:
            nRelated1 = FORCE_POWER_IMPROVED_FORCE_SCREAM;
            nRelated2 = FORCE_POWER_MASTER_FORCE_SCREAM;
            break;
        case FORCE_POWER_IMPROVED_FORCE_SCREAM:
            nRelated1 = FORCE_POWER_MASTER_FORCE_SCREAM;
            break;
        case FORCE_POWER_FURY:
            nRelated1 = FORCE_POWER_IMPROVED_FURY;
            nRelated2 = FORCE_POWER_MASTER_FURY;
            break;
        case FORCE_POWER_IMPROVED_FURY:
            nRelated1 = FORCE_POWER_MASTER_FURY;
            break;
        case FORCE_POWER_WOOKIEE_RAGE_I:
            nRelated1 = FORCE_POWER_WOOKIEE_RAGE_II;
            nRelated2 = FORCE_POWER_WOOKIEE_RAGE_III;
            break;
        case FORCE_POWER_WOOKIEE_RAGE_II:
            nRelated1 = FORCE_POWER_WOOKIEE_RAGE_III;
            break;
        case FORCE_POWER_INSPIRE_FOLLOWERS_I:
            nRelated1 = FORCE_POWER_INSPIRE_FOLLOWERS_II;
            nRelated2 = FORCE_POWER_INSPIRE_FOLLOWERS_III;
            nRelated3 = FORCE_POWER_INSPIRE_FOLLOWERS_IV;
            nRelated4 = FORCE_POWER_INSPIRE_FOLLOWERS_V;
            nRelated5 = FORCE_POWER_INSPIRE_FOLLOWERS_VI;
            break;
        case FORCE_POWER_INSPIRE_FOLLOWERS_II:
            nRelated1 = FORCE_POWER_INSPIRE_FOLLOWERS_III;
            nRelated2 = FORCE_POWER_INSPIRE_FOLLOWERS_IV;
            nRelated3 = FORCE_POWER_INSPIRE_FOLLOWERS_V;
            nRelated4 = FORCE_POWER_INSPIRE_FOLLOWERS_VI;
            break;
        case FORCE_POWER_INSPIRE_FOLLOWERS_III:
            nRelated1 = FORCE_POWER_INSPIRE_FOLLOWERS_IV;
            nRelated2 = FORCE_POWER_INSPIRE_FOLLOWERS_V;
            nRelated3 = FORCE_POWER_INSPIRE_FOLLOWERS_VI;
            break;
        case FORCE_POWER_INSPIRE_FOLLOWERS_IV:
            nRelated1 = FORCE_POWER_INSPIRE_FOLLOWERS_V;
            nRelated2 = FORCE_POWER_INSPIRE_FOLLOWERS_VI;
            break;
        case FORCE_POWER_INSPIRE_FOLLOWERS_V:
            nRelated1 = FORCE_POWER_INSPIRE_FOLLOWERS_VI;
            break;
        case FORCE_POWER_MIND_TRICK:
            nRelated1 = FORCE_POWER_CONFUSION;
            break;
        case FORCE_POWER_BEAST_TRICK:
            nRelated1 = FORCE_POWER_BEAST_CONFUSION;
            break;
        case FORCE_POWER_DROID_TRICK:
            nRelated1 = FORCE_POWER_DROID_CONFUSION;
            break;
        case JD_BLIND:					      
            nRelated2 = JD_BLIND_IMP;		
            nRelated3 = JD_BLIND_MSTR;		
            break;
        case JD_BLIND_IMP:					
            nRelated2 = JD_BLIND_MSTR;		
            break;
        case JD_DECEIVE:					
            nRelated2 = JD_DECEIVE_IMP;		
            nRelated3 = JD_DECEIVE_MSTR;		
            break;
        case JD_DECEIVE_IMP:					
            nRelated2 = JD_DECEIVE_MSTR;		
            break;
        case JD_LEECH:   					
            nRelated2 = JD_LEECH_IMP;		
            nRelated3 = JD_LEECH_MSTR;		
            break;
        case JD_LEECH_IMP:					
            nRelated3 = JD_LEECH_MSTR;		
            break;
        case JD_ENERGY: 					
            nRelated2 = JD_ENERGY_IMP;		
            nRelated3 = JD_ENERGY_MSTR;		
            break;
        case JD_ENERGY_IMP:					
            nRelated3 = JD_ENERGY_MSTR;		
            break;
        case JD_STATIC:  					
            nRelated2 = JD_STATIC_IMP;		
            nRelated3 = JD_STATIC_MSTR;		
            break;
        case JD_STATIC_IMP:					
            nRelated3 = JD_STATIC_MSTR;		
            break;
        case JD_CONTAGION:					
            nRelated2 = JD_CONTAGION_IMP;	
            nRelated3 =JD_CONTAGION_MSTR;	
            break;
        case JD_CONTAGION_IMP:				
            nRelated3 = JD_CONTAGION_MSTR;	
            break;
        case JD_BOMBARD:					
            nRelated2 = JD_BOMBARD_IMP;		
            nRelated3 = JD_BOMBARD_MSTR;		
            break;
        case JD_BOMBARD_IMP:					
            nRelated3 = JD_BOMBARD_MSTR;		
            break;
        case JD_DESTRUCT:					
            nRelated2 = JD_DESTRUCT_IMP;		
            nRelated3 = JD_DESTRUCT_MSTR;	
            break;
        case JD_DESTRUCT_IMP:					
            nRelated3 = JD_DESTRUCT_MSTR;	
            break;
        case JD_INFERNO:					
            nRelated2 = JD_INFERNO_IMP;		
            nRelated3 = JD_INFERNO_MSTR;		
            break;
        case JD_INFERNO_IMP:					
            nRelated3 = JD_INFERNO_MSTR;		
            break;
        case JD_REGEN:  					
            nRelated2 = JD_REGEN_IMP;		
            nRelated3 = JD_REGEN_MSTR;		
            break;
        case JD_REGEN_IMP:					
            nRelated3 = JD_REGEN_MSTR;		
            break;
        case JD_PROTECT:					
            nRelated2 = JD_PROTECT_IMP;		
            nRelated3 = JD_PROTECT_MSTR;		
            break;
        case JD_PROTECT_IMP:					
            nRelated3 = JD_PROTECT_MSTR;		
            break;
        case JD_GRIP:	       				
            nRelated2 = JD_GRIP_IMP;		
            nRelated3 = JD_GRIP_MSTR;		
            break;
        case JD_GRIP_IMP:					
            nRelated3 = JD_GRIP_MSTR;		
            break;
        case JD_OMNI:	      				
            nRelated2 = JD_OMNI_IMP;		
            nRelated3 = JD_OMNI_MSTR;		
            break;
        case JD_OMNI_IMP:					
            nRelated3 = JD_OMNI_MSTR;		
            break;
        case JD_FREEZE:  					
            nRelated2 = JD_FREEZE_IMP;		
            nRelated3 = JD_FREEZE_MSTR;		
            break;
        case JD_FREEZE_IMP:					
            nRelated3 = JD_FREEZE_MSTR;		
            break;
        case JD_HOLD:    					
            nRelated2 = JD_HOLD_IMP;		
            nRelated3 = JD_HOLD_MSTR;		
            break;
        case JD_HOLD_IMP:					
            nRelated3 = JD_HOLD_MSTR;		
            break;
        case JD_SAPWILL:					
            nRelated2 = JD_SAPWILL_IMP;		
            nRelated3 = JD_SAPWILL_MSTR;		
            break;
        case JD_SAPWILL_IMP:					
            nRelated3 = JD_SAPWILL_MSTR;		
            break;
        case JD_WEAKEN:	      				
            nRelated2 = JD_WEAKEN_IMP;		
            nRelated3 = JD_WEAKEN_MSTR;		
            break;
        case JD_WEAKEN_IMP:					
            nRelated3 = JD_WEAKEN_MSTR;		
            break;
        case JD_STRIKE:		      			
            nRelated2 = JD_STRIKE_IMP;		
            nRelated3 = JD_STRIKE_MSTR;		
            break;
        case JD_STRIKE_IMP:					
            nRelated3 = JD_STRIKE_MSTR;		
            break;
        case JD_HURRICANE:					
            nRelated2 = JD_HURRICANE_IMP;	
            nRelated3 = JD_HURRICANE_MSTR;	
            break;
        case JD_HURRICANE_IMP:				
            nRelated3 = JD_HURRICANE_MSTR;	
            break;
        case JD_DEMO:   					
            nRelated2 = JD_IMP_DEMO;		
            nRelated3 = JD_MSTR_DEMO;		
            break;
        case JD_IMP_DEMO:					
            nRelated3 = JD_MSTR_DEMO;		
            break;
        case JD_AWARE:	       				
            nRelated2 = JD_IMP_AWARE;		
            nRelated3 = JD_MSTR_AWARE;		
            break;
        case JD_IMP_AWARE:					
            nRelated3 = JD_MSTR_AWARE;		
            break;
        case JD_COMP:	       				
            nRelated2 = JD_IMP_COMP;		
            nRelated3 = JD_MSTR_COMP;		
            break;
        case JD_IMP_COMP:					
            nRelated3 = JD_MSTR_COMP;		
            break;
        case JD_PERS:    					
            nRelated2 = JD_IMP_PERS;		
            nRelated3 = JD_MSTR_PERS;		
            break;	
        case JD_IMP_PERS:					
            nRelated3 = JD_MSTR_PERS;		
            break;
        case JD_REPAIR:	      				
            nRelated2 = JD_IMP_REPAIR;		
            nRelated3 = JD_MSTR_REPAIR;		
            break;
        case JD_IMP_REPAIR:					
            nRelated3 = JD_MSTR_REPAIR;		
            break;
        case JD_SECURITY:					
            nRelated2 = JD_IMP_SECURITY;		
            nRelated3 = JD_MSTR_SECURITY;	
            break;
        case JD_IMP_SECURITY:					
            nRelated3 = JD_MSTR_SECURITY;	
            break;
        case JD_STEALTH:					
            nRelated2 = JD_IMP_STEALTH;		
            nRelated3 = JD_MSTR_STEALTH;		
            break;
        case JD_IMP_STEALTH:					
            nRelated3 = JD_MSTR_STEALTH;		
            break;
        case JD_TREAT_INJURY:					
            nRelated2 = JD_IMP_TREAT_INJURY;	
            nRelated3 = JD_MSTR_TREAT_INJURY;	
            break;
        case JD_IMP_TREAT_INJURY:				
            nRelated3 = JD_MSTR_TREAT_INJURY;  
            break;
        case JD_RECK:    					
            nRelated2 = JD_RECK_IMP;		
            nRelated3 = JD_RECK_MSTR;		
            break;
        case JD_RECK_IMP:					
            nRelated3 = JD_RECK_MSTR;		
            break;
        case JD_RAGE:	       				
            nRelated2 = JD_RAGE_IMP;		
            nRelated3 = JD_RAGE_MSTR;		
            break;
        case JD_RAGE_IMP:					
            nRelated3 = JD_RAGE_MSTR;		
            break;
        case JD_HEAL_FORCE_MINOR:	       		
            nRelated2 = JD_HEAL_FORCE_AVERAGE;	
            nRelated3 = JD_HEAL_FORCE_STRONG;	
            break;
        case JD_HEAL_FORCE_AVERAGE:				
            nRelated3 = JD_HEAL_FORCE_STRONG;	
            break;
        default:
            return 0;
        break;
    }

    effect eRelatedEffect;
    if( GetHasSpellEffect(nRelated1, oTarget) ||
        GetHasSpellEffect(nRelated2, oTarget) ||
        GetHasSpellEffect(nRelated3, oTarget) ||
        GetHasSpellEffect(nRelated4, oTarget) ||
        GetHasSpellEffect(nRelated5, oTarget) ||
        GetHasSpellEffect(nRelated6, oTarget) )
    {
        bBetterExists = 1;
    }

    return bBetterExists;
}

// -------------------------------------------------------------
// Debug function - print string to the Feedback screen in-game.
// -------------------------------------------------------------
void DebugMessage(string sText, int bTimestamp=FALSE) {
	string sTimestamp = "";
	
	if (bTimestamp) {
		int nHour = GetTimeHour();
		int nMin  = GetTimeMinute(); // ST: Ingame-time! There are 2 min/hour.
		int nSec  = GetTimeSecond();
		int nMSec = GetTimeMillisecond();
		
		sTimestamp = (nHour < 10 ? "0" : "") + IntToString(nHour)
			 + ":" + (nMin  < 10 ? "0" : "") + IntToString(nMin)
			 + ":" + (nSec  < 10 ? "0" : "") + IntToString(nSec)
			 + ":" + GetSubString((nMSec  < 10 ? "0" : "") + IntToString(nMSec), 0, 2);	
			 
		sTimestamp += " - ";	
	}
	
	SendMessageToPC(GetPartyLeader(), sTimestamp + "DEBUG[" + GetName(OBJECT_SELF) + "] " + sText);
}

// -------------------------------------------------------------
// Surrender/death safe apply wrapper for use with delayed
// application of effects. Remember that this should be used
// against hostile targets ONLY, since it does hostility checks.
// -------------------------------------------------------------
void ST_ApplyEffectToObject(int nDurationType, effect eEffect, object oTarget, float fDuration=0.0) {
    if(GetIsObjectValid(oTarget) && !GetIsDead(oTarget) && GetIsEnemy(oTarget))
        ApplyEffectToObject(nDurationType, eEffect, oTarget, fDuration);
}


// -------------------------------------------------------------
// Returns the party member in the specified active party slot
// if this party member has the Force Chain feat.
// -------------------------------------------------------------
object ST_GetForceChainPartner(int nIdx) {
	object oParty = GetPartyMemberByIndex(nIdx);	
	if (GetIsObjectValid(oParty) 
		&& (oParty != OBJECT_SELF) 
		&& !GetIsDead(oParty)
		&& (GetCurrentHitPoints(oParty) > 0)
		&& GetHasFeat(FEAT_FORCE_CHAIN, OBJECT_SELF)
		&& GetHasFeat(FEAT_FORCE_CHAIN, oParty))
	{
		return oParty;	
	}
	return OBJECT_INVALID;
}


// ----------------------------------------------------------------------
// Returns the SpellId for the next Shield in sequence from the
// number specified as a parameter.
// ----------------------------------------------------------------------
int ST_GetNextShieldId(int nId) {
	if (nId < 99)
		nId = 99;
	else if ((nId >= 99) && (nId < 107))
		nId++;
	else if (nId == 107)
		nId = 110;
	else if ((nId >= 110) && (nId < 115))
		nId++;
	else if (nId == 115)
		nId = 132;
	else if (nId == 132)
		nId = 257;
	else if (nId == 257)
		nId = 999;	
	return nId;
}


// ----------------------------------------------------------------------
// Returns TRUE if the specified target is protected by an energy
// shield of some kind.
// ----------------------------------------------------------------------
int ST_GetIsShielded(object oTarget=OBJECT_SELF) {
	int nId;	
	for (nId = 99; nId != 999; nId = ST_GetNextShieldId(nId)) {
		if (GetHasSpellEffect(nId, oTarget))
			return TRUE;		
	} 	
	return FALSE;
}


// -------------------------------------------------------------
// UTILITY: Returns the highest value of the two float values.
//          Use for bounds trimming where a value may not be
//          lower than the set nLimit value.
// -------------------------------------------------------------
float FMax(float fValue, float fLimit) {
	return (fValue < fLimit ? fLimit : fValue);	
}


// -------------------------------------------------------------
// UTILITY: Returns the lowest value of the two float values.
//          Use for bounds trimming where a value may not be 
//          higher than the set nLimit value.
// -------------------------------------------------------------
float FMin(float fValue, float fLimit) {
	return (fValue > fLimit ? fLimit : fValue);	
}

// -------------------------------------------------------------
// UTILITY: Returns the highest value of the two integer values.
//          Use for bounds trimming where a value may not be
//          lower than the set nLimit value.
// -------------------------------------------------------------
int IMax(int nValue, int nLimit) {
	return (nValue < nLimit ? nLimit : nValue);	
}


// -------------------------------------------------------------
// UTILITY: Returns the lowest value of the two integer values.
//          Use for bounds trimming where a value may not be 
//          higher than the set nLimit value.
// -------------------------------------------------------------
int IMin(int nValue, int nLimit) {
	return (nValue > nLimit ? nLimit : nValue);	
}
// -------------------------------------------------------------
// Do a force resistance check. If successful, display the
// "Resisted" UI message and play a visual.
// -------------------------------------------------------------
int ST_ResistForce(object oTarget) {
    if(ResistForce(OBJECT_SELF, oTarget)) {
        DisplayFeedBackText(oTarget, 0);
        ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectForceResisted(OBJECT_SELF), oTarget);
        return TRUE;
    }
    return FALSE;
}

// -------------------------------------------------------------
// Substitute knockdown effect with a stun effect if the target
// is a droid or beast, since most of those lack an "dead on
// their back" animation which knockdown + kill often gives.
// -------------------------------------------------------------
effect ST_SubKnockDown(object oTarget, effect eKnockdown) {
	int nAppear = GetAppearanceType(oTarget);
	if ((GetRacialType(oTarget) == RACIAL_TYPE_DROID) 
		&& (nAppear != 3)
		&& (nAppear != 538)
		&& (nAppear != 539))
	{
		return EffectDroidStun();	
	}
	
	if (GetSubRace(oTarget) == 2)
		return EffectCutSceneStunned();
	
	return eKnockdown;
}

void BombardBlast(object oTarget, int nSpellId, float fDur, int nDice) {
	// Don't continue if the duration has expired or the target is no longer valid.
	if ((fDur <= 0.0) 
		|| !GetIsObjectValid(oTarget) 
		|| GetIsDead(oTarget) 
		|| !GetIsEnemy(oTarget))
	{
		SetLocalBoolean(OBJECT_SELF, 62, FALSE);
		return;
	}
	
	location lTarget = GetLocation(oTarget);
	int nBaseDamage = GetHitDice(OBJECT_SELF);
	object oCreature = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_MEDIUM, lTarget);
	
	effect eDamage;
	effect eBoom = EffectVisualEffect(ST_VFX_FNF_FORCE_BOMBARD); // ST: Set by installer to new line with sound!!
	ApplyEffectToObject(DURATION_TYPE_INSTANT, eBoom, oTarget);
	
	// Do energy damage to all nearby enemies with slight delay to allow the blast to land.
	while (GetIsObjectValid(oCreature)) {
		if (GetIsEnemy(oCreature) && !GetIsDead(oCreature)) {
			float fDist = 0.3 + GetDistanceBetweenLocations2D(lTarget, GetLocation(oCreature)) / 20.0;
                  int nDamage = JD_CalcDamage( OBJECT_SELF, nBaseDamage, nDice, nBaseDamage );
			nDamage = FloatToInt((1.0 - fDist) * IntToFloat(nDamage));
						
			SignalEvent(oCreature, EventSpellCastAt(OBJECT_SELF, nSpellId, GetIsEnemy(oCreature)));
                  int nDcMod          = 0;
                  int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
                  int nSaves          = ReflexSave(oCreature, nDifficulty);			
			if (nSaves = 0){
				eDamage	= EffectDamage(nDamage, DAMAGE_TYPE_BLASTER);
                  }
			else {
				eDamage	= EffectDamage(nDamage / 2, DAMAGE_TYPE_BLASTER);
                  }				
			DelayCommand(fDist, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oCreature));
		}
		
		oCreature = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_MEDIUM, lTarget);
	}
	
	
	// Don't continue if the target has been killed or has surendered.
	if (!GetIsObjectValid(oTarget) || GetIsDead(oTarget) || !GetIsEnemy(oTarget)) {
		SetLocalBoolean(OBJECT_SELF, 62, FALSE);
		return;
	}
		
	DelayCommand(2.0, BombardBlast(oTarget, nSpellId, fDur - 2.0, nDice));
}

void ST_DestructionDamage(object oTarget, int nBaseDamage, int nSpellId, int nDice) {
	location lTarget = GetLocation(oTarget);
	int nType = DAMAGE_TYPE_LIGHT_SIDE;
	
	effect eDown	= EffectKnockdown();
	effect ePush	= EffectForcePushTargeted(lTarget);	
	effect eVisual  = EffectVisualEffect(VFX_PRO_LIGHTNING_JEDI);
	effect eDamage;
	
	object oCreature = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_LARGE, lTarget);
	while (GetIsObjectValid(oCreature)) {
		// The Force power target is hit for full damage and is knocked down.
		if ((oCreature == oTarget) && !GetIsDead(oCreature) && GetIsEnemy(oCreature)) {
			SignalEvent(oCreature, EventSpellCastAt(OBJECT_SELF, nSpellId, TRUE));
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eVisual, oCreature);
                  int nDcMod          = 0;
                  int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
                  int nSaves          = ReflexSave(oCreature, nDifficulty);
			if (nSaves = 0) {
				int nDamage = (JD_CalcDamage( OBJECT_SELF, GetHitDice(OBJECT_SELF), nDice, nBaseDamage ) + nBaseDamage);
				eDamage	= EffectDamage(nDamage, nType);
				ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oCreature);
				ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ST_SubKnockDown(oCreature, eDown), oCreature, 2.5);
			}
			else {
				int nDamage = ((JD_CalcDamage( OBJECT_SELF, GetHitDice(OBJECT_SELF), nDice, nBaseDamage ) + nBaseDamage) / 2);
				eDamage	= EffectDamage(nDamage, nType);
				ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oCreature);
			}
		}
		// Nearby creatures are hit by dissipating splash damage and are knocked back.
		else if (!GetIsNeutral(oCreature) && !GetIsDead(oCreature)) {
			float fDist = GetDistanceBetweenLocations2D(lTarget, GetLocation(oCreature)) / 20.0;
			int nDamage = (JD_CalcDamage( OBJECT_SELF, GetHitDice(OBJECT_SELF), nDice, nBaseDamage ) + nBaseDamage);
			nDamage = FloatToInt((1.0 - fDist) * IntToFloat(nDamage));
			
			SignalEvent(oCreature, EventSpellCastAt(OBJECT_SELF, nSpellId, GetIsEnemy(oCreature)));
			DelayCommand(fDist, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eVisual, oCreature));
                  int nDcMod          = 0;
                  int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
                  int nSaves          = ReflexSave(oCreature, nDifficulty);			
			if (nSaves = 0) {
				eDamage	= EffectDamage(nDamage, nType);
				DelayCommand(fDist, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oCreature));
				DelayCommand(fDist, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ePush, oCreature, 0.1));
			}
			else {
				eDamage	= EffectDamage(nDamage / 2, nType);				
				DelayCommand(fDist, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oCreature));				
			}
		}
		
		oCreature = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_LARGE, lTarget);
	}
}


////////////////////////////////////////////////////////////////////////////////
// Apply splash damage to a target. If the target makes a reflex save, 
// only half damage is dealt.
////////////////////////////////////////////////////////////////////////////////
void ApplyDamage(int nDmg, object oTarget, int nDC) {
    int nDcMod          = 0;
    int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
    int nSaves          = FortitudeSave(oTarget, nDifficulty, SAVING_THROW_TYPE_ALL);
    if (nSaves  > 0) {
        nDmg /= 2;
    }
    effect eDmg = EffectDamage(nDmg, DAMAGE_TYPE_COLD);

    ApplyEffectToObject(DURATION_TYPE_INSTANT, eDmg, oTarget);
}


////////////////////////////////////////////////////////////////////////////////
// The real action....
////////////////////////////////////////////////////////////////////////////////
void ColdBlast(object oTarget, int nNum, int nDC, location lBup, int nDiceSize,int nBonusValue, float fDuration, int nSpellid) {
    float BLAST_RADIUS = 5.0;

    if (nNum > 0) {
        // Base damage
        int nEffectid;
        int nDmg = JD_CalcDamage( OBJECT_SELF, GetHitDice(OBJECT_SELF) / 2, nDiceSize, 0 );
        if(nSpellid == JD_FREEZE) {
           nEffectid = JD_FREEZE_EFFECT;
        }
        else if (nSpellid == JD_FREEZE_IMP) {
           nEffectid = JD_FREEZE_IMP_EFFECT;
        }
        else if (nSpellid == JD_FREEZE_MSTR) {  
           nEffectid = JD_FREEZE_MSTR_EFFECT;
        }                        
        // Delay between hops
        float fDelay = 0.6f;

		// Full penalties, used if the saving throw is failed.
    	effect eChillF = EffectACDecrease(nBonusValue);
    	       eChillF = EffectLinkEffects(eChillF, EffectBlasterDeflectionDecrease(nBonusValue));
    	       eChillF = EffectLinkEffects(eChillF, EffectAttackDecrease(nBonusValue));
    	       eChillF = EffectLinkEffects(eChillF, EffectACDecrease(nBonusValue));
    	       eChillF = EffectLinkEffects(eChillF, EffectSavingThrowDecrease(SAVING_THROW_ALL, nBonusValue));
    	       eChillF = EffectLinkEffects(eChillF, EffectMovementSpeedDecrease(50));
    	       eChillF = SetEffectIcon(eChillF, nEffectid);  // ST: Update with correct row in effecticon.2da.
    	 
    	// Half penalties, used if the target makes their save.   
    	effect eChillH = EffectACDecrease(nBonusValue/2);
    	       eChillH = EffectLinkEffects(eChillH, EffectBlasterDeflectionDecrease(nBonusValue/2));
    	       eChillH = EffectLinkEffects(eChillH, EffectAttackDecrease(nBonusValue/2));
    	       eChillH = EffectLinkEffects(eChillH, EffectACDecrease(nBonusValue/2));
    	       eChillH = EffectLinkEffects(eChillH, EffectSavingThrowDecrease(SAVING_THROW_ALL, nBonusValue/2));
    	       eChillH = EffectLinkEffects(eChillH, EffectMovementSpeedDecrease(50));
    	       eChillH = SetEffectIcon(eChillH, nEffectid);  // ST: Update with correct row in effecticon.2da.

		effect eDmgF    = EffectDamage(nDmg, DAMAGE_TYPE_COLD);
		effect eDmgH    = EffectDamage(nDmg/2, DAMAGE_TYPE_COLD);
		effect eFreeze	= EffectCutSceneParalyze();
		
        effect eVis     = EffectVisualEffect(2055);
        effect eVis2    = EffectVisualEffect(2054); 
		effect eBlast   = EffectVisualEffect(3008); 
 
        // Center of explosion
        location lLoc;
        if (GetIsObjectValid(oTarget) && !GetIsDead(oTarget) && GetIsEnemy(oTarget)) {
            lLoc = GetLocation(oTarget);
        }
        else {
            // Target gone: Pick a new target in range if there is one.
            object oTmp = GetFirstObjectInShape(SHAPE_SPHERE, BLAST_RADIUS, lBup, FALSE, OBJECT_TYPE_CREATURE);
            while (GetIsObjectValid(oTmp)) {
                if ((oTmp != oTarget)
                    && GetIsEnemy(oTmp)
                    && !GetIsDead(oTmp)
                    && (GetLocalNumber(oTmp, 1) != 1))
                {
                    oTarget = oTmp;
                    lLoc = GetLocation(oTarget);
                    break;
                }
                oTmp = GetNextObjectInShape(SHAPE_SPHERE, BLAST_RADIUS, lBup, FALSE, OBJECT_TYPE_CREATURE);
            }
        }

        if (GetIsObjectValid(oTarget) && !GetIsDead(oTarget) && GetIsEnemy(oTarget)) {
            // Make sure the blast doesn't jump back to this creature again.
            SetLocalNumber(oTarget, 1, 1);
            DelayCommand(nNum * fDelay, SetLocalNumber(oTarget, 1, 0));

			JD_RemoveRelatedPowers(oTarget, GetSpellId());
			
			// Smack the target the explosion is centered on for full dmg.
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
            int nSaves          = FortitudeSave(oTarget, nDC, SAVING_THROW_TYPE_NONE);
    		if (nSaves > 0) {
				ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDmgH, oTarget);
				ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eChillH, oTarget, FREEZE_DURATION + (fDuration/2));
    		}
    		else {
				ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDmgF, oTarget);
				ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eChillF, oTarget, FREEZE_DURATION + fDuration);
    		}

            ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, oTarget, FREEZE_DURATION);
            ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, oTarget, FREEZE_DURATION);   
            ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eFreeze, oTarget, FREEZE_DURATION); 
        }
        else {
            return;
        }

        // Explosion impact VFX
        ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eBlast, lLoc);

        // Comparison vars used to find the nearest living creature to target.
        float fCmpDist = 999.0;
        object oCmpNear = OBJECT_INVALID;

        // Find nearby creatures within the blast radius of the explosion.
        object oNear = GetFirstObjectInShape(SHAPE_SPHERE, BLAST_RADIUS, lLoc, FALSE, OBJECT_TYPE_CREATURE);
        while (GetIsObjectValid(oNear)) {
            // Don't hit the blast target again and don't hit friendlies.
            if ((oNear != oTarget) && GetIsEnemy(oNear) && !GetIsDead(oNear)) {
                // Deal splash damage from the blast to nearby targets.
                float fDist = GetDistanceBetweenLocations(lLoc, GetLocation(oNear));
                float fD = fDist / 15;

                // Damage drops off the farther from the center of the blast the creature is.
                int myDmg = nDmg - FloatToInt((nDmg * fDist) / (BLAST_RADIUS * 2));

                // Apply the splash damage to this creature.
                DelayCommand(fD, SignalEvent(oNear, EventSpellCastAt(OBJECT_SELF, GetSpellId())));
                DelayCommand(fD, ApplyDamage(myDmg, oNear, nDC));

                // Find the nearest new target for the blast to jump to.
                if (GetIsObjectValid(oNear)
                    && !GetIsDead(oNear)
                    && (GetLocalNumber(oTarget, 1) != 1)
                    && (fDist < fCmpDist))
                {
                    oCmpNear = oNear;
                    fCmpDist = fDist;
                }
            }
            oNear = GetNextObjectInShape(SHAPE_SPHERE, BLAST_RADIUS, lLoc, FALSE, OBJECT_TYPE_CREATURE);
        }

        // Make the blast hop to the next nearest enemy.
        DelayCommand(fDelay, ColdBlast(oCmpNear, --nNum, nDC, lLoc, nDiceSize, nBonusValue, fDuration, nSpellid));
    }
}

location GetSideLocation(object oTarget)
{
    float fDir           = GetFacing(oTarget);
    float fDistance      = 0.5;
    float fAngleOpposite = fDir + 90.0;
    vector vOriginal     = GetPosition(oTarget);
    vector vChanged;

    while (fAngleOpposite >= 360.0) {
        fAngleOpposite -= 360.0;
    }

    vChanged.z = vOriginal.z;
    vChanged.x = vOriginal.x + (fDistance * cos(fAngleOpposite));
    vChanged.y = vOriginal.y + (fDistance * sin(fAngleOpposite));

    if (vChanged.x < 0.0)
        vChanged.x = - vChanged.x;

    if (vChanged.y < 0.0)
        vChanged.y = - vChanged.y;

    return Location(vChanged, fDir);
}

void MaintainForceGrip(object oTarget, int nDamage, int nSpellid) {
    // Release the grip if the target is dead.
    if (GetIsDead(oTarget))
        return;

    // ...or if the force user has died... (in case it doesn't already terminate
    //    script execution by that object)
    if (GetIsDead(OBJECT_SELF))
        return;

    // Release the grip if target is no longer an enemy (surrendered etc)
    if (!GetIsEnemy(oTarget))
        return;

    // If target makes succesful fort save, release the grip with a backlash,
    // smacking them away and causing falling damage.
    int nDcMod          = 0;
    int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
    int nSaves          = FortitudeSave(oTarget, nDifficulty);
    if (nSaves > 0)
    {
        effect eSmack  = EffectForcePushTargeted(GetLocation(oTarget));
        effect eImpact = EffectDamage(nDamage, DAMAGE_TYPE_BLUDGEONING);
        ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eSmack, oTarget, 0.2);
        ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eImpact, oTarget);
        return;
    }
    int nEffectid;
    if(nSpellid == JD_GRIP) {
       nEffectid = JD_GRIP_EFFECT;
    }
    else if (nSpellid == JD_GRIP_IMP) {
       nEffectid = JD_GRIP_IMP_EFFECT;
    }
    else if (nSpellid == JD_GRIP_MSTR) {  
       nEffectid = JD_GRIP_MSTR_EFFECT;
    } 
    effect eVFX = EffectVisualEffect(VFX_IMP_CHOKE);
    effect eDamage = EffectDamage(nDamage, DAMAGE_TYPE_ACID);
    effect eChoke = EffectChoke();
    eChoke = SetEffectIcon(eChoke, nEffectid); // ST: Update to use proper effecticon.2da line

    ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eVFX, oTarget);
    ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eChoke, oTarget, 3.0);
    ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);

    // Continue gripping and damaging target again in 3 seconds.
    DelayCommand(3.0, MaintainForceGrip(oTarget, nDamage, nSpellid));
}

void SpawnGasCloud(object oTarget, float fDur) {
	if (GetIsObjectValid(oTarget) && !GetIsDead(oTarget) && GetIsEnemy(oTarget)) {
		location lLoc = GetLocation(oTarget);
    	object oVfx = CreateObject(OBJECT_TYPE_PLACEABLE, "plc_sithritual", lLoc);
    	SetLocalBoolean(oVfx, 1, TRUE);
    	AssignCommand(oVfx, DestroyObject(oVfx, fDur, TRUE));	
	}
}

void RemoveBeamsPoller(object oTarget, int nId, float fDuration) {
	if (!GetIsObjectValid(oTarget) || GetIsDead(oTarget)) {
		int iIdx = 0;
		object oInv = GetObjectByTag("Invisible", iIdx);
		while (GetIsObjectValid(oInv)) {
			if ((GetObjectType(oInv) == OBJECT_TYPE_PLACEABLE) 
				&& (GetLocalNumber(oInv, 1) == nId) 
				&& (GetDistanceBetween(oInv, oTarget) < 12.0)) 
			{
				DestroyObject(oInv, 0.0, TRUE);
			}
			oInv = GetObjectByTag("Invisible", ++iIdx);
		}	
	}	
	else if (fDuration > 0.0) {
		DelayCommand(0.4, RemoveBeamsPoller(oTarget, nId, fDuration - 0.4));	
	}
}

void DelayedApplyEffectsSap(object oTarget, int nSpellId, effect eStop, effect eFlat, float fDuration) {
    JD_RemoveRelatedPowers( oTarget, nSpellId );
	SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, nSpellId, TRUE));
	
    int nDcMod          = 0;
    int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
    int nSaves          = WillSave(oTarget, nDifficulty);	
    if (nSaves > 0) {
    	ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStop, oTarget, JD_CalcDuration( OBJECT_SELF, fDuration/2 ) );        	
    	ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eFlat, oTarget, JD_CalcDuration( OBJECT_SELF, fDuration/2 ) );
    } 
	else {
    	ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStop, oTarget, JD_CalcDuration( OBJECT_SELF, fDuration ) );        	
    	ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eFlat, oTarget, JD_CalcDuration( OBJECT_SELF, fDuration ) );           	
	}		
}

void DelayedApplyEffects(object oTarget, int nSpellId, effect eBlind, effect eHit, float fDuration) {
    JD_RemoveRelatedPowers( oTarget, nSpellId );
	SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, nSpellId, TRUE));
	
        int nDcMod          = 0;
        int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
        int nSaves          = WillSave(oTarget, nDifficulty);	
        if (nSaves > 0)
    	ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBlind, oTarget, JD_CalcDuration( OBJECT_SELF, fDuration/2 ) );        	
	else
    	ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBlind, oTarget, JD_CalcDuration( OBJECT_SELF, fDuration ) );        	         	
	
	ApplyEffectToObject(DURATION_TYPE_INSTANT, eHit, oTarget);	
}

float FREEZE_DURATION = 9.0;

void GetTagAndDistance(string sThing, object oThing) {
  object oPC=GetFirstPC();
  string sTag=GetTag(oThing);
  float  fDistance=GetDistanceBetween(oThing, oPC);
  string sDistance=FloatToString(fDistance,6,3);
  sDistance=GetStringLeft(sDistance,GetStringLength(sDistance)-1);  //trim the newline character
  string sMsg="Nearest "+ sThing + ":  Tag: " + sTag + "  Distance: "+ sDistance + "m";
  SendMessageToPC(oPC, sMsg);
}