{
    JD_ForcePowerCost( OBJECT_SELF, GetSpellId(), FALSE);
	object oTarget 	= GetSpellTargetObject();
	location lLoc 	= GetLocation(oTarget);
    int nDice 		= GetHitDice(OBJECT_SELF);
    int nValue		= JD_CalcBuffBonus( OBJECT_SELF, 6  );
    float fDur 		= JD_CalcDuration( OBJECT_SELF, 14.0 );
    
    
    if (ST_ResistForce(oTarget)) {
        ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectForceFizzle(), OBJECT_SELF);	
    }
    else {
    	effect eGlue = EffectEntangle();	   // Don't move...
    	effect eFall = EffectKnockdown();      // Fall over every now and then...
    	effect eHeld = EffectACDecrease(nValue);   // Penalties for being stuck in a dense cloud...
    	       eHeld = EffectLinkEffects(eHeld, EffectBlasterDeflectionDecrease(nValue));
    	       eHeld = EffectLinkEffects(eHeld, EffectAttackDecrease(nValue));
    	       eHeld = EffectLinkEffects(eHeld, EffectSavingThrowDecrease(SAVING_THROW_ALL, nValue));
    	       eHeld = EffectLinkEffects(eHeld, EffectBlind());
    	       eHeld = EffectLinkEffects(eHeld, EffectSpellImmunity(FORCE_POWER_FORCE_PUSH));
    	       eHeld = EffectLinkEffects(eHeld, EffectSpellImmunity(FORCE_POWER_FORCE_WHIRLWIND));
    	       eHeld = EffectLinkEffects(eHeld, EffectSpellImmunity(FORCE_POWER_FORCE_WAVE));
    	       eHeld = SetEffectIcon(eHeld, JD_HOLD_IMP_EFFECT);  // ST: Update with correct row in effecticon.2da.
    	       
    	effect eVis1 = EffectVisualEffect(9014);
    	effect eVis2 = EffectVisualEffect(9013);
    	effect eVis3 = EffectVisualEffect(VFX_PRO_DRAIN);
    	
    	// Remove any old effects if the power is Re-cast while already active
    	// on a target...
    	JD_RemoveRelatedPowers( oTarget, JD_HOLD_IMP );
    	SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));
    	
    	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVis1, lLoc);
    	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVis2, lLoc);
    	ApplyEffectToObject(  DURATION_TYPE_INSTANT, eVis3, oTarget);
    	
    	if( !JD_BetterRelatedPowerExists( oTarget, JD_HOLD_IMP ) ) {
            JD_RemoveRelatedPowers( oTarget, JD_HOLD_IMP );
            JD_SignalPartyEvent( GetFirstPC(), JD_HOLD_IMP );
		JD_SignalEnemyEvent( oTarget );
    		ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eGlue, oTarget, fDur);
    		ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eHeld, oTarget, fDur);
    	}
    	    	
    	int i;    	
    	int nDur = FloatToInt(fDur);
    	
    	// Maintain the effects of the power while it is active...
    	for (i = 0; i < nDur; i += 4) {
    		float fD = IntToFloat(i);
    		
    		if (i <= (nDur - 4))
    		    DelayCommand(fD, SpawnGasCloud(oTarget, 4.0));
    		
    		// ST: Added Knockdown substitution function...
    		DelayCommand(((fD - 0.1) > 0.0 ? fD - 0.1 : 0.0), ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis3, oTarget));
    		DelayCommand(fD, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ST_SubKnockDown(oTarget, eFall), oTarget, 3.0));    		
    	}
	}
}