{
	object oTarget 	= GetSpellTargetObject();
    int nDice 		= (GetHitDice(OBJECT_SELF)*6);
    float fDur		= JD_CalcDuration( OBJECT_SELF, 24.0 );

	effect eHover = EffectWhirlWind();
	       eHover = EffectLinkEffects(eHover, EffectEntangle());
	       eHover = SetEffectIcon(eHover, JD_INFERNO_MSTR_EFFECT); // ST: Update to use proper effecticon.2da line
	       
	effect eBurn  = EffectDamage(JD_CalcDamage( OBJECT_SELF, 0, 0, nDice ), DAMAGE_TYPE_FIRE);
		   eBurn  = EffectLinkEffects(eBurn, EffectVisualEffect(1039));
	effect eFlame = EffectVisualEffect(2062);

	// Only one cast of this power can affect a target at a time.
	if (GetHasSpellEffect(GetSpellId(), oTarget)) {
		SendMessageToPC(OBJECT_SELF, "Force Incinerate does not stack for a single target.");
		effect eRestore = EffectHealForcePoints(GetSpellForcePointCost());
		ApplyEffectToObject(DURATION_TYPE_INSTANT, eRestore, OBJECT_SELF);
		ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectForceFizzle(), OBJECT_SELF);
		return;		
	}
    
    // Successful saving throw cuts the duration in half...
    int nDcMod          = 0;
    int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
    int nSaves          = FortitudeSave(oTarget, nDifficulty, SAVING_THROW_TYPE_FIRE);
    if (nSaves > 0) {
    	fDur /= 2;	
    }
    JD_ForcePowerCost( OBJECT_SELF, GetSpellId(), FALSE);	    
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), TRUE));
    
    // FIX - ID must start at 1, or unset objects might get deleted. Not good.
	int i;
	int nRnd = Random(99) + 1; 
	int nBeams = 3;
	float fAngleInc = 360.0 / nBeams;
	float fAngle = 0.0;	
	vector loc;
	effect eBeam = EffectBeam(VFX_BEAM_FLAME_SPRAY, oTarget, BODY_NODE_CHEST);
	
	for (i = 0; i < nBeams; i++) {
		loc = GetPosition(oTarget);
		loc.x += cos(fAngle) * 4.5; 
		loc.y += sin(fAngle) * 4.5; 
		loc.z -= 0.25;

		object oInv = CreateObject(OBJECT_TYPE_PLACEABLE, "plc_invisible", Location(loc, (fAngle - 180.0)));
		SetLocalNumber(oInv, 1, nRnd);
		
		float fDelay = IntToFloat(i) / 5.0;
		DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam, oInv, fDur - fDelay));
		AssignCommand(oInv, DestroyObject(oInv, fDur-1.0, TRUE));
		
		fAngle += fAngleInc;
		if (fAngle > 360.0)
			fAngle = fAngle - 360.0;
	} 
	
	// The beam coming from the sky...
	loc = GetPosition(oTarget);
	loc.z += 10.0;
	object oInv = CreateObject(OBJECT_TYPE_PLACEABLE, "plc_invisible", Location(loc, (fAngle - 180.0))); 
	SetLocalNumber(oInv, 1, nRnd);
	DelayCommand(0.6, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam, oInv, fDur - 0.6));
	AssignCommand(oInv, DestroyObject(oInv, fDur-1.0, TRUE));	
	
	// Remove the beams and beam targets if the victim dies...
	RemoveBeamsPoller(oTarget, nRnd, fDur);
	
    	if( !JD_BetterRelatedPowerExists( oTarget, JD_INFERNO_MSTR ) ) {
		JD_RemoveRelatedPowers( oTarget, JD_INFERNO_MSTR );
            JD_SignalPartyEvent( GetFirstPC(), JD_INFERNO_MSTR );
		JD_SignalEnemyEvent( oTarget );
		ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eHover, oTarget, fDur);  
		ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eFlame, oTarget, fDur);
    	}
	
	// Apply the damage once every 2 seconds for the duration....
	int nDur = FloatToInt(fDur);
	for (i = 0; i < nDur; i += 2) {
		DelayCommand(IntToFloat(i), ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eBurn, oTarget)); 	
	}
}