{
	object oTarget = GetSpellTargetObject();
	float  fDur    = JD_CalcDuration( OBJECT_SELF, 90.0 );
	int    nMod    = JD_CalcBuffBonus( OBJECT_SELF, 9  );
	int    nSpeed  = 50;
	
	if (!GetIsEnemy(oTarget))
		return;
	
	// If the target is immune to ability drain, the power fizzles....
	effect eTest = EffectAbilityDecrease(ABILITY_STRENGTH, 4);
	if (GetIsLinkImmune(oTarget, eTest) || GetIsImmune(oTarget, IMMUNITY_TYPE_ABILITY_DECREASE)) {
		DisplayFeedBackText(oTarget, 1);
		ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectForceResisted(OBJECT_SELF), oTarget);
		ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectForceFizzle(), OBJECT_SELF);
		return;
	}
	
	// Lessen the effects somewhat if target makes a Will save.
      int nDcMod          = 0;
      int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
      int nSaves          = WillSave(oTarget, nDifficulty);
	if (nSaves > 0) {
		nMod = nMod/2;	
		nSpeed = nSpeed/2;
	}
	
	// Penalties applied to victim.
	effect eDrain = EffectMovementSpeedDecrease(99 - nSpeed);
	       eDrain = EffectLinkEffects(eDrain, EffectAbilityDecrease(ABILITY_STRENGTH, nMod));
	       eDrain = EffectLinkEffects(eDrain, EffectAbilityDecrease(ABILITY_DEXTERITY, nMod));
	       eDrain = EffectLinkEffects(eDrain, EffectAbilityDecrease(ABILITY_CONSTITUTION, nMod));
	       eDrain = EffectLinkEffects(eDrain, EffectAbilityDecrease(ABILITY_INTELLIGENCE, nMod));
	       eDrain = EffectLinkEffects(eDrain, EffectAbilityDecrease(ABILITY_WISDOM, nMod));
	       eDrain = EffectLinkEffects(eDrain, EffectAbilityDecrease(ABILITY_CHARISMA, nMod));
	       eDrain = SetEffectIcon(eDrain, JD_BAD_LEECH_MSTR_EFFECT);
	
	// Matching bonuses applied to caster.
	effect eGain =	EffectMovementSpeedIncrease(100 + nSpeed);
	       eGain = EffectLinkEffects(eGain, EffectAbilityIncrease(ABILITY_STRENGTH, nMod));
	       eGain = EffectLinkEffects(eGain, EffectAbilityIncrease(ABILITY_DEXTERITY, nMod));
	       eGain = EffectLinkEffects(eGain, EffectAbilityIncrease(ABILITY_CONSTITUTION, nMod));
	       eGain = EffectLinkEffects(eGain, EffectAbilityIncrease(ABILITY_INTELLIGENCE, nMod));
	       eGain = EffectLinkEffects(eGain, EffectAbilityIncrease(ABILITY_WISDOM, nMod));
	       eGain = EffectLinkEffects(eGain, EffectAbilityIncrease(ABILITY_CHARISMA, nMod));
	       eGain = SetEffectIcon(eGain, JD_GOOD_LEECH_MSTR_EFFECT);
	 
	// Other needed effects, mostly visual.
	effect eOuch  = EffectCutSceneHorrified();       
	effect eBeamL = EffectBeam(VFX_BEAM_STUN_RAY, OBJECT_SELF, BODY_NODE_HAND_LEFT);
	effect eBeamR = EffectBeam(VFX_BEAM_STUN_RAY, OBJECT_SELF, BODY_NODE_HAND_RIGHT);
	effect eVisE  = EffectVisualEffect(VFX_PRO_DEATH_FIELD);
	effect eVisG  = EffectVisualEffect(VFX_PRO_RESIST_POISON);
	      
	// Remove previous effects from both target and caster. This can only be
	// active once for each creature, either as a target and as caster. 
	
      JD_ForcePowerCost( OBJECT_SELF, GetSpellId(), FALSE);		
    	if( !JD_BetterRelatedPowerExists( oTarget, JD_LEECH_MSTR ) ) {
            JD_RemoveRelatedPowers(oTarget, GetSpellId());
            JD_SignalEnemyEvent( oTarget );
            JD_SignalPartyEvent( GetFirstPC(), JD_LEECH_MSTR );
		ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOuch, oTarget, 2.0);
		DelayCommand(0.2, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeamL, oTarget, 1.6));
		DelayCommand(0.2, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeamR, oTarget, 1.6));
		DelayCommand(0.5, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eVisE, oTarget));
		DelayCommand(1.0, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eVisE, oTarget));
		DelayCommand(0.5, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDrain, oTarget, fDur));
    	}

            int nCnt = 0;

            object oParty;
            if(IsObjectPartyMember(OBJECT_SELF))
            {
                oParty = GetPartyMemberByIndex(nCnt);
            }
            else
            {
                oParty = OBJECT_SELF;
            }

            while(nCnt < 3)
            {
		    if( GetIsObjectValid(oParty) )
                {
                	if( !JD_BetterRelatedPowerExists( oParty, JD_LEECH_MSTR ) && !GetIsDead(oParty) ) {
				JD_RemoveRelatedPowers( oParty, JD_LEECH_MSTR );
            		JD_SignalPartyEvent( GetFirstPC(), JD_LEECH_MSTR );
				DelayCommand(0.5, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVisG, oParty));
				DelayCommand(0.5, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eGain, oParty, fDur));
                  }
                }
                nCnt++;
                if(IsObjectPartyMember(OBJECT_SELF))
                {
                   oParty = GetPartyMemberByIndex(nCnt);
                }
                else
                {
                   oParty = GetNearestCreature(CREATURE_TYPE_REPUTATION, REPUTATION_TYPE_FRIEND, OBJECT_SELF, nCnt);
                }
            }
}