{
	object   oTarget  = GetSpellTargetObject();
	location lTarget  = GetLocation(oTarget);
	vector   vDummy   = GetPositionFromLocation(lTarget);	
	float 	 fDur	  = JD_CalcDuration( OBJECT_SELF, 30.0 );
	int      nSpellId = GetSpellId();
      JD_ForcePowerCost( OBJECT_SELF, GetSpellId(), FALSE);	
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		
	// The Domination effect	
	effect   eDomi    = EffectFactionModifier(IsObjectPartyMember(OBJECT_SELF) ? STANDARD_FACTION_FRIENDLY_1 : GetStandardFaction(OBJECT_SELF));
	         eDomi	  = EffectLinkEffects(eDomi, EffectVisualEffect(9009));
	         eDomi    = SetEffectIcon(eDomi, JD_STATIC_MSTR_EFFECT );
	 
	// The Stun effect        
	effect   eStun    = EffectDroidStun();
	         eStun    = EffectLinkEffects(eStun, EffectVisualEffect(1008));
	         eStun    = SetEffectIcon(eStun, JD_STATIC_MSTR_EFFECT );
	     
	// The Scramble effect    
	effect   eConf    = EffectDroidScramble();
	         eConf    = EffectLinkEffects(eConf, EffectVisualEffect(VFX_IMP_SUPPRESS_FORCE));
	         eConf    = SetEffectIcon(eConf, JD_STATIC_MSTR_EFFECT );
	
	effect   eDamage;
	         eDamage  = EffectLinkEffects(eDamage, EffectVisualEffect(VFX_PRO_LIGHTNING_L));
	
	effect   eBeam1   = EffectBeam(VFX_BEAM_DEATH_FIELD_TENTACLE, OBJECT_SELF, BODY_NODE_HAND_LEFT);
	
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	vDummy.z += 2.8;
	int nCnt = 0;	
	object oDummy = CreateObject(OBJECT_TYPE_PLACEABLE, "plc_invisible", Location(vDummy, GetFacingFromLocation(lTarget)));
	object oVictim = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_GARGANTUAN, lTarget);
	AssignCommand(oDummy, DestroyObject(oDummy, 2.0, TRUE));
	
	// Mess up all electrical opponents within range.
	while (GetIsObjectValid(oVictim)) {
		if ((GetRacialType(oTarget) == RACIAL_TYPE_DROID) && GetIsEnemy(oVictim)) {
	    	   if( !JD_BetterRelatedPowerExists( oVictim, JD_STATIC_MSTR ) ) {
			JD_RemoveRelatedPowers( oVictim, JD_STATIC_MSTR );
			float fD = FMin(GetDistanceBetweenLocations2D(lTarget, GetLocation(oVictim)) / 9.0, 0.6);
			float fMyDur = fDur;
			eDamage  = EffectDamage(JD_CalcDamage( OBJECT_SELF, 0, 0, GetHitDice(OBJECT_SELF) * 2 ), DAMAGE_TYPE_ELECTRICAL);

			JD_SignalPartyEvent( GetFirstPC(), JD_STATIC_MSTR );
			JD_SignalEnemyEvent( oVictim );

			effect eBeam2 = EffectBeam(VFX_BEAM_DEATH_FIELD_TENTACLE, oVictim, BODY_NODE_CHEST);
			ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam2, oDummy, 1.2);
			
			// Saving throw halves duration.
                  int nDcMod          = 0;
                  int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
                  int nSaves          = WillSave(oVictim, nDifficulty);
			if (nSaves > 0)
				fMyDur *= 0.5;
			
			// Randomly pick an effect to apply to this target.
			switch (Random(3)) {
				case 0: // Domination
					DelayCommand(fD,     ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oVictim));
					DelayCommand(fD+0.2, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDomi, oVictim, fMyDur));
				break;	
								
				case 1: // Stun
					DelayCommand(fD,     ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oVictim));
					DelayCommand(fD+0.2, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStun, oVictim, fMyDur));				
				break;
				
				case 2: // Scramble (Droid Trick)
					DelayCommand(fD,     ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oVictim));
					DelayCommand(fD+0.2, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eConf, oVictim, fMyDur));
				break;				
			}
   		   }
			nCnt++;
		}
		oVictim = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_GARGANTUAN, lTarget);
	}
	
	// Only shoot beams if any targets were affected.
	if (nCnt > 0) {
		// Shoot first beam over the head of the selected target.
		ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectVisualEffect(VFX_PRO_DEATH_FIELD), oDummy);	
		ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam1, oDummy, 1.2);
		
		// Some random electric-ish beams criscrossing the ground...
		int i;
		vector vRnd;
		object oCurr = OBJECT_INVALID;
		object oLast = OBJECT_INVALID;
		for (i = 0; i < 8; i++) {
			vRnd = (GetPositionFromLocation(lTarget) + AngleToVector(IntToFloat(Random(360))) * FMax(IntToFloat(Random(9)), 2.0));
			vRnd.z -= 0.15;
			oCurr = CreateObject(OBJECT_TYPE_PLACEABLE, "plc_invisible", Location(vRnd, 0.0));
			if (GetIsObjectValid(oCurr) && GetIsObjectValid(oLast)) {
				AssignCommand(oCurr, DestroyObject(oCurr, 2.0, TRUE));	
				eBeam1 = EffectBeam(VFX_BEAM_DROID_DISABLE, oCurr, BODY_NODE_HAND_LEFT);
				DelayCommand(IntToFloat(i) / 4.8, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam1, oLast, 0.65));
				
			}	
			oLast = oCurr;				
		}
		
	}
	else {
		// Fizzle if there are no valid targets.
		ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectForceFizzle(), OBJECT_SELF);
	}
}

