{
	object oTarget 		= GetSpellTargetObject();
	location lLoc 		= GetLocation(oTarget);
    int nDice 			= GetHitDice(OBJECT_SELF);
    int nDamage			= JD_CalcDamage(oTarget, nDice, 4, 0);
    effect eDamage      = EffectDamage(nDamage, DAMAGE_TYPE_ACID);
    effect eKnockdown	= EffectKnockdown();
    effect eVis 		= EffectVisualEffect(VFX_PRO_LIGHTNING_L);
    JD_ForcePowerCost( OBJECT_SELF, GetSpellId(), FALSE);	    
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), TRUE));
        
	int i;
	int nBeams = 6;
	float fAngleInc = 360.0 / nBeams;
	float fAngle = 0.0;	
	vector loc;
	effect eBeam = EffectBeam(VFX_BEAM_LIGHTNING_DARK_L, oTarget, BODY_NODE_CHEST);
	
	for (i = 0; i < nBeams; i++) {
		loc = GetPosition(oTarget);
		loc.x += cos(fAngle) * 5.5; 
		loc.y += sin(fAngle) * 5.5; 
		loc.z += 12.0;

		object oInv = CreateObject(OBJECT_TYPE_PLACEABLE, "plc_invisible", Location(loc, (fAngle - 180.0)));
		ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam, oInv, 1.6);
		AssignCommand(oInv, DestroyObject(oInv, 2.0, TRUE));
		
		fAngle += fAngleInc;
		if (fAngle > 360.0)
			fAngle = fAngle - 360.0;
	}
	
    	if( !JD_BetterRelatedPowerExists( oTarget, JD_STRIKE_IMP ) ) {
		JD_RemoveRelatedPowers( oTarget, JD_STRIKE_IMP );
            JD_SignalPartyEvent( GetFirstPC(), JD_STRIKE_IMP );
		JD_SignalEnemyEvent( oTarget );  
		DelayCommand(0.1, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget));
		DelayCommand(0.2, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget));
		DelayCommand(0.25, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ST_SubKnockDown(oTarget, eKnockdown), oTarget, 4.0));
   	}
	
	// Push away any other nearby enemies by the force of the impact....
	effect ePushy = EffectForcePushTargeted(lLoc);	
	effect eWave  = EffectVisualEffect(3007);
	object oNear = GetFirstObjectInShape(SHAPE_SPHERE, 4.0, lLoc);

	while (GetIsObjectValid(oNear)) {
		if (!GetIsNeutral(oNear) && (oNear != oTarget) && (oNear != OBJECT_SELF)) {
			JD_SignalEnemyEvent( oNear );
			DelayCommand(0.1, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ePushy, oNear, 0.1));
		}
		oNear = GetNextObjectInShape(SHAPE_SPHERE, 4.0, lLoc);	
	}
	
	// Show an impact explosion effect where the bolts hit...
	DelayCommand(0.3, ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eWave, lLoc));
    
}
