{
	object oTarget 	= GetSpellTargetObject();
	location lLoc 	= GetLocation(oTarget);
    float fDuration     = JD_CalcDuration( OBJECT_SELF, 10.0 );
    int nDivisor	 	= 4;
    int nDamage		= (GetMaxHitPoints(oTarget) / nDivisor);
    int nWeaken		= JD_CalcBuffBonus( OBJECT_SELF, 6 );
    int nDcMod          = 0;
    int nDifficulty     = JD_GetSaveDC(OBJECT_SELF, nDcMod);
    int nSaves          = FortitudeSave(oTarget, nDifficulty);
    if (nSaves > 0) {
        nDamage = nDamage / 2;
        nWeaken = nWeaken / 2;
    }
    /*I put this in because the game turns any damage over 10000 into 1 damage */
    int nMax = 10000;
    if(nDamage > nMax){
        nDamage = nMax;
    } 
    if (GetLocalBoolean( oTarget, 150 ) != FALSE) {
        if(OBJECT_SELF == GetFirstPC() ){ 
           DisplayMessageBox(IMPROVED_WEAKEN_MESSAGE, "jd_weaken_imp");
        }
	  effect eRestore = EffectHealForcePoints(GetSpellForcePointCost());
	  ApplyEffectToObject(DURATION_TYPE_INSTANT, eRestore, OBJECT_SELF);
	  ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectForceFizzle(), OBJECT_SELF);
	  return;	
    }
    JD_ForcePowerCost( OBJECT_SELF, GetSpellId(), FALSE);    
    effect eDamage = EffectDamage(nDamage, DAMAGE_TYPE_DARK_SIDE);
    effect eStop   = EffectEntangle();
    effect eOuch   = EffectCrush();
    effect eVis	   = EffectVisualEffect(VFX_PRO_DEATH_FIELD);
    effect eWeaken = EffectAttackDecrease(nWeaken);
           eWeaken = EffectLinkEffects(eWeaken, EffectACDecrease(nWeaken));
           eWeaken = EffectLinkEffects(eWeaken, EffectSavingThrowDecrease(SAVING_THROW_ALL, nWeaken));
           eWeaken = EffectLinkEffects(eWeaken, EffectMovementSpeedDecrease(50));
           eWeaken = EffectLinkEffects(eWeaken, EffectBlasterDeflectionDecrease(nWeaken));
           eWeaken = SetEffectIcon(eWeaken, JD_WEAKEN_IMP_EFFECT );  // ST: Update with correct row in effecticon.2da.
    
    JD_RemoveRelatedPowers( oTarget, GetSpellId());
    
	int i;
	int nBeams = 6;
	float fAngleInc = 360.0 / nBeams;
	float fAngle = 0.0;	
	vector loc;
	effect eBeam = EffectBeam(VFX_BEAM_DROID_DESTROY, oTarget, BODY_NODE_CHEST);
	
	for (i = 0; i < nBeams; i++) {
		loc = GetPosition(oTarget);
		loc.x += cos(fAngle) * 4.5; 
		loc.y += sin(fAngle) * 4.5; 
		loc.z -= 0.25;

		object oInv = CreateObject(OBJECT_TYPE_PLACEABLE, "plc_invisible", Location(loc, (fAngle - 180.0)));
		
		ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam, oInv, 1.6);
		AssignCommand(oInv, DestroyObject(oInv, 1.6, TRUE));
		
		fAngle += fAngleInc;
		if (fAngle > 360.0)
			fAngle = fAngle - 360.0;
	}
	
    	if( !JD_BetterRelatedPowerExists( oTarget, JD_WEAKEN_IMP ) ) {
		JD_RemoveRelatedPowers( oTarget, JD_WEAKEN_IMP );
		JD_SignalEnemyEvent( oTarget );
            JD_SignalPartyEvent( GetFirstPC(), JD_WEAKEN_IMP );
		ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStop, oTarget, 1.8);
		    DelayCommand(0.3, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, oTarget, 1.6));
		    DelayCommand(0.2, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOuch, oTarget, 1.6));    
		    DelayCommand(1.0, ST_ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget));
		    DelayCommand(1.0, ST_ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eWeaken, oTarget, fDuration));
            SetLocalBoolean( oTarget, 150, TRUE );
            DelayCommand(120.0, SetLocalBoolean( oTarget, 150, FALSE ));
   	}
    
}